import { h } from "@stencil/core";
export class TooltipComponent {
    constructor() {
        this.position = 'bottom';
    }
    showTooltip(event) {
        event.target.nextElementSibling.style.display = 'inline';
    }
    hideTooltip(event) {
        event.target.nextElementSibling.style.display = 'none';
    }
    render() {
        return (h("div", { key: 'e1e79618ab71eee4c2cf48c4b2c288a6a19895dc', class: "tooltip-container", part: "tc__container" }, h("span", { key: 'ebd9f3bf846599bde4cc1803059df26d035e6a02', class: "info-icon", tabindex: "0", onFocus: this.showTooltip.bind(this), onBlur: this.hideTooltip.bind(this) }, h("slot", { key: 'aaeb3fcf449c6de602c2033460636746ad649305', name: "tooltip-icon" }, "i")), h("span", { key: '0d2b40ad53708491581286f66e38417623df1755', class: `tooltip-content ${this.position}`, part: "tc__content" }, h("slot", { key: '9a982f400b4837edfcd8865963b8afa53e056db6', name: "tooltip-content" }, "This is a help text."))));
    }
    static get is() { return "tooltip-component"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() {
        return {
            "$": ["tooltip-component.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["tooltip-component.css"]
        };
    }
    static get properties() {
        return {
            "position": {
                "type": "string",
                "mutable": false,
                "complexType": {
                    "original": "'top' | 'bottom' | 'left' | 'right'",
                    "resolved": "\"bottom\" | \"left\" | \"right\" | \"top\"",
                    "references": {}
                },
                "required": false,
                "optional": false,
                "docs": {
                    "tags": [],
                    "text": "The position of the tooltip."
                },
                "attribute": "position",
                "reflect": false,
                "defaultValue": "'bottom'"
            }
        };
    }
    static get elementRef() { return "el"; }
}
//# sourceMappingURL=toolitp-component.js.map
