import { newSpecPage } from "@stencil/core/testing";
import { NylasBookingConfirmationType } from "../nylas-booking-confirmation-type";
import { selectedConfiguration } from "../../../../utils/test-utils";
import { h } from "@stencil/core";
import { SelectDropdown } from "../../../design-system/select-dropdown/select-dropdown";
jest.mock('@/utils/i18n', () => ({
    t: (_key, _options) => '',
    changeLanguage: (_lng) => Promise.resolve(),
    language: 'en',
    exists: (_key) => true,
}));
describe('nylas-booking-confirmation-type', () => {
    it('should render the dropdown', async () => {
        const page = await newSpecPage({
            components: [NylasBookingConfirmationType, SelectDropdown],
            template: () => {
                return h("nylas-booking-confirmation-type", { selectedConfiguration: selectedConfiguration, name: "booking-confirmation-type" });
            },
        });
        await page.waitForChanges();
        expect(page.root).toMatchSnapshot();
    });
});
//# sourceMappingURL=nylas-booking-confirmation-type.spec.js.map
