import { Fragment, h } from "@stencil/core";
import { CONFIGURATION_EVENT_TYPE } from "../../../common/constants";
export default function ExpressFlow({ currentUser, calendars, selectedEventType }) {
    const defaultCalendarOption = calendars?.find(c => c.is_primary) || calendars?.[0];
    switch (selectedEventType) {
        case CONFIGURATION_EVENT_TYPE.one_on_one:
        case CONFIGURATION_EVENT_TYPE.max_availability:
        case CONFIGURATION_EVENT_TYPE.max_fairness: {
            return (h(Fragment, null, h("nylas-event-info", null, h("div", { slot: "inputs" }, h("nylas-event-title", null), h("nylas-event-duration", null), h("nylas-event-location", { userProvider: currentUser.provider }))), h("nylas-booking-calendar-picker", { exportparts: "nbcp, nbcp__header, nbcp__dropdown, nbcp__dropdown-button, nbcp__dropdown-content", expressFlow: true, calendars: calendars, currentUser: currentUser, defaultBookingCalendar: defaultCalendarOption?.id }), h("nylas-custom-event-slug", { name: "custom-event-slug", exportparts: "nces, nces__body, nces__header, nces__drawer-toggle--container, nces__input-textfield" })));
        }
        case CONFIGURATION_EVENT_TYPE.collective: {
            return (h(Fragment, null, h("nylas-event-info", null, h("div", { slot: "inputs" }, h("nylas-event-title", null), h("nylas-event-duration", null), h("nylas-event-location", { userProvider: currentUser.provider }))), h("nylas-booking-calendar-picker", { exportparts: "nbcp, nbcp__header, nbcp__dropdown, nbcp__dropdown-button, nbcp__dropdown-content", expressFlow: true, calendars: calendars, currentUser: currentUser, defaultBookingCalendar: defaultCalendarOption?.id }), h("nylas-custom-event-slug", { name: "custom-event-slug", exportparts: "nces, nces__body, nces__header, nces__drawer-toggle--container, nces__input-textfield" }), h("nylas-additional-participants", { name: "participants", eventParticipants: [{ name: currentUser?.name || currentUser?.email, email: currentUser?.email || '', is_organizer: true }], exportparts: "nadtnlpart, nadtnlpart__title, nadtnlpart__subtitle, nadtnlpart__content, nadtnlpart__input_group, nadtnlpart__input_wrapper, nadtnlpart__input, nadtnlpart__remove-participant" })));
        }
        case CONFIGURATION_EVENT_TYPE.group: {
            return (h(Fragment, null, h("nylas-event-info", null, h("div", { slot: "inputs" }, h("nylas-event-title", { noTemplates: true }), h("nylas-event-description", { noTemplates: true, hideAutoPopulateButton: true }), h("nylas-event-location", { userProvider: currentUser.provider }), h("nylas-event-timeslot", { name: "event-timeslot" }), h("nylas-event-capacity", null))), h("nylas-booking-calendar-picker", { exportparts: "nbcp, nbcp__header, nbcp__dropdown, nbcp__dropdown-button, nbcp__dropdown-content", expressFlow: true, calendars: calendars, currentUser: currentUser, defaultBookingCalendar: defaultCalendarOption?.id }), h("nylas-additional-participants", { name: "participants", eventParticipants: [{ name: currentUser?.name || currentUser?.email, email: currentUser?.email || '', is_organizer: true }], exportparts: "nadtnlpart, nadtnlpart__title, nadtnlpart__subtitle, nadtnlpart__content, nadtnlpart__input_group, nadtnlpart__input_wrapper, nadtnlpart__input, nadtnlpart__remove-participant" }), h("nylas-page-name", { requirePageName: true, pageName: "Group events page" }), h("nylas-custom-event-slug", { name: "custom-event-slug", exportparts: "nces, nces__body, nces__header, nces__drawer-toggle--container, nces__input-textfield" })));
        }
    }
}
//# sourceMappingURL=ExpressFlow.js.map
