import { h } from "@stencil/core";
export const LoginRequired = ({ authenticationUrl }) => (h("div", { class: 'login-required', part: "nse__login-required login-component" }, h("div", { class: 'card', part: "nse__login-required-card" }, h("p", { part: "nse__login-required-text" }, "Log into your account to use the Scheduler Editor."), h("button", { class: "google-button", part: "nse__login-required-google-button", onClick: async (event) => {
        event.preventDefault();
        const authUrl = await authenticationUrl('google');
        if (authUrl) {
            window.location.href = authUrl;
        }
        else {
            console.error(`[nylas-scheduler-editor] Unable to get authentication URL.`);
        }
    } }, h("span", { class: "icon" }, h("google-logo-icon", { width: "15", height: "15" })), "Continue with Google"), h("button", { class: "microsoft-button", part: "nse__login-required-microsoft-button", onClick: async (event) => {
        event.preventDefault();
        const authUrl = await authenticationUrl('microsoft');
        if (authUrl) {
            window.location.href = authUrl;
        }
        else {
            console.error(`[nylas-scheduler-editor] Unable to get authentication URL.`);
        }
    } }, h("span", { class: "icon" }, h("microsoft-logo-icon", { width: "15", height: "15" })), "Continue with Microsoft"), h("button", { class: "other-provider-button", part: "nse__login-required-other-provider-button", onClick: async (event) => {
        event.preventDefault();
        const authUrl = await authenticationUrl();
        if (authUrl) {
            window.location.href = authUrl;
        }
        else {
            console.error(`[nylas-scheduler-editor] Unable to get authentication URL.`);
        }
    } }, "View all providers ", h("chevron-icon", { width: "17", height: "17" })), h("small", { class: "disclaimer-text", part: "nse__login-required-disclaimer-text" }, "* You will be redirected to authenticate your account."))));
//# sourceMappingURL=LoginRequired.js.map
