var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
import { RegisterComponent } from "../../../common/register-component";
import { h, Host } from "@stencil/core";
import { debug } from "../../../utils/utils";
import i18next from "../../../utils/i18n";
export class NylasFeedbackForm {
    constructor() {
        this.handleConfirmBookingButtonClicked = () => {
            const validationEvent = this.triggerValidation.emit();
            if (validationEvent.defaultPrevented) {
                return;
            }
            this.feedbackSubmitted.emit({ feedback: this.feedbackMessage });
        };
        this.themeConfig = undefined;
        this.feedbackMessage = '';
    }
    connectedCallback() { }
    disconnectedCallback() { }
    async componentWillLoad() {
        debug(`[nylas-feedback-form] Component will load`);
    }
    async componentDidLoad() {
        debug(`[nylas-feedback-form] Component did load`);
        this.applyThemeConfig(this.themeConfig);
    }
    applyThemeConfig(themeConfig) {
        if (themeConfig) {
            for (const [key, value] of Object.entries(themeConfig)) {
                this.host.style.setProperty(`${key}`, value);
            }
        }
    }
    handleFormInputChanged(event) {
        debug(`[nylas-feedback-form] Form input changed`);
        if (!event.detail.value) {
            return;
        }
        this.triggerValidation.emit();
        if (event.detail.name === 'feedback') {
            this.feedbackMessage = event.detail.value;
        }
    }
    closeModal(e) {
        e.preventDefault();
        e.stopImmediatePropagation();
        this.feedbackModalClosed.emit();
    }
    render() {
        return (h(Host, { key: '3dfba1b006f09a9ac9ccdd03a659784b86df25d4', part: "nfbf" }, h("div", { key: 'f548f82b9689115b254815c0a6b940d1450ada04', class: "card-wrapper", part: "nfbfc__card" }, h("div", { key: '3e1be6b2ff7d6818b677f09772cde78edb4c7ef1', class: "close-button" }, h("button-component", { key: 'dd98523ad84cc745f24daa400bb41753d103c3c6', tooltip: "Close", id: "close", variant: 'invisible', onClick: e => this.closeModal(e), part: "nfbf__close-button" }, h("close-icon", { key: '0b919c2be114e231ff8eb7121536b6c24dfb7158' }))), h("div", { key: '2c62e429a6871d1dc6a34df4fc37440e61e9e041', class: "header" }, h("h2", { key: '8c1009dc5a853bb0cbc21b64958353c95a0ca140', slot: "card-title", part: "nfbf__title" }, i18next.t('feedbackFormTitle'))), h("div", { key: 'b16e5a7c0e3b299d6ee9a74d154aa3628e9d4d25', class: "description title-desc" }, h("p", { key: '00675ebd52e88ed101df5710b3bded1f6424c274' }, i18next.t('feedbackFormDescription'))), h("textarea-component", { key: '7b021701b44eb5b3ba02ee3191d3866489f4ec8a', label: i18next.t('feedbackMessageLabel'), required: true, maxLength: 500, part: "nfbf__description", name: "feedback", placeholder: i18next.t('feedbackMessagePlaceholder') }), h("div", { key: 'def91af529f167b1fac0cc078f79cec67b961a1a', class: 'description footer-desc' }, h("p", { key: 'ad346ef93ae4a25fd5478284ff5415eb62b54f26' }, "By sending this report, you agree to Nylas\u2019 access to the data necessary to respond to this issue, subject to Nylas\u2019", ' ', h("a", { key: 'cd6a79cf548346d92d04264c4ff7244a032c3977', href: "https://www.nylas.com/privacy-policy/", target: "_blank", rel: "nofollow noreferrer noopener" }, "Privacy Policy"), ".")), h("div", { key: '5dfee1045b6711f5cf7d15009c86c0fd9b76b137', class: {
                footer: true,
            } }, h("button-component", { key: '45894bd04b89365c83d7e2a07e8a62ee7c94b6c0', variant: 'invisible', onClick: e => this.closeModal(e), part: "nfbf__button-outline nfbf__cancel-cta" }, `${i18next.t('feedbackModalCloseButton')}`), h("button-component", { key: 'ac586974014c3e3b6b454a8b830585b76bc1f290', variant: 'primary', onClick: this.handleConfirmBookingButtonClicked, part: "nfbf__button-outline nfbf__reschedule-cta" }, `${i18next.t('feedbackModalSubmitButton')}`)))));
    }
    static get is() { return "nylas-feedback-form"; }
    static get encapsulation() { return "shadow"; }
    static get originalStyleUrls() {
        return {
            "$": ["nylas-feedback-form.scss"]
        };
    }
    static get styleUrls() {
        return {
            "$": ["nylas-feedback-form.css"]
        };
    }
    static get properties() {
        return {
            "themeConfig": {
                "type": "any",
                "mutable": false,
                "complexType": {
                    "original": "any",
                    "resolved": "any",
                    "references": {}
                },
                "required": false,
                "optional": true,
                "docs": {
                    "tags": [{
                            "name": "standalone",
                            "text": "The theme configuration."
                        }],
                    "text": ""
                },
                "attribute": "theme-config",
                "reflect": false
            }
        };
    }
    static get states() {
        return {
            "feedbackMessage": {}
        };
    }
    static get events() {
        return [{
                "method": "feedbackModalClosed",
                "name": "feedbackModalClosed",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "Feedback modal close event."
                },
                "complexType": {
                    "original": "void",
                    "resolved": "void",
                    "references": {}
                }
            }, {
                "method": "feedbackSubmitted",
                "name": "feedbackSubmitted",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "Feedback submitted event."
                },
                "complexType": {
                    "original": "{ feedback: string }",
                    "resolved": "{ feedback: string; }",
                    "references": {}
                }
            }, {
                "method": "triggerValidation",
                "name": "triggerValidation",
                "bubbles": true,
                "cancelable": true,
                "composed": true,
                "docs": {
                    "tags": [],
                    "text": "This is an internal event that is used to trigger validation on the form."
                },
                "complexType": {
                    "original": "void",
                    "resolved": "void",
                    "references": {}
                }
            }];
    }
    static get elementRef() { return "host"; }
    static get listeners() {
        return [{
                "name": "nylasFormInputChanged",
                "method": "handleFormInputChanged",
                "target": "document",
                "capture": false,
                "passive": false
            }];
    }
}
__decorate([
    RegisterComponent({
        name: 'nylas-feedback-form',
        stateToProps: new Map([]),
        eventToProps: {
            feedbackSubmitted: async (_event, _nylasSchedulerConnector) => {
            },
        },
        localPropsToProp: new Map([['themeConfig', 'themeConfig']]),
        fireRegisterEvent: true,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NylasFeedbackForm.prototype, "render", null);
//# sourceMappingURL=nylas-feedback-form.js.map
