import { createStore } from "@stencil/store";
export function CreateNylasSchedulerConfigStore(defaultState = {}) {
    const defaultSchedulerConfigState = {
        selectedConfiguration: {},
        configurations: [],
        groupEvents: [],
        listConfigurationsNextCursor: null,
        calendars: [],
        currentUser: null,
        action: null,
        additionalParticipants: [],
        requiresSlug: false,
        masterGroupEvents: {},
        isLoading: false,
        ...defaultState,
    };
    const store = createStore(defaultSchedulerConfigState);
    function resetSelectedConfiguration() {
        store.set('selectedConfiguration', { ...defaultState['selectedConfiguration'] });
    }
    store.onChange('action', async (action) => {
        if (!action) {
            resetSelectedConfiguration();
        }
    });
    return {
        ...store,
        resetSelectedConfiguration,
    };
}
//# sourceMappingURL=scheduler-config-store.js.map
