import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const iconCss = ".sc-checkmark-circle-icon-h{display:flex}";
const CheckmarkCircleIconStyle0 = iconCss;

const CheckmarkCircleIcon = proxyCustomElement(class CheckmarkCircleIcon extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.width = '20';
        this.height = '20';
    }
    render() {
        return (h("svg", { key: '498101e43697aec830fd97c25cc7ad443b865cc0', xmlns: "http://www.w3.org/2000/svg", width: this.width, height: this.height, fill: "none", viewBox: "0 0 20 20" }, h("path", { key: 'dd7f115b73e2bdb02da721329ac5ff8b8e629ca4', fill: "currentColor", d: "M10 2a8 8 0 1 1 0 16 8 8 0 0 1 0-16Zm0 1a7 7 0 1 0 0 14 7 7 0 0 0 0-14Zm3.358 4.646a.5.5 0 0 1 .058.638l-.058.07-4.004 4.004a.5.5 0 0 1-.638.058l-.07-.058-2-2a.5.5 0 0 1 .638-.765l.07.058L9 11.298l3.651-3.652a.5.5 0 0 1 .707 0Z" })));
    }
    static get style() { return CheckmarkCircleIconStyle0; }
}, [2, "checkmark-circle-icon", {
        "width": [1],
        "height": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["checkmark-circle-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "checkmark-circle-icon":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, CheckmarkCircleIcon);
            }
            break;
    } });
}

export { CheckmarkCircleIcon as C, defineCustomElement as d };

//# sourceMappingURL=checkmark-circle.js.map