import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const iconCss = ".sc-chevron-icon-h{display:flex}";
const ChevronIconStyle0 = iconCss;

const ChevronIcon = proxyCustomElement(class ChevronIcon extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.width = '24';
        this.height = '24';
    }
    render() {
        return (h("svg", { key: 'a616a1831c338230ef83909865b628dd2b8e4317', xmlns: "http://www.w3.org/2000/svg", width: this.width, height: this.height, viewBox: "0 0 24 24", fill: "none" }, h("path", { key: 'c2abe3769a15572d0b2a9b865bbdbf7394562572', fill: "currentColor", d: "M15.53 4.22a.75.75 0 0 1 0 1.06L8.81 12l6.72 6.72a.75.75 0 1 1-1.06 1.06l-7.25-7.25a.75.75 0 0 1 0-1.06l7.25-7.25a.75.75 0 0 1 1.06 0Z" })));
    }
    static get style() { return ChevronIconStyle0; }
}, [2, "chevron-icon", {
        "width": [1],
        "height": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["chevron-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "chevron-icon":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, ChevronIcon);
            }
            break;
    } });
}

export { ChevronIcon as C, defineCustomElement as d };

//# sourceMappingURL=chevron.js.map