import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const iconCss = ".sc-feedback-icon-h{display:flex}";
const FeedbackIconStyle0 = iconCss;

const FeedbackIcon = proxyCustomElement(class FeedbackIcon extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.width = '11';
        this.height = '14';
    }
    render() {
        return (h("svg", { key: '0cef0443a3b22ffa2bd9be587f55175bef8557cf', width: this.width, height: this.height, fill: "none", xmlns: "http://www.w3.org/2000/svg" }, h("path", { key: '20631452d3f3bc031b79d3337eda08143db490e4', d: "M0.5 8.875C0.5 8.875 1.125 8.25 3 8.25C4.875 8.25 6.125 9.5 8 9.5C9.875 9.5 10.5 8.875 10.5 8.875V1.375C10.5 1.375 9.875 2 8 2C6.125 2 4.875 0.75 3 0.75C1.125 0.75 0.5 1.375 0.5 1.375V8.875ZM0.5 8.875V13.25", stroke: "currentColor", "stroke-linecap": "round", "stroke-linejoin": "round" })));
    }
    static get style() { return FeedbackIconStyle0; }
}, [2, "feedback-icon", {
        "width": [1],
        "height": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["feedback-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "feedback-icon":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, FeedbackIcon);
            }
            break;
    } });
}

export { FeedbackIcon as F, defineCustomElement as d };

//# sourceMappingURL=feedback-icon2.js.map