import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const loadingCss = ".wave{display:flex;align-items:center;justify-content:center}.dot{width:4px;height:4px;background-color:var(--dot-color, white);border-radius:50%;margin:0 2px;animation:wave 1.5s infinite ease-in-out}.dot:nth-child(2){animation-delay:0.2s}.dot:nth-child(3){animation-delay:0.4s}@keyframes wave{0%,60%,100%{transform:translateY(0)}30%{transform:translateY(-4px)}}";
const LoadingIconStyle0 = loadingCss;

const LoadingIcon = proxyCustomElement(class LoadingIcon extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.width = '15';
        this.height = '15';
    }
    render() {
        return (h("div", { key: 'cb855fdd798e64637d245045e56a97f016f8b74f', class: "wave" }, h("div", { key: '41591d61b8eda97e3abdd2ca83f82aada7d67edc', class: "dot" }), h("div", { key: '096aa4e8c6f1d9cb5a5d1d24cda06298fd0366b1', class: "dot" }), h("div", { key: 'd2dd6942fe7b1a8ca68102e9dea7dae88e341824', class: "dot" })));
    }
    static get style() { return LoadingIconStyle0; }
}, [1, "loading-icon", {
        "width": [1],
        "height": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["loading-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "loading-icon":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, LoadingIcon);
            }
            break;
    } });
}

export { LoadingIcon as L, defineCustomElement as d };

//# sourceMappingURL=loading.js.map