import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const iconCss = ".sc-microsoft-logo-icon-h{display:flex}";
const MicrosoftLogoIconStyle0 = iconCss;

const MicrosoftLogoIcon = proxyCustomElement(class MicrosoftLogoIcon extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.width = '22';
        this.height = '22';
    }
    render() {
        return (h("svg", { key: 'a6a6af29ed81710f3f493d849c90871991e0be0f', width: this.width, height: this.height, viewBox: "0 0 22 22", fill: "none", xmlns: "http://www.w3.org/2000/svg" }, h("path", { key: '025c40cab8337a37897481fb47580f219b3ad528', d: "M0.043457 0.043457H10.4782V10.4782H0.043457V0.043457Z", fill: "#F35325" }), h("path", { key: 'd7e67a46de5217cfa54f8973616616a9fd4fb474', d: "M11.5217 0.043457H21.9565V10.4782H11.5217V0.043457Z", fill: "#81BC06" }), h("path", { key: '2f4162db32fb29afb4f88c3070e59e8dc574a732', d: "M0.043457 11.5217H10.4782V21.9565H0.043457V11.5217Z", fill: "#05A6F0" }), h("path", { key: '4ec074b89f50e66765e199ae112d063ca21b541a', d: "M11.5217 11.5217H21.9565V21.9565H11.5217V11.5217Z", fill: "#FFBA08" })));
    }
    static get style() { return MicrosoftLogoIconStyle0; }
}, [2, "microsoft-logo-icon", {
        "width": [1],
        "height": [1]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["microsoft-logo-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "microsoft-logo-icon":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, MicrosoftLogoIcon);
            }
            break;
    } });
}

export { MicrosoftLogoIcon as M, defineCustomElement as d };

//# sourceMappingURL=microsoft-logo.js.map