import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { R as RegisterComponent } from './register-component.js';
import { a as debug, b as instance } from './utils.js';
import { c as LANGUAGE_MAP, L as LANGUAGE_CODE } from './constants.js';
import { d as defineCustomElement$7 } from './chevron.js';
import { d as defineCustomElement$6 } from './info.js';
import { d as defineCustomElement$5 } from './search.js';
import { d as defineCustomElement$4 } from './select-dropdown2.js';
import { d as defineCustomElement$3 } from './toggle-switch2.js';
import { d as defineCustomElement$2 } from './toolitp-component.js';
import { d as defineCustomElement$1 } from './translate.js';

const nylasDisableEmailsCss = ":host{display:block;--nylas-primary:#2563eb;--nylas-error:#cc4841;--nylas-error-pressed:#992222;--nylas-wraning:#f06c00;--nylas-success:#16a392;--nylas-info:#2b8fc2;--nylas-base-0:#ffffff;--nylas-base-25:#fcfcfd;--nylas-base-50:#f8f9fc;--nylas-base-100:#eaecf5;--nylas-base-200:#d5d9eb;--nylas-base-300:#b3b8d8;--nylas-base-400:#717bbc;--nylas-base-500:#4e5ba6;--nylas-base-600:#3e4784;--nylas-base-700:#263f72;--nylas-base-800:#293056;--nylas-base-900:#101323;--nylas-base-950:#0e101b;--nylas-color-blue-100:#e0e6f9;--nylas-border-radius:0.25rem;--nylas-border-radius-2x:0.5rem;--nylas-border-radius-3x:0.75rem;--nylas-font-family:\"Inter\", sans-serif;--nylas-color-black:#000000;--nylas-color-grey-900:#2c2c2c;--nylas-color-grey-800:#4b4b4b;--nylas-color-grey-700:#6e6e6e;--nylas-color-grey-600:#8e8e8e;--nylas-color-grey-500:#b3b3b3;--nylas-color-grey-400:#cacaca;--nylas-color-grey-300:#e1e1e1;--nylas-color-grey-200:#eaeaea;--nylas-color-grey-100:#f5f5f5;--nylas-color-grey-50:#fbfcfe;--nylas-color-white:#ffffff;--nylas-color-red-900:#992222;--nylas-color-red-700:#cc4841;--nylas-color-red-500:#ff786a;--nylas-color-red-300:#ffa79e;--nylas-color-red-100:#ffc5bf;--nylas-color-red-50:#ffeae8;--nylas-color-blue-900:#213571;--nylas-color-blue-700:#314fa9;--nylas-color-blue-500:#4169e1;--nylas-color-blue-300:#bdccf9;--nylas-color-blue-100:#e0e6f9;--nylas-color-blue-50:#f6f8fd;--nylas-color-yellow-900:#7c6506;--nylas-color-yellow-700:#c29f09;--nylas-color-yellow-500:#f7c90b;--nylas-color-yellow-300:#f9de70;--nylas-color-yellow-100:#fceba9;--nylas-color-yellow-50:#fdf4ce;--nylas-color-green-900:#0e6b60;--nylas-color-green-700:#16a392;--nylas-color-green-500:#17c3b2;--nylas-color-green-300:#74dbd1;--nylas-color-green-100:#a2e7e0;--nylas-color-green-50:#d1f3f0;--nylas-color-purple-900:#643554;--nylas-color-purple-700:#954f7d;--nylas-color-purple-500:#c769a7;--nylas-color-purple-300:#dda5ca;--nylas-color-purple-100:#e0bdd6;--nylas-color-purple-50:#e9dde5;--nylas-color-sky-900:#20698f;--nylas-color-sky-700:#2b8fc2;--nylas-color-sky-500:#6dceff;--nylas-color-sky-300:#8fdaff;--nylas-color-sky-100:#b8e7ff;--nylas-color-sky-50:#d9f2ff;width:inherit}.nylas-disable-emails{border:1px solid var(--nylas-base-200);border-radius:var(--nylas-border-radius-2x);margin:1rem}.header{padding:1rem;display:grid;grid-template-columns:1fr auto;border-bottom:1px solid var(--nylas-base-200)}.header h3{border-radius:var(--nylas-border-radius-2x);margin:0;font-size:16px;font-weight:600;line-height:20px;color:var(--nylas-base-900);text-align:left}.header p{display:flex;gap:4px;align-items:center;margin:0.25rem 0 0 0;font-size:0.875rem;font-weight:400;line-height:20px;color:var(--nylas-base-600);text-align:left}.header .drawer-toggle{display:flex;gap:24px;align-items:center}.header .drawer-toggle .chevron{display:flex;align-self:center;cursor:pointer}.header .drawer-toggle .chevron:hover,.header .drawer-toggle .chevron:active{color:var(--nylas-primary)}.header .drawer-toggle .chevron.open{transform:rotate(90deg)}.header .drawer-toggle .chevron.closed{transform:rotate(270deg)}.header .drawer-toggle .chevron.disabled{cursor:not-allowed;color:var(--nylas-base-300)}.header .drawer-toggle .chevron.disabled:hover{color:var(--nylas-base-300)}.toggle{display:flex;align-items:center;justify-content:space-between;padding:0;margin:16px}.toggle label{display:inline-flex;align-items:center;gap:8px}.toggle toggle-switch{margin-right:12px}.toggle select-dropdown{width:auto}";
const NylasDisableEmailsStyle0 = nylasDisableEmailsCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
const NylasDisableEmails = proxyCustomElement(class NylasDisableEmails extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.valueChanged = createEvent(this, "valueChanged", 7);
        this.internals = this.attachInternals();
        this.selectedConfiguration = undefined;
        this.name = 'disable-emails';
        this.selectedLanguage = undefined;
        this.organizerLocale = this.selectedLanguage || 'en';
        this.disableEmails = false;
    }
    connectedCallback() {
        debug('nylas-disable-emails', 'connectedCallback');
    }
    disconnectedCallback() {
        debug('nylas-disable-emails', 'disconnectedCallback');
    }
    componentWillLoad() {
        debug('nylas-disable-emails', 'componentWillLoad');
        this.host.setAttribute('name', this.name);
    }
    componentDidLoad() {
        debug('nylas-disable-emails', 'componentDidLoad');
        const lang = this.selectedConfiguration?.scheduler?.email_template?.organizer_locale || this.selectedLanguage || 'en';
        this.organizerLocale = lang;
        const isGroupConfig = this.selectedConfiguration?.group_booking !== undefined;
        const disableEmails = isGroupConfig
            ? this.selectedConfiguration?.group_booking?.disable_emails
            : this.selectedConfiguration?.event_booking?.disable_emails;
        this.disableEmails = disableEmails || false;
        this.handleSettingValue(false);
    }
    elementNameChangedHandler(newValue) {
        debug('nylas-disable-emails', 'elementNameChangedHandler', newValue);
        this.host.setAttribute('name', newValue);
    }
    selectedLanguageChangedHandler(newVal, oldVal) {
        if (newVal === oldVal)
            return;
        instance.changeLanguage(newVal);
    }
    selectedConfigurationChangedHandler(newVal, oldVal) {
        if (newVal === oldVal)
            return;
        this.organizerLocale = newVal.scheduler?.email_template?.organizer_locale || this.selectedLanguage || 'en';
        this.handleSettingValue(false);
        const isGroupConfig = newVal?.group_booking !== undefined;
        const disableEmails = isGroupConfig ? newVal?.group_booking?.disable_emails : newVal?.event_booking?.disable_emails;
        this.disableEmails = disableEmails || false;
        this.handleSettingValue(false);
    }
    nyalsFormSwitchToggledHandler(event) {
        debug('nylas-confirmation-email', 'nyalsFormSwitchToggledHandler', event.detail);
        const { checked } = event.detail;
        if (event.detail.name === 'disable-emails') {
            this.disableEmails = !checked;
            this.handleSettingValue();
        }
    }
    nylasFormDropdownChangedHandler(event) {
        const { name, value } = event.detail;
        if (name === 'organizer-locale') {
            const lang = LANGUAGE_CODE[value];
            this.organizerLocale = lang;
            this.handleSettingValue();
        }
    }
    handleSettingValue(valueChanged = true) {
        if (valueChanged) {
            this.valueChanged.emit({
                value: JSON.stringify({
                    disableEmails: this.disableEmails,
                    organizerLocale: this.organizerLocale,
                }),
                name: this.name,
            });
        }
        this.internals.setFormValue(JSON.stringify({
            disableEmails: this.disableEmails,
            organizerLocale: this.organizerLocale,
        }), this.name);
    }
    render() {
        const languageOptions = Object.keys(LANGUAGE_MAP).map(key => ({
            label: LANGUAGE_MAP[key],
            value: key,
        }));
        const isGroupConfig = this.selectedConfiguration?.group_booking !== undefined;
        const disableEmails = isGroupConfig
            ? this.selectedConfiguration?.group_booking?.disable_emails
            : this.selectedConfiguration?.event_booking?.disable_emails;
        return (h(Host, { key: '61c656e8493effefc64d68b07bf663350d854630' }, h("div", { key: 'e3e32aea50842e2e9c1426fd639eb0dab573a989', class: "nylas-disable-emails", part: "nde" }, h("div", { key: '621732af92baada7bc6c06408ff9a51674cc158c', class: "header", part: "nde__header" }, h("div", { key: '8f882d8b83994abc4c73219701979d2287411edb' }, h("h3", { key: 'a81f9e1b64dac3621ee45eb3d6dc1709f61c272b' }, instance.t('eventCommunicationsTitle')), h("p", { key: 'c52741d9875a3f3c8df86e1a5d104783a7934c5e' }, instance.t('eventCommunicationsDescription')))), h("div", { key: '5a08c4030ba531402a9a4bb42153eb8d4968dfd6', class: "toggle", part: "nde__toggle" }, h("label", { key: '9f2c2a5d4f07e2882d598d0f7f8a90d7f4ec5758' }, instance.t('nylasConfirmationEmail.confirmationEmail.label'), h("span", { key: '8743fdc4d47c1ad833656629a7096610436ddccd', class: "label-icon" }, h("tooltip-component", { key: 'a92ff3a415b36a68fd94eff0a4b2f0d825fbfbb6' }, h("info-icon", { key: 'eb0806cdc0690f2d7f6e515a691569b683099c09', slot: "tooltip-icon" }), h("span", { key: '45f1a35f845617099c9b8d786dc5762a46ca374e', slot: "tooltip-content" }, " ", instance.t('nylasConfirmationEmail.confirmationEmail.tooltip.desc'))))), h("toggle-switch", { key: '984d924370c58341ac73cce774c26b910d54a52b', exportparts: "ts_label: nde__toggle-label, ts_input: nde_toggle-input, ts_slider: nde_toggle-slider", name: `disable-emails`, checked: !disableEmails })), h("div", { key: '50524c61fa7d56e401a76b7f53a08e83b7498cc6', class: "toggle", part: "nde__toggle" }, h("label", { key: 'e72bac6b8d355a2d87cdb98e058e3564555c2783' }, instance.t('nylasConfirmationEmail.confirmationEmail.language'), h("span", { key: 'ec813fa7ca1cb750b55c75f0954664dcb4625995', class: "label-icon" }, h("tooltip-component", { key: '5efbf9e93637e15b93e4baa786131534424d8896' }, h("info-icon", { key: '5e2e302326c873d637e7892d508d83636e81a20b', slot: "tooltip-icon" }), h("span", { key: 'b6a1e85100d303079c2efb4833d9b98fe74326c6', slot: "tooltip-content" }, " ", instance.t('nylasConfirmationEmail.confirmationEmail.tooltip.language'))))), h("select-dropdown", { key: 'd1b12b65f4dcb88781400ec594611e6a41f86c0f', name: "organizer-locale", options: languageOptions, searchPlaceholder: instance.t('search'), withChevron: false, defaultSelectedOption: languageOptions.find(lang => lang.value == this.organizerLocale), exportparts: "sd_dropdown: nse__language-dropdown, sd_dropdown-button: nse__language-drop-button, sd_dropdown-content: nse__language-drop-content, sd_dropdown_label: nse__language-drop-label" }, h("span", { key: '52a4959de14fb93cdcb0f624d0b86e768f302a5b', slot: "select-icon" }, h("translate-icon", { key: '5c0aa2784847c6b858b833606c661d593e7cd40c', width: "20", height: "20" })))))));
    }
    static get formAssociated() { return true; }
    get host() { return this; }
    static get watchers() { return {
        "name": ["elementNameChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"],
        "selectedConfiguration": ["selectedConfigurationChangedHandler"]
    }; }
    static get style() { return NylasDisableEmailsStyle0; }
}, [65, "nylas-disable-emails", {
        "selectedConfiguration": [16],
        "name": [1],
        "selectedLanguage": [1, "selected-language"],
        "organizerLocale": [32],
        "disableEmails": [32]
    }, [[0, "nylasFormSwitchToggled", "nyalsFormSwitchToggledHandler"], [0, "nylasFormDropdownChanged", "nylasFormDropdownChangedHandler"]], {
        "name": ["elementNameChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"],
        "selectedConfiguration": ["selectedConfigurationChangedHandler"]
    }]);
__decorate([
    RegisterComponent({
        name: 'nylas-disable-emails',
        stateToProps: new Map([
            ['schedulerConfig.selectedLanguage', 'selectedLanguage'],
            ['schedulerConfig.selectedConfiguration', 'selectedConfiguration'],
        ]),
        eventToProps: {
            valueChanged: async (event, _nylasSchedulerConfigConnector) => {
                const { valueChanged } = event.detail;
                if (valueChanged) {
                    valueChanged(event);
                }
            },
        },
        fireRegisterEvent: true,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NylasDisableEmails.prototype, "render", null);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["nylas-disable-emails", "chevron-icon", "info-icon", "search-icon", "select-dropdown", "toggle-switch", "tooltip-component", "translate-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "nylas-disable-emails":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, NylasDisableEmails);
            }
            break;
        case "chevron-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$7();
            }
            break;
        case "info-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "search-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "select-dropdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "toggle-switch":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "tooltip-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "translate-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { NylasDisableEmails as N, defineCustomElement as d };

//# sourceMappingURL=nylas-disable-emails2.js.map