import { h, Fragment, proxyCustomElement, HTMLElement, createEvent, Host } from '@stencil/core/internal/client';
import { R as RegisterComponent } from './register-component.js';
import { a as debug, b as instance, E as mergeDeep, F as parsePreviewLink } from './utils.js';
import { n as nr, E as ErrorCategory } from './index3.js';
import { g as editorGroupTabComponentNames, C as CONFIGURATION_EVENT_TYPE } from './constants.js';
import { d as defineCustomElement$1a } from './add-circle.js';
import { d as defineCustomElement$19 } from './button-component2.js';
import { d as defineCustomElement$18 } from './calendar-agenda-fill.js';
import { d as defineCustomElement$17 } from './calendar-agenda.js';
import { d as defineCustomElement$16 } from './checkbox-component2.js';
import { d as defineCustomElement$15 } from './checkbox-group2.js';
import { d as defineCustomElement$14 } from './checkmark.js';
import { d as defineCustomElement$13 } from './chevron.js';
import { d as defineCustomElement$12 } from './clock.js';
import { d as defineCustomElement$11 } from './close.js';
import { d as defineCustomElement$10 } from './copy.js';
import { d as defineCustomElement$$ } from './dragable.js';
import { d as defineCustomElement$_ } from './edit.js';
import { d as defineCustomElement$Z } from './envelope-fill.js';
import { d as defineCustomElement$Y } from './envelope.js';
import { d as defineCustomElement$X } from './eye.js';
import { d as defineCustomElement$W } from './feedback-icon2.js';
import { d as defineCustomElement$V } from './flow.js';
import { d as defineCustomElement$U } from './globe.js';
import { d as defineCustomElement$T } from './google-meet.js';
import { d as defineCustomElement$S } from './info.js';
import { d as defineCustomElement$R } from './input-color-picker2.js';
import { d as defineCustomElement$Q } from './input-component2.js';
import { d as defineCustomElement$P } from './input-dropdown2.js';
import { d as defineCustomElement$O } from './input-image-url2.js';
import { d as defineCustomElement$N } from './loading.js';
import { d as defineCustomElement$M } from './location.js';
import { d as defineCustomElement$L } from './location-off.js';
import { d as defineCustomElement$K } from './microsof-teams.js';
import { d as defineCustomElement$J } from './multi-select-dropdown2.js';
import { d as defineCustomElement$I } from './nylas-additional-participants2.js';
import { d as defineCustomElement$H } from './nylas-booking-confirmation-redirect2.js';
import { d as defineCustomElement$G } from './nylas-booking-confirmation-type2.js';
import { d as defineCustomElement$F } from './nylas-booking-form-config2.js';
import { d as defineCustomElement$E } from './nylas-cancellation-policy2.js';
import { d as defineCustomElement$D } from './nylas-confirmation-email2.js';
import { d as defineCustomElement$C } from './nylas-custom-booking-flow2.js';
import { d as defineCustomElement$B } from './nylas-custom-event-slug2.js';
import { d as defineCustomElement$A } from './nylas-customize-booking-settings2.js';
import { d as defineCustomElement$z } from './nylas-date-component2.js';
import { d as defineCustomElement$y } from './nylas-disable-emails2.js';
import { d as defineCustomElement$x } from './nylas-event-calendar2.js';
import { d as defineCustomElement$w } from './nylas-event-capacity2.js';
import { d as defineCustomElement$v } from './nylas-event-description2.js';
import { d as defineCustomElement$u } from './nylas-event-info2.js';
import { d as defineCustomElement$t } from './nylas-event-limits2.js';
import { d as defineCustomElement$s } from './nylas-event-location2.js';
import { d as defineCustomElement$r } from './nylas-event-timeslot2.js';
import { d as defineCustomElement$q } from './nylas-event-title2.js';
import { d as defineCustomElement$p } from './nylas-feedback-form2.js';
import { d as defineCustomElement$o } from './nylas-form-card2.js';
import { d as defineCustomElement$n } from './nylas-min-booking-notice2.js';
import { d as defineCustomElement$m } from './nylas-min-cancellation-notice2.js';
import { d as defineCustomElement$l } from './nylas-notification2.js';
import { d as defineCustomElement$k } from './nylas-page-name2.js';
import { d as defineCustomElement$j } from './nylas-page-styling2.js';
import { d as defineCustomElement$i } from './nylas-reminder-emails2.js';
import { d as defineCustomElement$h } from './nylas-reminder-time2.js';
import { d as defineCustomElement$g } from './nylas-scheduling-method2.js';
import { d as defineCustomElement$f } from './nylas-time-window-picker2.js';
import { d as defineCustomElement$e } from './paintbrush-fill.js';
import { d as defineCustomElement$d } from './paintbrush.js';
import { d as defineCustomElement$c } from './person-clipboard.js';
import { d as defineCustomElement$b } from './plus.js';
import { d as defineCustomElement$a } from './search.js';
import { d as defineCustomElement$9 } from './select-dropdown2.js';
import { d as defineCustomElement$8 } from './textarea-component2.js';
import { d as defineCustomElement$7 } from './time-period-selector2.js';
import { d as defineCustomElement$6 } from './toggle-switch2.js';
import { d as defineCustomElement$5 } from './toolitp-component.js';
import { d as defineCustomElement$4 } from './translate.js';
import { d as defineCustomElement$3 } from './trash.js';
import { d as defineCustomElement$2 } from './warning.js';
import { d as defineCustomElement$1 } from './zoom.js';
import { i as isInitialized, a as init, c as captureMessage, b as captureFeedback, f as feedbackSyncIntegration } from './feedbackSync.js';

var TabGroup;
(function (TabGroup) {
    TabGroup["BookingOptions"] = "bookingOptions";
    TabGroup["Communications"] = "communications";
    TabGroup["BookingForm"] = "bookingForm";
    TabGroup["PageStyles"] = "pageStyles";
    TabGroup["CalendarView"] = "calendarView";
})(TabGroup || (TabGroup = {}));
function TabContentsGroup({ id, formState, activeTab }, children) {
    return (h(Fragment, null,
        activeTab === TabGroup.CalendarView && (h("div", { key: `calendar-view-${id}`, class: { 'hide': activeTab !== TabGroup.CalendarView, 'calendar-view': true } },
            h("nylas-event-calendar", null))),
        h("div", { key: `booking-options-${id}`, class: { hide: activeTab !== TabGroup.BookingOptions } },
            h("nylas-scheduling-method", { name: "availability-method", readOnly: true, exportparts: "nsm, nsm__header, nsm__input-label, nsm__dropdown, nsm__dropdown-button, nsm__dropdown-content" }),
            h("nylas-custom-booking-flow", { exportparts: 'ncbflow, ncbflow__header, ncbflow__title, ncbflow__content' },
                h("div", { slot: "inputs" },
                    h("nylas-booking-confirmation-type", { name: "confirmation-type", exportparts: 'nbct, nbct__header, nbct__dropdown, nbct__dropdown-button, nbct__dropdown-content' }),
                    h("nylas-booking-confirmation-redirect", { name: "confirmation-redirect", exportparts: 'nbcr, nbcr__header, nbcr__dropdown, nbcr__dropdown-button, nbcr__dropdown-content, nbcr__input-textfield' }))),
            h("nylas-event-limits", null,
                h("div", { slot: "inputs" },
                    h("nylas-min-booking-notice", { name: "min-booking-notice", exportparts: "nmbn, nmbn__number-dropdown, nmbn__number-dropdown-button, nmbn__number-dropdown-content, nmbn__period-dropdown, nmbn__period-dropdown-button, nmbn__period-dropdown-content" }),
                    h("nylas-min-cancellation-notice", { name: "min-cancellation-notice", exportparts: "nmcn, nmcn__number-dropdown, nmcn__number-dropdown-button, nmcn__number-dropdown-content, nmcn__period-dropdown, nmcn__period-dropdown-button, nmcn__period-dropdown-content" }),
                    h("nylas-cancellation-policy", { name: "cancellation-policy", exportparts: "ncpolicy, ncpolicy__textarea" }))),
            h("nylas-customize-booking-settings", { showSettings: ['hideCancellationOptions', 'hideReschedulingOptions'], name: "customize-booking-settings", exportparts: "ncbs, ncbs__header, ncbs__settings, ncbs__settings-div, ncbs__additional_guests, ncbs__cancellation_options, ncbs__rescheduling_options" })),
        h("div", { key: `communications-${id}`, class: { hide: activeTab !== TabGroup.Communications } },
            h("nylas-disable-emails", { name: "disable-emails", exportparts: "nde, nde__toggle-label, nde_toggle-input, nde_toggle-slider" }),
            !formState?.disableEmails && (h(Fragment, null,
                h("nylas-confirmation-email", { name: "confirmation-email-template", exportparts: 'nce, nce__tab-heading, nce__header, nce__body, nce__confirmation-email-toggle--container, nce__summary, nce__reminder-input_dropdown, nce__reminder-input_dropdown-input, nce__reminder-input_dropdown-content' }),
                h("nylas-reminder-emails", { name: "reminder-overrides", exportparts: 'nre, nre__tab-heading, nre__header, nre__body, nre__confirmation-email-toggle--container, nre__summary, nrt, nrt__number-dropdown, nrt__number-dropdown-button, nrt__number-dropdown-content, nrt__period-dropdown, nrt__period-dropdown-button, nrt__period-dropdown-content, nrt__time-period-selector' })))),
        h("div", { key: `page-styles-${id}`, class: { hide: activeTab !== TabGroup.PageStyles } },
            h("nylas-custom-event-slug", { name: "custom-event-slug", exportparts: "nces, nces__body, nces__header, nces__drawer-toggle--container, nces__input-textfield" }),
            h("nylas-page-name", { name: "page-name", requirePageName: true, exportparts: "npn, npn__body, npn__header, npn__drawer-toggle--container, npn__input-textfield" }),
            h("nylas-page-styling", { name: "page-styling", exportparts: "nps, nps__header, nps__drawer-toggle--container, nps__body, nps__title-input-textfield, nps__company-logo-input-textfield, nps__color-picker, nps__color-picker-button, nps__color-picker-button-label, nps__color-picker-selected-label, nps__submit-button-label-input-textfield, nps__message-textarea" }, children)),
        h("div", { key: `booking-form-${id}`, class: { hide: activeTab !== TabGroup.BookingForm } },
            h("nylas-booking-form-config", { name: "additional-fields", exportparts: "nbfc, nbfc__header, nbfc__add_field, nbfc__add_field-button, nbfc__add_field-content, nbfc__static_fields, nbfc__additional_fields, nbfc__form-field, nbfc__form-field-header, nbfc__form-field-content" }))));
}

const nylasEditorTabsGroupCss = ".sc-nylas-editor-tabs-group-h{display:block;--nylas-primary:#2563eb;--nylas-error:#cc4841;--nylas-error-pressed:#992222;--nylas-wraning:#f06c00;--nylas-success:#16a392;--nylas-info:#2b8fc2;--nylas-base-0:#ffffff;--nylas-base-25:#fcfcfd;--nylas-base-50:#f8f9fc;--nylas-base-100:#eaecf5;--nylas-base-200:#d5d9eb;--nylas-base-300:#b3b8d8;--nylas-base-400:#717bbc;--nylas-base-500:#4e5ba6;--nylas-base-600:#3e4784;--nylas-base-700:#263f72;--nylas-base-800:#293056;--nylas-base-900:#101323;--nylas-base-950:#0e101b;--nylas-color-blue-100:#e0e6f9;--nylas-border-radius:0.25rem;--nylas-border-radius-2x:0.5rem;--nylas-border-radius-3x:0.75rem;--nylas-font-family:\"Inter\", sans-serif;--nylas-color-black:#000000;--nylas-color-grey-900:#2c2c2c;--nylas-color-grey-800:#4b4b4b;--nylas-color-grey-700:#6e6e6e;--nylas-color-grey-600:#8e8e8e;--nylas-color-grey-500:#b3b3b3;--nylas-color-grey-400:#cacaca;--nylas-color-grey-300:#e1e1e1;--nylas-color-grey-200:#eaeaea;--nylas-color-grey-100:#f5f5f5;--nylas-color-grey-50:#fbfcfe;--nylas-color-white:#ffffff;--nylas-color-red-900:#992222;--nylas-color-red-700:#cc4841;--nylas-color-red-500:#ff786a;--nylas-color-red-300:#ffa79e;--nylas-color-red-100:#ffc5bf;--nylas-color-red-50:#ffeae8;--nylas-color-blue-900:#213571;--nylas-color-blue-700:#314fa9;--nylas-color-blue-500:#4169e1;--nylas-color-blue-300:#bdccf9;--nylas-color-blue-100:#e0e6f9;--nylas-color-blue-50:#f6f8fd;--nylas-color-yellow-900:#7c6506;--nylas-color-yellow-700:#c29f09;--nylas-color-yellow-500:#f7c90b;--nylas-color-yellow-300:#f9de70;--nylas-color-yellow-100:#fceba9;--nylas-color-yellow-50:#fdf4ce;--nylas-color-green-900:#0e6b60;--nylas-color-green-700:#16a392;--nylas-color-green-500:#17c3b2;--nylas-color-green-300:#74dbd1;--nylas-color-green-100:#a2e7e0;--nylas-color-green-50:#d1f3f0;--nylas-color-purple-900:#643554;--nylas-color-purple-700:#954f7d;--nylas-color-purple-500:#c769a7;--nylas-color-purple-300:#dda5ca;--nylas-color-purple-100:#e0bdd6;--nylas-color-purple-50:#e9dde5;--nylas-color-sky-900:#20698f;--nylas-color-sky-700:#2b8fc2;--nylas-color-sky-500:#6dceff;--nylas-color-sky-300:#8fdaff;--nylas-color-sky-100:#b8e7ff;--nylas-color-sky-50:#d9f2ff}.scheduler-editor.sc-nylas-editor-tabs-group{display:flex;flex-direction:column;height:inherit;position:relative}.scheduler-editor.sc-nylas-editor-tabs-group div.return-to-calendar-view.sc-nylas-editor-tabs-group{display:flex;border-bottom:1px solid var(--nylas-base-200)}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group{display:grid;grid-template-columns:minmax(224px, 25%) 1fr;height:auto;overflow-y:auto;min-height:calc(100% - 80px - 48px)}@media screen and (max-width: 768px){.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group{display:table-column-group;height:auto;min-height:calc(100% - 80px - 196px - 48px)}}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tabs.sc-nylas-editor-tabs-group{display:flex;flex-direction:column;border-right:1px solid var(--nylas-base-200);background-color:var(--nylas-base-25)}@media screen and (max-width: 768px){.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tabs.sc-nylas-editor-tabs-group{border-right:none}}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tabs.sc-nylas-editor-tabs-group .tab.sc-nylas-editor-tabs-group{display:flex;align-items:center;text-align:left;gap:0.5rem;padding:0.5rem 1rem;color:var(--nylas-base-900);background:var(--nylas-base-0);border:none;height:56px;font-family:var(--nylas-font-family);font-size:16px;font-weight:500;line-height:24px;cursor:pointer}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tabs.sc-nylas-editor-tabs-group .tab.sc-nylas-editor-tabs-group:not(:first-of-type){margin-top:0.25rem}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tabs.sc-nylas-editor-tabs-group .tab.sc-nylas-editor-tabs-group:last-of-type{margin-bottom:0.25rem}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tabs.sc-nylas-editor-tabs-group .tab.active.sc-nylas-editor-tabs-group{font-weight:600;background:var(--nylas-base-0);color:var(--nylas-primary);border-left:4px solid var(--nylas-primary);box-shadow:0px 1px 2px 0px rgba(0, 0, 0, 0.0588235294);box-shadow:0px 1px 3px 0px rgba(0, 0, 0, 0.1019607843)}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tabs.sc-nylas-editor-tabs-group .tab.hide.sc-nylas-editor-tabs-group{display:none}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group{max-width:692px;overflow-y:auto;overflow-x:hidden}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group .hide.sc-nylas-editor-tabs-group{display:none}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group .calendar-view.sc-nylas-editor-tabs-group{position:absolute;top:0;left:0;height:calc(100% - 80px);width:-webkit-fill-available;background:var(--nylas-base-0)}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group nylas-event-info.sc-nylas-editor-tabs-group,.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group nylas-event-limits.sc-nylas-editor-tabs-group{width:inherit}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group nylas-event-info.sc-nylas-editor-tabs-group div[slot=inputs].sc-nylas-editor-tabs-group,.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group nylas-event-limits.sc-nylas-editor-tabs-group div[slot=inputs].sc-nylas-editor-tabs-group{display:flex;flex-direction:column;gap:1rem}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group .tab-header.sc-nylas-editor-tabs-group{display:flex;flex-direction:column;margin:1rem 1rem 0.5rem;row-gap:4px}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group .tab-header.sc-nylas-editor-tabs-group h3.sc-nylas-editor-tabs-group{margin:0;font-size:16px;font-weight:600;line-height:20px;color:var(--nylas-base-900);text-align:left}.scheduler-editor.sc-nylas-editor-tabs-group .form-contents.sc-nylas-editor-tabs-group .tab-content.sc-nylas-editor-tabs-group .tab-header.sc-nylas-editor-tabs-group p.sc-nylas-editor-tabs-group{margin:0;font-size:0.875rem;font-weight:400;line-height:20px;color:var(--nylas-base-600);text-align:left}.footer.sc-nylas-editor-tabs-group{display:flex;justify-content:space-between;align-items:center;gap:1rem;min-height:80px;padding:0 1rem;border-top:1px solid var(--nylas-base-200)}@media screen and (max-width: 768px){.footer.sc-nylas-editor-tabs-group{flex-direction:column;height:auto;z-index:2}}.footer.sc-nylas-editor-tabs-group .preview.sc-nylas-editor-tabs-group{display:flex;gap:16px}@media screen and (max-width: 768px){.footer.sc-nylas-editor-tabs-group .preview.sc-nylas-editor-tabs-group{margin-top:1rem;width:100%}}.footer.sc-nylas-editor-tabs-group .preview.sc-nylas-editor-tabs-group button-component.page-settings-button.sc-nylas-editor-tabs-group{min-width:140px}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group{display:flex;justify-content:flex-end;align-items:center;justify-self:flex-end;gap:1rem}@media screen and (max-width: 768px){.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group{flex-direction:column-reverse;width:100%}}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group .footer-buttons__row.sc-nylas-editor-tabs-group{display:flex;gap:16px}@media screen and (max-width: 768px){.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group .footer-buttons__row.sc-nylas-editor-tabs-group{width:100%}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group .footer-buttons__row.sc-nylas-editor-tabs-group button-component[title=Preview].sc-nylas-editor-tabs-group{width:48px}}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group p.sc-nylas-editor-tabs-group{max-width:524px}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group p.unsaved-changes.sc-nylas-editor-tabs-group{color:var(--nylas-base-600)}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group p.saved-changes.sc-nylas-editor-tabs-group{color:var(--nylas-success)}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group p.error.sc-nylas-editor-tabs-group{color:var(--nylas-error)}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group p.error-full-width.sc-nylas-editor-tabs-group{max-width:660px}@media screen and (max-width: 768px){.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group button-component.sc-nylas-editor-tabs-group{width:100%}}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group button.sc-nylas-editor-tabs-group{background:var(--nylas-primary);color:var(--nylas-base-0);height:48px;border:none;border-radius:var(--nylas-border-radius-2x);font-size:16px;line-height:24px;padding:0 1rem;cursor:pointer;width:148px}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group button.sc-nylas-editor-tabs-group:hover{background:var(--nylas-base-600)}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group button.sc-nylas-editor-tabs-group:active{background:var(--nylas-base-800)}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group button.sc-nylas-editor-tabs-group:disabled{background:var(--nylas-base-300);cursor:not-allowed}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group button.sc-nylas-editor-tabs-group span.sc-nylas-editor-tabs-group{display:flex;align-items:center;justify-content:center;gap:0.5rem}.footer.sc-nylas-editor-tabs-group .buttons.sc-nylas-editor-tabs-group button-component.save-changes.sc-nylas-editor-tabs-group{min-width:140px}button-component#report-issue.sc-nylas-editor-tabs-group{width:auto}nylas-feedback-form.sc-nylas-editor-tabs-group{position:absolute;top:0;height:100%;width:100%;display:flex;flex-direction:column;justify-content:center;align-items:center;background:rgba(0, 0, 0, 0.6);z-index:2;border-radius:inherit}";
const NylasEditorTabsGroupStyle0 = nylasEditorTabsGroupCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
const NylasEditorTabsGroup = proxyCustomElement(class NylasEditorTabsGroup extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.schedulerConfigChanged = createEvent(this, "schedulerConfigChanged", 7);
        this.schedulerConfigCreated = createEvent(this, "schedulerConfigCreated", 7);
        this.cancelButtonClick = createEvent(this, "cancelButtonClick", 7);
        this.formSubmitted = createEvent(this, "formSubmitted", 7);
        this.previewButtonClicked = createEvent(this, "previewButtonClicked", 7);
        this.schedulerEditorFormUpdated = createEvent(this, "schedulerEditorFormUpdated", 7);
        this.groupEventCreateTriggered = createEvent(this, "groupEventCreateTriggered", 7);
        this.groupEventUpdateTriggered = createEvent(this, "groupEventUpdateTriggered", 7);
        this.groupEventDeleteTriggered = createEvent(this, "groupEventDeleteTriggered", 7);
        this.groupEventImportTriggered = createEvent(this, "groupEventImportTriggered", 7);
        this.saveGroupEventChangesError = createEvent(this, "saveGroupEventChangesError", 7);
        this.nylasSchedulerError = createEvent(this, "nylasSchedulerError", 6);
        this.dismissNotification = createEvent(this, "dismissNotification", 6);
        this.formSubmissionHandler = async (event) => {
            event.preventDefault();
            const formEvent = await this.formSubmitted.emit();
            debug('[nylas-editor-tabs-group]', 'formSubmissionHandler', formEvent);
            const valid = this.formRef.checkValidity();
            if (!valid || formEvent.defaultPrevented) {
                await this.host.setError({
                    message: this.formRef.validationMessage || instance.t('fixFormErrors'),
                    type: nr.Error,
                    category: ErrorCategory.Component,
                    title: instance.t('nylasEditorTabs.formErrorTitle'),
                });
                return;
            }
            this.isLoading = true;
            this.hasUnsavedChanges = false;
            const formState = this.updateFormState();
            debug('[nylas-editor-tabs-group]', 'formState', formState);
            const { title, description, bookingCalendar, location, bookingType, minCancellationNotice, minBookingNotice, cancellationPolicy, hideCancellationOptions, hideReschedulingOptions, additionalFields, conferencing, reminders, emailTemplate, redirectUrl, slug, appearance, name, eventCapacity, eventTimeslot, participants, disableEmails, organizerLocale, } = formState;
            const configObject = {
                ...(this.selectedConfiguration?.id && { id: this.selectedConfiguration.id }),
                slug: slug,
                name: name,
                type: this.selectedEventType === CONFIGURATION_EVENT_TYPE.group ? CONFIGURATION_EVENT_TYPE.group : undefined,
                scheduler: {
                    cancellation_policy: cancellationPolicy ?? '',
                    min_cancellation_notice: minCancellationNotice ?? 0,
                    min_booking_notice: minBookingNotice ?? 60,
                    hide_cancellation_options: hideCancellationOptions ?? false,
                    hide_rescheduling_options: hideReschedulingOptions ?? false,
                    additional_fields: additionalFields,
                    email_template: emailTemplate
                        ? {
                            ...emailTemplate,
                            organizer_locale: organizerLocale || 'en',
                            logo: emailTemplate.logo || '',
                        }
                        : undefined,
                    confirmation_redirect_url: redirectUrl,
                },
                appearance: appearance,
                group_booking: {
                    booking_type: bookingType ? bookingType : 'booking',
                    disable_emails: typeof disableEmails === 'boolean' ? disableEmails : false,
                    reminders: reminders,
                    conferencing: conferencing,
                    calendar_id: bookingCalendar || 'primary',
                    default_capacity: eventCapacity || 10,
                },
            };
            const configObjectWithDeveloperSettings = mergeDeep(this.selectedConfiguration, configObject || {});
            const finalConfig = this.action === 'create' ? configObjectWithDeveloperSettings : configObject;
            delete finalConfig.availability;
            delete finalConfig.participants;
            delete finalConfig.event_booking;
            const resetLoadingState = (_e) => {
                this.isLoading = false;
                this.changesSaved = true;
                setTimeout(() => {
                    this.changesSaved = false;
                }, 3000);
            };
            const hasBookingError = this.checkForBookingFormErrors(finalConfig);
            if (hasBookingError) {
                return;
            }
            const organizer = {
                name: this.currentUser?.name ?? this.currentUser?.email ?? '',
                email: this.currentUser?.email ?? '',
            };
            const organizerDefaultCal = this.calendars?.find(c => c.is_primary) ?? this.calendars?.[0];
            const organizerParticipant = [{ ...organizer, is_organizer: true }];
            const groupEvent = !this.selectedConfiguration?.id
                ? {
                    title: title,
                    description: description,
                    location: !conferencing ? location : undefined,
                    conferencing: !location ? conferencing : undefined,
                    when: {
                        start_time: eventTimeslot?.when?.start_time ?? 0,
                        end_time: eventTimeslot?.when?.end_time ?? 0,
                        start_timezone: eventTimeslot?.when?.start_timezone ?? '',
                        end_timezone: eventTimeslot?.when?.end_timezone ?? '',
                    },
                    recurrence: eventTimeslot?.recurrence ?? [],
                    calendar_id: bookingCalendar || organizerDefaultCal?.id || 'primary',
                    participants: participants?.length ? participants : organizerParticipant,
                    organizer: organizer,
                    capacity: eventCapacity || 10,
                }
                : undefined;
            this.schedulerConfigChanged.emit({ groupEvent: groupEvent || undefined, config: finalConfig, resetLoadingState: resetLoadingState, action: this.action, host: this.host });
        };
        this.checkForBookingFormErrors = config => {
            let hasError = false;
            let errorMessage = '';
            const additionalFields = config.scheduler?.additional_fields;
            if (additionalFields) {
                errorMessage = '';
                Object.entries(additionalFields).forEach(entry => {
                    const field = entry[1];
                    if (field.label === '') {
                        errorMessage += instance.t('nylasEditorTabs.bookingFormError_label', { type: field.type });
                        hasError = true;
                        return;
                    }
                    if (field.options) {
                        for (const option of field.options) {
                            if (option.trim() === '') {
                                errorMessage += instance.t('nylasEditorTabs.bookingFormError_option', { label: field.label, type: field.type });
                                hasError = true;
                                break;
                            }
                        }
                    }
                });
            }
            if (hasError) {
                this.isLoading = false;
                this.host.setError({
                    message: errorMessage,
                    type: nr.Error,
                    category: ErrorCategory.Component,
                    title: instance.t('nylasEditorTabs.bookingFormError'),
                });
            }
            return hasError;
        };
        this.calendars = undefined;
        this.selectedConfiguration = undefined;
        this.configurations = undefined;
        this.currentUser = undefined;
        this.schedulerPreviewLink = '';
        this.mode = 'app';
        this.hideEditorTabs = [];
        this.enableUserFeedback = true;
        this.selectedLanguage = undefined;
        this.selectedEventType = undefined;
        this.selectedGroupEvent = undefined;
        this.action = 'create';
        this.showFeedbackModal = false;
        this.activeTab = TabGroup.CalendarView;
        this.isLoading = false;
        this.componentLoaded = false;
        this.hasUnsavedChanges = false;
        this.changesSaved = false;
        this.formState = {};
        this.error = {
            message: '',
            type: nr.Error,
            category: ErrorCategory.Component,
            title: '',
        };
    }
    configChangedHandler(newConfig) {
        debug('[nylas-editor-tabs-group]', 'configChangedHandler', newConfig, this.selectedConfiguration);
        this.formState = {
            ...this.getFormStateFromConfig(newConfig),
        };
        if (newConfig?.id) {
            this.action = 'edit';
        }
        else {
            this.action = 'create';
        }
    }
    selectedGroupEventChangedHandler(newConfig) {
        debug('[nylas-editor-tabs-group]', 'selectedGroupEventChangedHandler', newConfig, this.selectedConfiguration);
        this.formState = {
            ...this.formState,
            title: this.selectedGroupEvent?.event?.title,
            description: this.selectedGroupEvent?.event?.description,
            location: this.selectedGroupEvent?.event?.location,
            conferencing: this.selectedGroupEvent?.event?.conferencing,
            eventCapacity: this.selectedGroupEvent?.group_event_info?.capacity,
            participants: this.selectedGroupEvent?.group_event_info?.participants?.map(participant => ({
                name: participant.name,
                email: participant.email,
                is_organizer: !!participant.is_organizer,
            })),
            eventTimeslot: this.selectedGroupEvent?.event?.when
                ? {
                    when: {
                        start_time: this.selectedGroupEvent?.event?.when?.start_time,
                        end_time: this.selectedGroupEvent?.event?.when?.end_time,
                        start_timezone: this.selectedGroupEvent?.event?.when?.start_timezone,
                        end_timezone: this.selectedGroupEvent?.event?.when?.end_timezone,
                    },
                    recurrence: this.selectedGroupEvent?.group_event_info?.rrule ? this.selectedGroupEvent?.group_event_info?.rrule : [],
                }
                : undefined,
        };
    }
    userChangedHandler(newUser) {
        debug('[nylas-editor-tabs-group]', 'userChangedHandler', newUser);
        if (newUser) {
            this.formState = {
                ...this.getFormStateFromConfig(this.selectedConfiguration),
            };
        }
    }
    selectedLanguageChangedHandler(newVal, oldVal) {
        if (newVal === oldVal)
            return;
        instance.changeLanguage(newVal);
        if (this.error && this.error.message) {
            this.error = {
                ...this.error,
                message: instance.t('fixFormErrors'),
            };
            this.showErrorNotification(this.error);
        }
    }
    async schedulerConfigCreatedEventHandler(data) {
        const event = this.schedulerConfigCreated.emit(data);
        return event;
    }
    async setError(error) {
        this.error = {
            message: error.message,
            type: error.type,
            category: error.category,
            title: error.title || instance.t('genericErrorTitle'),
        };
        if (this.error?.message) {
            this.showErrorNotification(this.error);
        }
    }
    async resetError() {
        if (this.error?.message) {
            this.dismissNotification.emit({ id: this.error?.message.split(' ').join('-'), host: this.host });
        }
        this.error = {
            message: '',
            type: nr.Error,
            category: ErrorCategory.Component,
            title: '',
        };
    }
    connectedCallback() {
        debug('[nylas-editor-tabs-group]', 'connectedCallback');
    }
    componentWillLoad() {
        debug('[nylas-editor-tabs-group]', 'componentWillLoad');
        this.formState = this.getFormStateFromConfig(this.selectedConfiguration);
    }
    componentDidLoad() {
        debug('[nylas-editor-tabs-group]', 'componentDidLoad');
        if (this.enableUserFeedback && !isInitialized()) {
            init({
                dsn: 'https://9d5731f1c77ca84c9ed3fb9b3ccf7ee1@o74852.ingest.us.sentry.io/4507889638178816',
                release: "2.0.1",
                integrations: integrations => [
                    ...integrations.filter(_integration => false),
                    feedbackSyncIntegration({
                        colorScheme: 'system',
                        autoInject: false,
                    }),
                ],
                autoSessionTracking: false,
                beforeSend: () => null,
            });
        }
        if (this.selectedConfiguration?.id) {
            this.configChangedHandler(this.selectedConfiguration);
        }
        const firstVisibleTab = this.host.querySelector('button.tab:not(.hide)')?.name;
        if (firstVisibleTab && this.hideEditorTabs?.includes(this.activeTab)) {
            this.activeTab = firstVisibleTab;
        }
        this.updateFormState();
        this.componentLoaded = true;
    }
    disconnectedCallback() {
        debug('[nylas-editor-tabs-group]', 'disconnectedCallback');
    }
    handleValueChanged(event) {
        debug('[nylas-editor-tabs-group]', 'handleValueChanged', event);
        const { name, value } = event.detail;
        console.log('name', name, 'value', value);
        this.setFormState(value, name);
        this.formState = { ...this.formState };
        if (editorGroupTabComponentNames.includes(name)) {
            this.hasUnsavedChanges = true;
        }
        this.host.resetError();
        this.schedulerEditorFormUpdated.emit({
            value: event.detail.value,
            name: event.detail.name,
        });
    }
    feedbackModalClosedHandler() {
        this.showFeedbackModal = false;
    }
    feedbackSubmittedHandler(event) {
        const eventId = captureMessage('Scheduler Editor User Feedback');
        const feedback = {
            eventId: eventId,
            message: event.detail.feedback,
        };
        captureFeedback(feedback, {
            includeReplay: true,
            captureContext: {
                tags: {
                    'nylas-web-element': 'nylas-scheduler-editor',
                    'nylas-web-element-version': "2.0.1",
                },
                extra: {
                    configId: this.selectedConfiguration?.id,
                    slug: this.selectedConfiguration?.slug,
                },
            },
        });
        this.showFeedbackModal = false;
    }
    importGroupEventHandler(event) {
        this.groupEventImportTriggered.emit({ groupEvent: event.detail, configId: this.selectedConfiguration?.id ?? '', host: this.host });
    }
    saveGroupEventChangesHandler(event) {
        debug('saveGroupEventChangesHandler', event.detail, this.selectedGroupEvent);
        const valid = this.formRef.checkValidity();
        const groupEvent = this.getGroupEventDetailsFromFormState();
        this.resetError();
        if (!groupEvent.title) {
            this.setError({
                message: instance.t('nylasEditorTabsGroup.eventTitleRequired'),
                type: nr.Error,
                category: ErrorCategory.Component,
                title: instance.t('nylasEditorTabs.formErrorTitle'),
            });
        }
        if (!groupEvent.when?.start_time || !groupEvent.when?.end_time) {
            this.setError({
                message: instance.t('nylasEditorTabsGroup.eventTimeRequired'),
                type: nr.Error,
                category: ErrorCategory.Component,
                title: instance.t('nylasEditorTabs.formErrorTitle'),
            });
        }
        if (!groupEvent.participants?.length) {
            this.setError({
                message: instance.t('nylasEditorTabsGroup.participantsRequired'),
                type: nr.Error,
                category: ErrorCategory.Component,
                title: instance.t('nylasEditorTabs.formErrorTitle'),
            });
        }
        if (groupEvent.participants?.length && groupEvent.participants?.some(p => !p.email)) {
            this.setError({
                message: instance.t('nylasEditorTabsGroup.participantEmailRequired'),
                type: nr.Error,
                category: ErrorCategory.Component,
                title: instance.t('nylasEditorTabs.formErrorTitle'),
            });
        }
        if (this.error?.message !== '' || !valid) {
            this.saveGroupEventChangesError.emit({
                error: this.error?.message ?? instance.t('nylasEditorTabsGroup.errorOccured'),
                configId: this.selectedConfiguration?.id ?? '',
                host: this.host,
            });
            return;
        }
        this.groupEventUpdateTriggered.emit({
            groupEvent: groupEvent,
            chosenOption: event.detail.action,
            configId: this.selectedConfiguration?.id ?? '',
            host: this.host,
        });
    }
    deleteGroupEventHandler(event) {
        debug('deleteGroupEventHandler', event.detail);
        const groupEvent = this.getGroupEventDetailsFromFormState();
        this.groupEventDeleteTriggered.emit({
            groupEvent: groupEvent,
            chosenOption: event.detail.action,
            configId: this.selectedConfiguration?.id ?? '',
            host: this.host,
        });
    }
    createGroupEventHandler(event) {
        const formState = event.detail;
        const organizer = {
            name: this.currentUser?.name ?? this.currentUser?.email ?? '',
            email: this.currentUser?.email ?? '',
        };
        const organizerDefaultCal = this.calendars?.find(c => c.is_primary) ?? this.calendars?.[0];
        const conferencing = this.formState?.conferencing || formState.conferencing;
        const groupEvent = {
            title: formState.title,
            description: formState.description,
            location: !conferencing ? formState.location : undefined,
            participants: formState.participants,
            organizer: organizer,
            conferencing: !formState.location ? conferencing : {},
            when: formState.eventTimeslot.when,
            recurrence: formState.eventTimeslot.recurrence,
            calendar_id: organizerDefaultCal?.id || 'primary',
            capacity: formState.eventCapacity,
        };
        this.groupEventCreateTriggered.emit({ groupEvent, configId: this.selectedConfiguration?.id ?? '', host: this.host });
    }
    showErrorNotification(error) {
        this.nylasSchedulerError.emit({
            notification: {
                title: error.title,
                category: error.category || ErrorCategory.Component,
                type: error.type || nr.Error,
                description: error.message,
                id: error.message.split(' ').join('-'),
                ttl: 'none',
            },
            host: this.host,
        });
    }
    getGroupEventDetailsFromFormState() {
        const organizerDefaultCal = this.calendars?.find(c => c.is_primary) ?? this.calendars?.[0];
        const organizer = {
            name: this.currentUser?.name ?? this.currentUser?.email ?? '',
            email: this.currentUser?.email ?? '',
        };
        const participantOrganizer = [{ ...organizer, is_organizer: true }];
        const { title, description, bookingCalendar, location, conferencing, eventCapacity, eventTimeslot, participants } = this.formState;
        return {
            title: title,
            description: description,
            location: !conferencing ? location : undefined,
            conferencing: !location ? conferencing : undefined,
            when: {
                start_time: eventTimeslot?.when?.start_time ?? 0,
                end_time: eventTimeslot?.when?.end_time ?? 0,
                start_timezone: eventTimeslot?.when?.start_timezone ?? '',
                end_timezone: eventTimeslot?.when?.end_timezone ?? '',
            },
            recurrence: eventTimeslot?.recurrence ?? [],
            calendar_id: bookingCalendar || organizerDefaultCal?.id || 'primary',
            participants: participants?.length ? participants : participantOrganizer,
            organizer: organizer,
            capacity: eventCapacity || 10,
        };
    }
    getFormStateFromConfig(config) {
        if (config?.appearance) {
            console.info('Appearance settings have been returned from the given configuration; please remember to grab them from the configSettingsLoaded event and apply them as desired.');
        }
        return {
            additionalFields: config?.scheduler?.additional_fields ?? {},
            bookingType: config?.group_booking?.booking_type ?? 'booking',
            cancellationPolicy: config?.scheduler?.cancellation_policy ?? '',
            minCancellationNotice: config?.scheduler?.min_cancellation_notice ?? 0,
            minBookingNotice: config?.scheduler?.min_booking_notice ?? 60,
            hideCancellationOptions: config?.scheduler?.hide_cancellation_options ?? false,
            hideReschedulingOptions: config?.scheduler?.hide_rescheduling_options ?? false,
            reminders: config?.group_booking?.reminders,
            emailTemplate: config?.scheduler?.email_template,
            redirectUrl: config?.scheduler?.confirmation_redirect_url,
            slug: config?.slug,
            appearance: config?.appearance,
            name: config?.name,
            bookingCalendar: config?.group_booking?.calendar_id,
            disableEmails: config?.group_booking?.disable_emails,
            organizerLocale: config?.scheduler?.email_template?.organizer_locale,
        };
    }
    setFormState(value, key) {
        switch (key) {
            case 'title':
                this.formState.title = value.toString();
                break;
            case 'description':
                this.formState.description = value.toString();
                break;
            case 'location':
                this.formState.location = value.toString();
                break;
            case 'conference':
                this.formState.conferencing = JSON.parse(value.toString());
                break;
            case 'confirmation-type':
                this.formState.bookingType = value.toString();
                break;
            case 'min-cancellation-notice':
                this.formState.minCancellationNotice = parseInt(value.toString());
                break;
            case 'min-booking-notice':
                this.formState.minBookingNotice = parseInt(value.toString());
                break;
            case 'cancellation-policy':
                this.formState.cancellationPolicy = value.toString();
                break;
            case 'customize-booking-settings': {
                const settings = JSON.parse(value.toString());
                this.formState.hideCancellationOptions = settings.hideCancellationOptions;
                this.formState.hideReschedulingOptions = settings.hideReschedulingOptions;
                break;
            }
            case 'booking-calendar':
                this.formState.bookingCalendar = value.toString();
                break;
            case 'event-capacity':
                this.formState.eventCapacity = parseInt(String(value));
                break;
            case 'additional-fields':
                this.formState.additionalFields = JSON.parse(value.toString());
                break;
            case 'confirmation-email-template':
                this.formState.emailTemplate = JSON.parse(value.toString());
                break;
            case 'reminder-overrides':
                this.formState.reminders = JSON.parse(value.toString());
                break;
            case 'confirmation-redirect':
                this.formState.redirectUrl = value.toString();
                break;
            case 'custom-event-slug':
                console.debug('custom-event-slug', value);
                this.formState.slug = JSON.parse(value.toString());
                break;
            case 'page-styling':
                this.formState.appearance = JSON.parse(value.toString());
                break;
            case 'page-name':
                this.formState.name = JSON.parse(value.toString());
                break;
            case 'participants': {
                const participants = JSON.parse(value.toString());
                this.formState.participants = participants.map(participant => ({
                    name: participant.name,
                    email: participant.email,
                    is_organizer: participant.is_organizer,
                }));
                break;
            }
            case 'event-timeslot':
                this.formState.eventTimeslot = JSON.parse(value.toString());
                break;
            case 'disable-emails': {
                const { disableEmails, organizerLocale } = JSON.parse(value.toString());
                this.formState.disableEmails = disableEmails;
                this.formState.organizerLocale = organizerLocale;
                break;
            }
        }
        this.schedulerEditorFormUpdated.emit({
            value,
            name: key,
        });
    }
    updateFormState() {
        const formData = new FormData(this.formRef);
        formData.forEach((value, key) => {
            this.setFormState(value, key);
        });
        this.formState = { ...this.formState };
        return this.formState;
    }
    setActiveTab(e, tabName) {
        e.preventDefault();
        this.updateFormState();
        this.activeTab = tabName;
    }
    hideTab(tab) {
        return this.hideEditorTabs?.includes(tab) || false;
    }
    onFeedbackClick(e) {
        e.preventDefault();
        this.showFeedbackModal = true;
    }
    render() {
        debug('[nylas-editor-tabs-group]', 'render', this.formState);
        return (h(Host, { key: 'f1f9489924f24e9e70b03f29ca492f952447857e' }, h("nylas-notification", { key: '55313223571d2279f7371dee53422b682484a8f0' }), h("form", { key: '127ab3460883730d9519df3995e12a29375cf3c5', onSubmit: this.formSubmissionHandler, class: "scheduler-editor", ref: el => (this.formRef = el), noValidate: true }, this.mode === 'app' ? (h("div", { class: "return-to-calendar-view", part: "editor__return-to-calendar-view net__return-to-calendar-view" }, h("button-component", { id: "return-to-calendar-view-button", variant: "invisible", part: "nset__header__back-button", type: "button", onClick: e => {
                this.setActiveTab(e, TabGroup.CalendarView);
            } }, h("chevron-icon", { width: "16", height: "16" }), h("span", null, instance.t('returnToCalendarView'))))) : null, this.mode === 'app' ? (h("div", { class: "form-contents", part: "editor__form-contents net__form-contents" }, h("div", { class: "tabs", part: "editor__tabs net__tabs" }, h("button", { name: TabGroup.BookingOptions, class: { tab: true, active: this.activeTab == TabGroup.BookingOptions, hide: this.hideTab(TabGroup.BookingOptions) }, part: "editortab__booking-options net__tab-booking-options", onClick: e => this.setActiveTab(e, TabGroup.BookingOptions) }, h("flow-icon", { width: "16", height: "16" }), instance.t('bookingOptionsTab')), h("button", { name: TabGroup.BookingForm, class: { tab: true, active: this.activeTab == TabGroup.BookingForm, hide: this.hideTab(TabGroup.BookingForm) }, part: "editortab__booking-form net__tab-booking-form", onClick: e => this.setActiveTab(e, TabGroup.BookingForm) }, this.activeTab == TabGroup.BookingForm ? h("calendar-agenda-fill-icon", { width: "16", height: "16" }) : h("calendar-agenda-icon", { width: "16", height: "16" }), instance.t('bookingFormTab')), h("button", { name: TabGroup.Communications, class: { tab: true, active: this.activeTab == TabGroup.Communications, hide: this.hideTab(TabGroup.Communications) }, onClick: e => this.setActiveTab(e, TabGroup.Communications), part: "editortab__communications net__tab-communications" }, this.activeTab == TabGroup.Communications ? h("envelope-fill-icon", { width: "16", height: "16" }) : h("envelope-icon", { width: "16", height: "16" }), instance.t('communicationsTab')), h("button", { name: TabGroup.PageStyles, class: { tab: true, active: this.activeTab == TabGroup.PageStyles, hide: this.hideTab(TabGroup.PageStyles) }, onClick: e => this.setActiveTab(e, TabGroup.PageStyles), part: "editortab__page-styles net__tab-page-styles" }, this.activeTab == TabGroup.PageStyles ? h("paintbrush-fill-icon", { width: "16", height: "16" }) : h("paintbrush-icon", { width: "16", height: "16" }), instance.t('pageStylesTab'))), h("div", { class: "tab-content", part: "editor__tab-content net__tab-content" }, h(TabContentsGroup, { formState: this.formState, activeTab: this.activeTab, currentUser: this.currentUser, calendars: this.calendars, id: this.selectedConfiguration?.id ?? 'new', i18next: instance })))) : (h("div", { class: "composable", key: this.selectedConfiguration?.id }, h("slot", null))), h("div", { key: '58a9ed32c7fde8663e25a05461e7dbbe8bc3d879', class: "footer", part: "editor__footer net__footer" }, h("div", { key: 'dddf1ddc9b444fc7f8f8f965d1a84a87678a9fa8', class: "preview", part: "editor__footer-preview net__footer-preview" }, this.enableUserFeedback && (h("button-component", { title: "Share your feedback", id: "report-issue", variant: 'basic', onClick: e => this.onFeedbackClick(e) }, h("feedback-icon", null))), this.activeTab === TabGroup.CalendarView && (h("button-component", { class: "page-settings-button", title: "Go to page settings", id: "page-settings", variant: 'basic', onClick: e => this.setActiveTab(e, TabGroup.BookingOptions) }, instance.t('pageSettingsButton')))), h("div", { key: 'be3ea7e9a341b7495d32c076505462b5845b1c66', class: "buttons", part: "editor__footer-buttons net__footer-buttons" }, h("p", { key: '42bf3aaae3eb30d443d4b45b1be81100eb95ac23', class: {
                'unsaved-changes': this.hasUnsavedChanges && !this.changesSaved,
                'saved-changes': this.changesSaved,
                'error': this.error?.message !== '',
                'error-full-width': this.error?.message !== '' && this.action === 'create',
            } }, this.error?.message == '' && this.hasUnsavedChanges && !this.changesSaved && this.activeTab !== TabGroup.CalendarView
            ? instance.t('unsavedChangesLabel')
            : this.error?.message == '' && this.changesSaved
                ? `${instance.t('changesSavedLabel')}!`
                : ''), h("div", { key: '6380b051bd4bc445092fd71be43e949c12629cd7', class: "footer-buttons__row" }, this.schedulerPreviewLink !== '' && this.action === 'edit' && (h("button-component", { title: "Preview", type: "button", disabled: this.isLoading, clickHandler: event => {
                event.preventDefault();
                const previewEvent = this.previewButtonClicked.emit(this.host);
                if (!previewEvent.defaultPrevented) {
                    window.open(parsePreviewLink(this.schedulerPreviewLink, this.selectedConfiguration), '_blank');
                }
            }, variant: 'basic' }, h("eye-icon", null))), h("button-component", { key: 'b78b23bc721251da33f803a46e23b66cea112095', type: "button", disabled: this.isLoading, clickHandler: event => {
                event.preventDefault();
                this.cancelButtonClick.emit();
                this.host.resetError();
            }, variant: 'basic', part: "editor__footer-cancel net__footer-cancel" }, instance.t('backButton')), h("button-component", { key: 'aaefcecf3c7247c085813831066bf79298b17263', class: { 'save-changes': this.action === 'edit' }, type: "submit", disabled: this.isLoading, part: "editor__footer-cta, net__footer-cta" }, !this.componentLoaded ? (h("span", null, h("loading-icon", null), ' ')) : this.isLoading ? (h("span", null, instance.t('savingButtonText'), h("loading-icon", null), ' ')) : this.action === 'create' ? (`${instance.t('createButtonText')}`) : (`${instance.t('saveChangesButtonText')}`)))))), this.showFeedbackModal && h("nylas-feedback-form", null)));
    }
    get host() { return this; }
    static get watchers() { return {
        "selectedConfiguration": ["configChangedHandler"],
        "selectedGroupEvent": ["selectedGroupEventChangedHandler"],
        "currentUser": ["userChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }; }
    static get style() { return NylasEditorTabsGroupStyle0; }
}, [6, "nylas-editor-tabs-group", {
        "calendars": [16],
        "selectedConfiguration": [16],
        "configurations": [16],
        "currentUser": [16],
        "schedulerPreviewLink": [1, "scheduler-preview-link"],
        "mode": [1],
        "hideEditorTabs": [16],
        "enableUserFeedback": [4, "enable-user-feedback"],
        "selectedLanguage": [1, "selected-language"],
        "selectedEventType": [1, "selected-event-type"],
        "selectedGroupEvent": [16],
        "action": [32],
        "showFeedbackModal": [32],
        "activeTab": [32],
        "isLoading": [32],
        "componentLoaded": [32],
        "hasUnsavedChanges": [32],
        "changesSaved": [32],
        "formState": [32],
        "error": [32],
        "schedulerConfigCreatedEventHandler": [64],
        "setError": [64],
        "resetError": [64]
    }, [[0, "valueChanged", "handleValueChanged"], [0, "feedbackModalClosed", "feedbackModalClosedHandler"], [0, "feedbackSubmitted", "feedbackSubmittedHandler"], [0, "importGroupEvent", "importGroupEventHandler"], [0, "saveGroupEventChanges", "saveGroupEventChangesHandler"], [0, "deleteGroupEvent", "deleteGroupEventHandler"], [0, "createGroupEvent", "createGroupEventHandler"]], {
        "selectedConfiguration": ["configChangedHandler"],
        "selectedGroupEvent": ["selectedGroupEventChangedHandler"],
        "currentUser": ["userChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }]);
__decorate([
    RegisterComponent({
        name: 'nylas-editor-tabs-group',
        stateToProps: new Map([
            ['schedulerConfig.calendars', 'calendars'],
            ['schedulerConfig.selectedConfiguration', 'selectedConfiguration'],
            ['schedulerConfig.currentUser', 'currentUser'],
            ['schedulerConfig.configurations', 'configurations'],
            ['schedulerConfig.selectedLanguage', 'selectedLanguage'],
            ['schedulerConfig.selectedEventType', 'selectedEventType'],
            ['schedulerConfig.selectedGroupEvent', 'selectedGroupEvent'],
        ]),
        eventToProps: {
            schedulerConfigChanged: async (event, nylasSchedulerConfigConnector) => {
                const { resetLoadingState, host, action, config, groupEvent } = event.detail;
                const checkForErrors = (response, errorTitle) => {
                    const [data, error] = response;
                    if (!data && error) {
                        host.setError({
                            message: error.message || instance.t('genericErrorTitle'),
                            type: nr.Error,
                            category: ErrorCategory.Component,
                            title: errorTitle,
                        });
                    }
                    else if (data && !error && action === 'create') {
                        host.schedulerConfigCreatedEventHandler({ config: data, action, host });
                    }
                };
                if (action === 'edit') {
                    const response = await nylasSchedulerConfigConnector.schedulerConfig.updateConfiguration(config);
                    checkForErrors(response, instance.t('nylasEditorTabs.updateConfigurationError'));
                    if (resetLoadingState) {
                        resetLoadingState(event);
                    }
                }
                else {
                    const response = await nylasSchedulerConfigConnector.schedulerConfig.createConfiguration(config);
                    checkForErrors(response, instance.t('nylasEditorTabs.createConfigurationError'));
                    const [data, _error] = response;
                    const configId = data?.id;
                    if (configId && groupEvent) {
                        const eventResponse = await nylasSchedulerConfigConnector.schedulerConfig.createGroupEvent(groupEvent, configId);
                        checkForErrors(eventResponse, instance.t('nylasEditorTabsGroup.createGroupEventError'));
                    }
                    if (resetLoadingState) {
                        resetLoadingState(event);
                    }
                }
            },
            cancelButtonClick: async (_, nylasSchedulerConfigConnector) => {
                nylasSchedulerConfigConnector.schedulerConfigStore.state.action = null;
                nylasSchedulerConfigConnector.schedulerConfigStore.set('selectedEventType', undefined);
                nylasSchedulerConfigConnector.schedulerConfigStore.set('selectedGroupEvent', undefined);
                nylasSchedulerConfigConnector.schedulerConfigStore.set('groupEvents', []);
            },
            previewButtonClicked: async (_, nylasSchedulerConfigConnector) => {
                debug('[nylas-editor-tabs-group]', 'previewButtonClicked', nylasSchedulerConfigConnector);
            },
            formSubmitted: async (_, nylasSchedulerConfigConnector) => {
                debug('[nylas-editor-tabs-group]', 'formSubmitted', nylasSchedulerConfigConnector);
            },
            schedulerEditorFormUpdated: async (event, _nylasSchedulerConfigConnector) => {
                debug('[nylas-editor-tabs-group]', 'schedulerEditorFormUpdated', event);
            },
            schedulerConfigCreated: async (event, _nylasSchedulerConfigConnector) => {
                debug('[nylas-editor-tabs-group]', 'schedulerConfigCreated', event);
            },
            groupEventUpdateTriggered: async (event, nylasSchedulerConfigConnector) => {
                const { groupEvent, host, chosenOption, configId } = event.detail;
                const response = await nylasSchedulerConfigConnector.schedulerConfig.updateGroupEvent(groupEvent, chosenOption, configId);
                const [data, error] = response;
                if (!data && error) {
                    host.setError({
                        message: error.message || instance.t('genericErrorTitle'),
                        type: nr.Error,
                        category: ErrorCategory.Component,
                        title: instance.t('nylasEditorTabsGroup.updateGroupEventError'),
                    });
                }
            },
            groupEventDeleteTriggered: async (event, nylasSchedulerConfigConnector) => {
                const { groupEvent, chosenOption, configId, host } = event.detail;
                const response = await nylasSchedulerConfigConnector.schedulerConfig.deleteGroupEvent(groupEvent, chosenOption, configId);
                const [data, error] = response;
                if (!data && error) {
                    host.setError({
                        message: error.message || instance.t('genericErrorTitle'),
                        type: nr.Error,
                        category: ErrorCategory.Component,
                        title: instance.t('nylasEditorTabsGroup.deleteGroupEventError'),
                    });
                }
            },
            groupEventCreateTriggered: async (event, nylasSchedulerConfigConnector) => {
                const { groupEvent, configId, host } = event.detail;
                const response = await nylasSchedulerConfigConnector.schedulerConfig.createGroupEvent(groupEvent, configId);
                const [data, error] = response;
                if (!data && error) {
                    host.setError({
                        message: error.message || instance.t('genericErrorTitle'),
                        type: nr.Error,
                        category: ErrorCategory.Component,
                        title: instance.t('nylasEditorTabsGroup.createGroupEventError'),
                    });
                }
            },
            groupEventImportTriggered: async (event, nylasSchedulerConfigConnector) => {
                const { groupEvent, configId, host } = event.detail;
                const response = await nylasSchedulerConfigConnector.schedulerConfig.importGroupEvent([groupEvent], configId);
                const [data, error] = response;
                if (!data && error) {
                    host.setError({
                        message: error.message || instance.t('genericErrorTitle'),
                        type: nr.Error,
                        category: ErrorCategory.Component,
                        title: instance.t('nylasEditorTabsGroup.importGroupEventError'),
                    });
                }
                if (data && data.import_failed && data.import_failed.length > 0) {
                    const errorMessage = data.import_failed.map(failedEvent => failedEvent.reason).join('\n');
                    host.setError({
                        message: errorMessage,
                        type: nr.Error,
                        category: ErrorCategory.Component,
                        title: instance.t('nylasEditorTabsGroup.importGroupEventError'),
                    });
                    setTimeout(() => {
                        host.resetError();
                    }, 5000);
                }
            },
            saveGroupEventChangesError: async (event, _nylasSchedulerConfigConnector) => {
                const { error, host } = event.detail;
                debug('[nylas-editor-tabs-group]', 'saveGroupEventChangesError', error, host);
            },
        },
        localPropsToProp: new Map([
            ['schedulerPreviewLink', 'schedulerPreviewLink'],
            ['enableUserFeedback', 'enableUserFeedback'],
            ['hideEditorTabs', 'hideEditorTabs'],
        ]),
        fireRegisterEvent: true,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NylasEditorTabsGroup.prototype, "render", null);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["nylas-editor-tabs-group", "add-circle-icon", "button-component", "calendar-agenda-fill-icon", "calendar-agenda-icon", "checkbox-component", "checkbox-group", "checkmark-icon", "chevron-icon", "clock-icon", "close-icon", "copy-icon", "dragable-icon", "edit-icon", "envelope-fill-icon", "envelope-icon", "eye-icon", "feedback-icon", "flow-icon", "globe-icon", "google-meet-icon", "info-icon", "input-color-picker", "input-component", "input-dropdown", "input-image-url", "loading-icon", "location-icon", "location-off-icon", "microsoft-teams-icon", "multi-select-dropdown", "nylas-additional-participants", "nylas-booking-confirmation-redirect", "nylas-booking-confirmation-type", "nylas-booking-form-config", "nylas-cancellation-policy", "nylas-confirmation-email", "nylas-custom-booking-flow", "nylas-custom-event-slug", "nylas-customize-booking-settings", "nylas-date-component", "nylas-disable-emails", "nylas-event-calendar", "nylas-event-capacity", "nylas-event-description", "nylas-event-info", "nylas-event-limits", "nylas-event-location", "nylas-event-timeslot", "nylas-event-title", "nylas-feedback-form", "nylas-form-card", "nylas-min-booking-notice", "nylas-min-cancellation-notice", "nylas-notification", "nylas-page-name", "nylas-page-styling", "nylas-reminder-emails", "nylas-reminder-time", "nylas-scheduling-method", "nylas-time-window-picker", "paintbrush-fill-icon", "paintbrush-icon", "person-clipboard-icon", "plus-icon", "search-icon", "select-dropdown", "textarea-component", "time-period-selector", "toggle-switch", "tooltip-component", "translate-icon", "trash-icon", "warning-icon", "zoom-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "nylas-editor-tabs-group":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, NylasEditorTabsGroup);
            }
            break;
        case "add-circle-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$1a();
            }
            break;
        case "button-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$19();
            }
            break;
        case "calendar-agenda-fill-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$18();
            }
            break;
        case "calendar-agenda-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$17();
            }
            break;
        case "checkbox-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$16();
            }
            break;
        case "checkbox-group":
            if (!customElements.get(tagName)) {
                defineCustomElement$15();
            }
            break;
        case "checkmark-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$14();
            }
            break;
        case "chevron-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$13();
            }
            break;
        case "clock-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$12();
            }
            break;
        case "close-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$11();
            }
            break;
        case "copy-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$10();
            }
            break;
        case "dragable-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$$();
            }
            break;
        case "edit-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$_();
            }
            break;
        case "envelope-fill-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$Z();
            }
            break;
        case "envelope-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$Y();
            }
            break;
        case "eye-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$X();
            }
            break;
        case "feedback-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$W();
            }
            break;
        case "flow-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$V();
            }
            break;
        case "globe-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$U();
            }
            break;
        case "google-meet-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$T();
            }
            break;
        case "info-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$S();
            }
            break;
        case "input-color-picker":
            if (!customElements.get(tagName)) {
                defineCustomElement$R();
            }
            break;
        case "input-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$Q();
            }
            break;
        case "input-dropdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$P();
            }
            break;
        case "input-image-url":
            if (!customElements.get(tagName)) {
                defineCustomElement$O();
            }
            break;
        case "loading-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$N();
            }
            break;
        case "location-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$M();
            }
            break;
        case "location-off-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$L();
            }
            break;
        case "microsoft-teams-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$K();
            }
            break;
        case "multi-select-dropdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$J();
            }
            break;
        case "nylas-additional-participants":
            if (!customElements.get(tagName)) {
                defineCustomElement$I();
            }
            break;
        case "nylas-booking-confirmation-redirect":
            if (!customElements.get(tagName)) {
                defineCustomElement$H();
            }
            break;
        case "nylas-booking-confirmation-type":
            if (!customElements.get(tagName)) {
                defineCustomElement$G();
            }
            break;
        case "nylas-booking-form-config":
            if (!customElements.get(tagName)) {
                defineCustomElement$F();
            }
            break;
        case "nylas-cancellation-policy":
            if (!customElements.get(tagName)) {
                defineCustomElement$E();
            }
            break;
        case "nylas-confirmation-email":
            if (!customElements.get(tagName)) {
                defineCustomElement$D();
            }
            break;
        case "nylas-custom-booking-flow":
            if (!customElements.get(tagName)) {
                defineCustomElement$C();
            }
            break;
        case "nylas-custom-event-slug":
            if (!customElements.get(tagName)) {
                defineCustomElement$B();
            }
            break;
        case "nylas-customize-booking-settings":
            if (!customElements.get(tagName)) {
                defineCustomElement$A();
            }
            break;
        case "nylas-date-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$z();
            }
            break;
        case "nylas-disable-emails":
            if (!customElements.get(tagName)) {
                defineCustomElement$y();
            }
            break;
        case "nylas-event-calendar":
            if (!customElements.get(tagName)) {
                defineCustomElement$x();
            }
            break;
        case "nylas-event-capacity":
            if (!customElements.get(tagName)) {
                defineCustomElement$w();
            }
            break;
        case "nylas-event-description":
            if (!customElements.get(tagName)) {
                defineCustomElement$v();
            }
            break;
        case "nylas-event-info":
            if (!customElements.get(tagName)) {
                defineCustomElement$u();
            }
            break;
        case "nylas-event-limits":
            if (!customElements.get(tagName)) {
                defineCustomElement$t();
            }
            break;
        case "nylas-event-location":
            if (!customElements.get(tagName)) {
                defineCustomElement$s();
            }
            break;
        case "nylas-event-timeslot":
            if (!customElements.get(tagName)) {
                defineCustomElement$r();
            }
            break;
        case "nylas-event-title":
            if (!customElements.get(tagName)) {
                defineCustomElement$q();
            }
            break;
        case "nylas-feedback-form":
            if (!customElements.get(tagName)) {
                defineCustomElement$p();
            }
            break;
        case "nylas-form-card":
            if (!customElements.get(tagName)) {
                defineCustomElement$o();
            }
            break;
        case "nylas-min-booking-notice":
            if (!customElements.get(tagName)) {
                defineCustomElement$n();
            }
            break;
        case "nylas-min-cancellation-notice":
            if (!customElements.get(tagName)) {
                defineCustomElement$m();
            }
            break;
        case "nylas-notification":
            if (!customElements.get(tagName)) {
                defineCustomElement$l();
            }
            break;
        case "nylas-page-name":
            if (!customElements.get(tagName)) {
                defineCustomElement$k();
            }
            break;
        case "nylas-page-styling":
            if (!customElements.get(tagName)) {
                defineCustomElement$j();
            }
            break;
        case "nylas-reminder-emails":
            if (!customElements.get(tagName)) {
                defineCustomElement$i();
            }
            break;
        case "nylas-reminder-time":
            if (!customElements.get(tagName)) {
                defineCustomElement$h();
            }
            break;
        case "nylas-scheduling-method":
            if (!customElements.get(tagName)) {
                defineCustomElement$g();
            }
            break;
        case "nylas-time-window-picker":
            if (!customElements.get(tagName)) {
                defineCustomElement$f();
            }
            break;
        case "paintbrush-fill-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$e();
            }
            break;
        case "paintbrush-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$d();
            }
            break;
        case "person-clipboard-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$c();
            }
            break;
        case "plus-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$b();
            }
            break;
        case "search-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$a();
            }
            break;
        case "select-dropdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$9();
            }
            break;
        case "textarea-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$8();
            }
            break;
        case "time-period-selector":
            if (!customElements.get(tagName)) {
                defineCustomElement$7();
            }
            break;
        case "toggle-switch":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "tooltip-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "translate-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "trash-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "warning-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "zoom-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { NylasEditorTabsGroup as N, defineCustomElement as d };

//# sourceMappingURL=nylas-editor-tabs-group2.js.map