import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { R as RegisterComponent } from './register-component.js';
import { a as debug, b as instance } from './utils.js';
import { d as defineCustomElement$3 } from './info.js';
import { d as defineCustomElement$2 } from './input-component2.js';
import { d as defineCustomElement$1 } from './toolitp-component.js';

const nylasEventCapacityCss = ":host{display:block;--nylas-primary:#2563eb;--nylas-error:#cc4841;--nylas-error-pressed:#992222;--nylas-wraning:#f06c00;--nylas-success:#16a392;--nylas-info:#2b8fc2;--nylas-base-0:#ffffff;--nylas-base-25:#fcfcfd;--nylas-base-50:#f8f9fc;--nylas-base-100:#eaecf5;--nylas-base-200:#d5d9eb;--nylas-base-300:#b3b8d8;--nylas-base-400:#717bbc;--nylas-base-500:#4e5ba6;--nylas-base-600:#3e4784;--nylas-base-700:#263f72;--nylas-base-800:#293056;--nylas-base-900:#101323;--nylas-base-950:#0e101b;--nylas-color-blue-100:#e0e6f9;--nylas-border-radius:0.25rem;--nylas-border-radius-2x:0.5rem;--nylas-border-radius-3x:0.75rem;--nylas-font-family:\"Inter\", sans-serif;--nylas-color-black:#000000;--nylas-color-grey-900:#2c2c2c;--nylas-color-grey-800:#4b4b4b;--nylas-color-grey-700:#6e6e6e;--nylas-color-grey-600:#8e8e8e;--nylas-color-grey-500:#b3b3b3;--nylas-color-grey-400:#cacaca;--nylas-color-grey-300:#e1e1e1;--nylas-color-grey-200:#eaeaea;--nylas-color-grey-100:#f5f5f5;--nylas-color-grey-50:#fbfcfe;--nylas-color-white:#ffffff;--nylas-color-red-900:#992222;--nylas-color-red-700:#cc4841;--nylas-color-red-500:#ff786a;--nylas-color-red-300:#ffa79e;--nylas-color-red-100:#ffc5bf;--nylas-color-red-50:#ffeae8;--nylas-color-blue-900:#213571;--nylas-color-blue-700:#314fa9;--nylas-color-blue-500:#4169e1;--nylas-color-blue-300:#bdccf9;--nylas-color-blue-100:#e0e6f9;--nylas-color-blue-50:#f6f8fd;--nylas-color-yellow-900:#7c6506;--nylas-color-yellow-700:#c29f09;--nylas-color-yellow-500:#f7c90b;--nylas-color-yellow-300:#f9de70;--nylas-color-yellow-100:#fceba9;--nylas-color-yellow-50:#fdf4ce;--nylas-color-green-900:#0e6b60;--nylas-color-green-700:#16a392;--nylas-color-green-500:#17c3b2;--nylas-color-green-300:#74dbd1;--nylas-color-green-100:#a2e7e0;--nylas-color-green-50:#d1f3f0;--nylas-color-purple-900:#643554;--nylas-color-purple-700:#954f7d;--nylas-color-purple-500:#c769a7;--nylas-color-purple-300:#dda5ca;--nylas-color-purple-100:#e0bdd6;--nylas-color-purple-50:#e9dde5;--nylas-color-sky-900:#20698f;--nylas-color-sky-700:#2b8fc2;--nylas-color-sky-500:#6dceff;--nylas-color-sky-300:#8fdaff;--nylas-color-sky-100:#b8e7ff;--nylas-color-sky-50:#d9f2ff;width:inherit}.nylas-event-capacity{display:flex;flex-direction:column;gap:4px}.nylas-event-capacity label{display:flex;align-items:center;gap:4px;color:var(--nylas-base-800);font-size:16px;font-style:normal;font-weight:400;line-height:150%;}.nylas-event-capacity label span.required{color:var(--nylas-error, #cc4841)}.nylas-event-capacity label span.label-icon{margin-left:4px}.nylas-event-capacity label span.label-icon tooltip-component{display:flex}.nylas-event-capacity label tooltip-component::part(tc__content){left:50px}.nylas-event-capacity__wrapper{display:flex;align-items:center;gap:0.5rem}.nylas-event-capacity__wrapper input-component{width:auto}.nylas-event-capacity__wrapper input-component::part(ic__input){border-width:1;border-radius:8px;border:1px solid var(--nylas-base-200);font-family:var(--nylas-font-family);font-size:16px;line-height:24px;width:80px}.nylas-event-capacity__wrapper input-component::part(ic__input--error){border:1px solid var(--nylas-error)}.nylas-event-capacity__wrapper input-component::part(ic__label--error){position:relative;margin-bottom:24px}.nylas-event-capacity__wrapper input-component::part(ic__error_message){position:absolute;top:54px;width:max-content}.nylas-event-capacity__wrapper span.attendees.error{margin-top:-24px}";
const NylasEventCapacityStyle0 = nylasEventCapacityCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
const NylasEventCapacity = proxyCustomElement(class NylasEventCapacity extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.valueChanged = createEvent(this, "valueChanged", 7);
        this.internals = this.attachInternals();
        this.name = 'event-capacity';
        this.capacity = undefined;
        this.selectedLanguage = undefined;
        this.selectedEventCapacity = undefined;
        this.error = '';
    }
    connectedCallback() {
        debug('nylas-event-capacity', 'connectedCallback');
    }
    disconnectedCallback() {
        debug('nylas-event-capacity', 'disconnectedCallback');
    }
    componentWillLoad() {
        debug('nylas-event-capacity', 'componentWillLoad');
        this.host.setAttribute('name', this.name);
    }
    componentDidLoad() {
        debug('nylas-event-capacity', 'componentDidLoad');
        this.selectedEventCapacity = this.capacity || 10;
        console.log('selectedEventCapacity', this.selectedEventCapacity);
        this.internals.setFormValue(this.selectedEventCapacity.toString(), this.name);
    }
    componentWillUpdate() {
        debug('nylas-event-capacity', 'componentWillUpdate');
    }
    componentDidUpdate() {
        debug('nylas-event-capacity', 'componentDidUpdate');
    }
    componentWillRender() {
        debug('nylas-event-capacity', 'componentWillRender');
    }
    componentDidRender() {
        debug('nylas-event-capacity', 'componentDidRender');
    }
    elementNameChangedHandler(newValue) {
        debug('nylas-event-capacity', 'elementNameChangedHandler', newValue);
        this.host.setAttribute('name', newValue);
    }
    selectedLanguageChangedHandler(newVal, oldVal) {
        if (newVal === oldVal)
            return;
        instance.changeLanguage(newVal);
    }
    async nylasFormInputChangeHandler(event) {
        const { name, value } = event.detail;
        if (name === 'event-capacity') {
            const parsedValue = parseInt(value);
            if (parsedValue < 1 || parsedValue > 500 || isNaN(parsedValue)) {
                this.error = instance.t('fixFormErrors');
                this.internals.setValidity({ customError: true }, this.error);
                this.valueChanged.emit({ value: value.toString(), name: this.name });
                return;
            }
            this.error = '';
            this.internals.setValidity({ customError: false }, '');
            this.selectedEventCapacity = parseInt(value);
            this.internals.setFormValue(value.toString(), this.name);
            this.valueChanged.emit({ value: value.toString(), name: this.name });
        }
    }
    render() {
        const isComponentReady = typeof this.selectedEventCapacity !== 'undefined';
        return (h(Host, { key: 'a5f7f13597235b6cafcb8201960bafe720c937bc' }, h("div", { key: '7565faeeb192bb44d1ccf2483c6b1e4590b48876', class: "nylas-event-capacity", part: "necapacity" }, h("label", { key: 'd46746e76bdc2daef8302602efd123cf676e8c9e', htmlFor: "event-capacity" }, h("span", { key: 'f6e17aac8d8f378a22de076378be2b7c3dbda4be' }, instance.t('nylasEventCapacity.headerTitle'), h("span", { key: '382366c5d94050870b88316216c6c64077561ddd', class: "required" }, "*")), h("tooltip-component", { key: 'f2122314aec576da8ca7723ddd7672311aed2d4e' }, h("info-icon", { key: 'bbfd875ee167603721e872f15fb83d12c371fa1d', slot: "tooltip-icon" }), h("span", { key: '49cd6598f2835f251cc0d34aa83065a0fb773e6a', slot: "tooltip-content" }, instance.t('nylasEventCapacity.tooltip.desc')))), isComponentReady && (h("div", { class: "nylas-event-capacity__wrapper" }, h("input-component", { name: "event-capacity", id: "event-capacity", type: "number", pattern: /^[0-9]*$/, patternError: instance.t('invalidInputFormat', { field: 'Event capacity' }), minValue: 1, maxValue: 500, required: false, exportparts: "ic_input: necapacity__input-textfield", defaultValue: typeof this.selectedEventCapacity === 'number' ? this.selectedEventCapacity.toString() : '10' }), h("span", { class: this.error ? 'attendees error' : 'attendees' }, instance.t('nylasEventCapacity.attendees')))))));
    }
    static get formAssociated() { return true; }
    get host() { return this; }
    static get watchers() { return {
        "name": ["elementNameChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }; }
    static get style() { return NylasEventCapacityStyle0; }
}, [65, "nylas-event-capacity", {
        "name": [1],
        "capacity": [2],
        "selectedLanguage": [1, "selected-language"],
        "selectedEventCapacity": [32],
        "error": [32]
    }, [[0, "nylasFormInputChanged", "nylasFormInputChangeHandler"]], {
        "name": ["elementNameChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }]);
__decorate([
    RegisterComponent({
        name: 'nylas-event-capacity',
        stateToProps: new Map([['schedulerConfig.selectedLanguage', 'selectedLanguage']]),
        eventToProps: {
            valueChanged: async (event, _nylasSchedulerConfigConnector) => {
                const { valueChanged } = event.detail;
                if (valueChanged) {
                    valueChanged(event);
                }
            },
        },
        fireRegisterEvent: true,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NylasEventCapacity.prototype, "render", null);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["nylas-event-capacity", "info-icon", "input-component", "tooltip-component"];
    components.forEach(tagName => { switch (tagName) {
        case "nylas-event-capacity":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, NylasEventCapacity);
            }
            break;
        case "info-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "input-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "tooltip-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { NylasEventCapacity as N, defineCustomElement as d };

//# sourceMappingURL=nylas-event-capacity2.js.map