import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { R as RegisterComponent } from './register-component.js';
import { a as debug, b as instance } from './utils.js';
import { d as defineCustomElement$4 } from './chevron.js';
import { d as defineCustomElement$3 } from './input-dropdown2.js';
import { d as defineCustomElement$2 } from './search.js';
import { d as defineCustomElement$1 } from './select-dropdown2.js';

const nylasEventDurationCss = ":host{display:block;--nylas-primary:#2563eb;--nylas-error:#cc4841;--nylas-error-pressed:#992222;--nylas-wraning:#f06c00;--nylas-success:#16a392;--nylas-info:#2b8fc2;--nylas-base-0:#ffffff;--nylas-base-25:#fcfcfd;--nylas-base-50:#f8f9fc;--nylas-base-100:#eaecf5;--nylas-base-200:#d5d9eb;--nylas-base-300:#b3b8d8;--nylas-base-400:#717bbc;--nylas-base-500:#4e5ba6;--nylas-base-600:#3e4784;--nylas-base-700:#263f72;--nylas-base-800:#293056;--nylas-base-900:#101323;--nylas-base-950:#0e101b;--nylas-color-blue-100:#e0e6f9;--nylas-border-radius:0.25rem;--nylas-border-radius-2x:0.5rem;--nylas-border-radius-3x:0.75rem;--nylas-font-family:\"Inter\", sans-serif;--nylas-color-black:#000000;--nylas-color-grey-900:#2c2c2c;--nylas-color-grey-800:#4b4b4b;--nylas-color-grey-700:#6e6e6e;--nylas-color-grey-600:#8e8e8e;--nylas-color-grey-500:#b3b3b3;--nylas-color-grey-400:#cacaca;--nylas-color-grey-300:#e1e1e1;--nylas-color-grey-200:#eaeaea;--nylas-color-grey-100:#f5f5f5;--nylas-color-grey-50:#fbfcfe;--nylas-color-white:#ffffff;--nylas-color-red-900:#992222;--nylas-color-red-700:#cc4841;--nylas-color-red-500:#ff786a;--nylas-color-red-300:#ffa79e;--nylas-color-red-100:#ffc5bf;--nylas-color-red-50:#ffeae8;--nylas-color-blue-900:#213571;--nylas-color-blue-700:#314fa9;--nylas-color-blue-500:#4169e1;--nylas-color-blue-300:#bdccf9;--nylas-color-blue-100:#e0e6f9;--nylas-color-blue-50:#f6f8fd;--nylas-color-yellow-900:#7c6506;--nylas-color-yellow-700:#c29f09;--nylas-color-yellow-500:#f7c90b;--nylas-color-yellow-300:#f9de70;--nylas-color-yellow-100:#fceba9;--nylas-color-yellow-50:#fdf4ce;--nylas-color-green-900:#0e6b60;--nylas-color-green-700:#16a392;--nylas-color-green-500:#17c3b2;--nylas-color-green-300:#74dbd1;--nylas-color-green-100:#a2e7e0;--nylas-color-green-50:#d1f3f0;--nylas-color-purple-900:#643554;--nylas-color-purple-700:#954f7d;--nylas-color-purple-500:#c769a7;--nylas-color-purple-300:#dda5ca;--nylas-color-purple-100:#e0bdd6;--nylas-color-purple-50:#e9dde5;--nylas-color-sky-900:#20698f;--nylas-color-sky-700:#2b8fc2;--nylas-color-sky-500:#6dceff;--nylas-color-sky-300:#8fdaff;--nylas-color-sky-100:#b8e7ff;--nylas-color-sky-50:#d9f2ff}.nylas-event-duration{display:flex;flex-direction:column;gap:4px}.nylas-event-duration label{display:flex;align-items:center;color:var(--nylas-base-800);font-size:16px;font-style:normal;font-weight:400;line-height:150%;}.nylas-event-duration label span.required{color:var(--nylas-error, #cc4841)}.nylas-event-duration label span.label-icon{margin-left:4px}.nylas-event-duration label span.label-icon tooltip-component{display:flex}.nylas-event-duration__error-container{max-height:0;opacity:0;overflow:hidden;transition:max-height 0.3s ease, opacity 0.3s ease}.nylas-event-duration__error-container.visible{max-height:20px;opacity:1}.nylas-event-duration__error-container .nylas-event-duration__error{color:var(--nylas-error);font-family:var(--nylas-font-family);font-size:12px;font-style:normal;font-weight:400;line-height:150%;}.nylas-event-duration__wrapper{display:flex;align-items:center;gap:0.5rem}.nylas-event-duration__wrapper input{padding:12px 16px;border-width:1;border-radius:8px;border:1px solid var(--nylas-base-200);font-family:var(--nylas-font-family);font-size:16px;line-height:24px;width:48px}.nylas-event-duration__wrapper input-dropdown::part(id_dropdown-input){border:1px solid var(--nylas-base-200);border-radius:var(--nylas-border-radius-2x);padding:14px 16px}.nylas-event-duration__wrapper input-dropdown::part(id_dropdown-content){width:100%;min-width:unset;height:200px}.nylas-event-duration__wrapper input-dropdown{width:80px}.nylas-event-duration__wrapper input-dropdown.error::part(id_dropdown-input){border:1px solid var(--nylas-error)}.nylas-event-duration__wrapper select-dropdown{width:120px}@media screen and (max-width: 768px){.nylas-event-duration__wrapper select-dropdown{width:100%}}.nylas-event-duration__wrapper select-dropdown::part(sd_dropdown-button){border:1px solid var(--nylas-base-200)}";
const NylasEventDurationStyle0 = nylasEventDurationCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
const NylasEventDuration = proxyCustomElement(class NylasEventDuration extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.valueChanged = createEvent(this, "valueChanged", 7);
        this.internals = this.attachInternals();
        this.selectedConfiguration = undefined;
        this.name = 'duration';
        this.eventDurationMinutes = undefined;
        this.selectedLanguage = undefined;
        this.duration = this.eventDurationMinutes ? (this.eventDurationMinutes >= 60 ? this.eventDurationMinutes / 60 : this.eventDurationMinutes) : 30;
        this.durationMinutes = undefined;
        this.durationIncrement = undefined;
        this.error = '';
        this.durationMinutesOptions = [
            { value: (15).toString(), label: '15' },
            { value: (30).toString(), label: '30' },
            { value: (45).toString(), label: '45' },
            { value: (60).toString(), label: '60' },
        ];
    }
    elementNameChangedHandler(newValue) {
        debug('nylas-event-duration', 'elementNameChangedHandler', newValue);
        this.host.setAttribute('name', newValue);
    }
    selectedConfigurationChangedHandler(newVal) {
        const configDuration = newVal?.availability?.duration_minutes;
        if (configDuration) {
            this.duration = configDuration >= 60 ? configDuration / 60 : configDuration;
            this.durationMinutes = configDuration ? configDuration : 30;
            this.durationIncrement = configDuration >= 60 ? 60 : 1;
            this.isInternalsAvailable && this.internals.setFormValue(this.durationMinutes.toString(), 'duration');
        }
    }
    selectedLanguageChangedHandler(newVal, oldVal) {
        if (newVal === oldVal)
            return;
        instance.changeLanguage(newVal);
        if (this.error) {
            this.validateDuration();
        }
    }
    connectedCallback() {
        debug('nylas-event-duration', 'connectedCallback');
    }
    componentWillLoad() {
        debug('nylas-event-duration', 'componentWillLoad');
        this.host.setAttribute('name', this.name);
    }
    componentDidLoad() {
        debug('nylas-event-duration', 'componentDidLoad');
        if (this.selectedConfiguration) {
            this.selectedConfigurationChangedHandler(this.selectedConfiguration);
        }
        this.duration = this.duration ? this.duration : this.eventDurationMinutes ? (this.eventDurationMinutes >= 60 ? this.eventDurationMinutes / 60 : this.eventDurationMinutes) : 30;
        this.durationMinutes = this.durationMinutes ? this.durationMinutes : this.duration ? this.duration : 30;
        this.durationIncrement = this.durationIncrement ? this.durationIncrement : this.duration >= 60 ? 60 : 1;
        this.setDurationMintueOptions();
        this.isInternalsAvailable && this.internals.setFormValue(this.durationMinutes.toString(), 'duration');
    }
    disconnectedCallback() {
        debug('nylas-event-duration', 'disconnectedCallback');
    }
    get isInternalsAvailable() {
        return typeof this.internals !== 'undefined' && typeof this.internals.setFormValue === 'function';
    }
    setDurationMintueOptions() {
        if (this.durationIncrement === 1) {
            this.durationMinutesOptions = [
                { value: (15).toString(), label: '15' },
                { value: (30).toString(), label: '30' },
                { value: (45).toString(), label: '45' },
                { value: (60).toString(), label: '60' },
            ];
        }
        else {
            this.durationMinutesOptions = Array.from({ length: 23 }, (_, i) => ({ value: (i + 1).toString(), label: (i + 1).toString() }));
        }
        return this.durationMinutesOptions;
    }
    validateDuration() {
        if (this.durationMinutes % 5 !== 0) {
            this.error = instance.t('nylasEventDuration.error.durationMustBeMultipleOf5');
            this.isInternalsAvailable && this.internals.setValidity({ customError: true }, this.error);
        }
        else if (this.durationMinutes <= 0) {
            this.error = instance.t('nylasEventDuration.error.durationMustBeGreaterThan0');
            this.isInternalsAvailable && this.internals.setValidity({ customError: true }, this.error);
        }
        else {
            this.error = '';
            this.isInternalsAvailable && this.internals.setValidity({});
        }
        return this.error;
    }
    nylasFormDropdownChangedHandler(event) {
        debug('nylas-calendar-picker', 'nylasFormDropdownChangedHandler', event.detail);
        const { value } = event.detail;
        this.durationIncrement = parseInt(value.toString());
        if (this.durationIncrement === 1) {
            this.duration = 60;
        }
        else {
            this.duration = 1;
        }
        this.setDurationMintueOptions();
        this.durationMinutes = this.duration * this.durationIncrement;
        if (this.validateDuration() !== '') {
            return;
        }
        this.isInternalsAvailable && this.internals.setFormValue(this.durationMinutes.toString(), this.name);
        this.valueChanged.emit({ value: this.durationMinutes.toString(), name: this.name });
    }
    inputOptionChangedHandler(event) {
        debug('nylas-calendar-picker', 'inputOptionChangedHandler', event.detail);
        const { value } = event.detail;
        this.duration = parseFloat(value.toString());
        this.durationMinutes = this.duration * this.durationIncrement;
        if (this.validateDuration() !== '') {
            return;
        }
        this.isInternalsAvailable && this.internals.setFormValue(this.durationMinutes.toString(), this.name);
        this.valueChanged.emit({ value: this.durationMinutes.toString(), name: this.name });
    }
    render() {
        const durationOptions = [
            { value: (1).toString(), label: instance.t('timeDuration', { context: 'minute' }) },
            { value: (60).toString(), label: instance.t('timeDuration', { context: 'hour' }) },
        ];
        return (h(Host, { key: 'bee74ed5eb48a1bc48dc362f078d7171e8a34257' }, h("div", { key: '5a04f4235b729b9ef3c8bdd85d154aff975736a2', class: "nylas-event-duration", part: "ned" }, h("label", { key: 'a66b0a5879cbdc7fdec1e1fe43385cea6a961a91', htmlFor: "duration" }, instance.t('nylasEventDuration.headerTitle'), h("span", { key: '9c7b52f52a84a8ed7d956d7e3c3dd27386eacec4', class: "required" }, "*")), h("div", { key: '266a3ed77da606bfbed95157fa2ca4aaafe27a2b', class: "nylas-event-duration__wrapper" }, h("input-dropdown", { key: '7b3a65e9fb1d687b03cec7b0e9df10e8a873ebcf', class: this.error ? 'error' : '', name: 'event-duration', options: this.durationMinutesOptions, inputValue: this.duration.toString(), exportparts: "id_dropdown: ned__input_dropdown, id_dropdown-input: ned__input_dropdown-input, id_dropdown-content: ned__input_dropdown-content", defaultInputOption: this.durationMinutesOptions.find(i => i.value === this.duration.toString()) }), this.durationIncrement && (h("select-dropdown", { name: 'event-duration', options: durationOptions, pluralizedLabel: this.duration > 1
                ? instance.t(`time.${this.durationIncrement === 60 ? 'hours' : 'minutes'}`)
                : instance.t(`time.${this.durationIncrement === 60 ? 'hour' : 'minute'}`), exportparts: "sd_dropdown: ned__dropdown, sd_dropdown-button: ned__dropdown-button, sd_dropdown-content: ned__dropdown-content", defaultSelectedOption: durationOptions.find(i => i.value === this.durationIncrement.toString()), withSearch: false }))), h("div", { key: 'ab0e152a7d9858325b968ed4f01827c3b14cac3a', class: `nylas-event-duration__error-container ${this.error ? 'visible' : ''}`, part: "ned__error-container" }, h("div", { key: '1bfc3072b3e2b51d46247f3eebcbdf917df121e8', class: "nylas-event-duration__error", part: "ned__error" }, this.error)))));
    }
    static get formAssociated() { return true; }
    get host() { return this; }
    static get watchers() { return {
        "name": ["elementNameChangedHandler"],
        "selectedConfiguration": ["selectedConfigurationChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }; }
    static get style() { return NylasEventDurationStyle0; }
}, [65, "nylas-event-duration", {
        "selectedConfiguration": [16],
        "name": [1],
        "eventDurationMinutes": [2, "event-duration-minutes"],
        "selectedLanguage": [1, "selected-language"],
        "duration": [32],
        "durationMinutes": [32],
        "durationIncrement": [32],
        "error": [32],
        "durationMinutesOptions": [32]
    }, [[0, "nylasFormDropdownChanged", "nylasFormDropdownChangedHandler"], [0, "inputOptionChanged", "inputOptionChangedHandler"]], {
        "name": ["elementNameChangedHandler"],
        "selectedConfiguration": ["selectedConfigurationChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }]);
__decorate([
    RegisterComponent({
        name: 'nylas-event-duration',
        stateToProps: new Map([
            ['schedulerConfig.selectedConfiguration', 'selectedConfiguration'],
            ['schedulerConfig.selectedLanguage', 'selectedLanguage'],
        ]),
        eventToProps: {},
        fireRegisterEvent: true,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NylasEventDuration.prototype, "render", null);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["nylas-event-duration", "chevron-icon", "input-dropdown", "search-icon", "select-dropdown"];
    components.forEach(tagName => { switch (tagName) {
        case "nylas-event-duration":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, NylasEventDuration);
            }
            break;
        case "chevron-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "input-dropdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "search-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "select-dropdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { NylasEventDuration as N, defineCustomElement as d };

//# sourceMappingURL=nylas-event-duration2.js.map