import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { R as RegisterComponent } from './register-component.js';
import { j as dayjs, u as utc, w as timezone, a as debug, K as generateRRule, b as instance, L as getTimezoneOffset } from './utils.js';
import { T as TIMEZONE_MAP } from './constants.js';
import { c as customParseFormat, d as defineCustomElement$4 } from './nylas-time-window-picker2.js';
import { d as defineCustomElement$9 } from './chevron.js';
import { d as defineCustomElement$8 } from './globe.js';
import { d as defineCustomElement$7 } from './input-component2.js';
import { d as defineCustomElement$6 } from './input-dropdown2.js';
import { d as defineCustomElement$5 } from './nylas-date-component2.js';
import { d as defineCustomElement$3 } from './search.js';
import { d as defineCustomElement$2 } from './select-dropdown2.js';
import { d as defineCustomElement$1 } from './time-period-selector2.js';

const nylasEventTimeslotCss = ":host{display:block;--nylas-primary:#2563eb;--nylas-error:#cc4841;--nylas-error-pressed:#992222;--nylas-wraning:#f06c00;--nylas-success:#16a392;--nylas-info:#2b8fc2;--nylas-base-0:#ffffff;--nylas-base-25:#fcfcfd;--nylas-base-50:#f8f9fc;--nylas-base-100:#eaecf5;--nylas-base-200:#d5d9eb;--nylas-base-300:#b3b8d8;--nylas-base-400:#717bbc;--nylas-base-500:#4e5ba6;--nylas-base-600:#3e4784;--nylas-base-700:#263f72;--nylas-base-800:#293056;--nylas-base-900:#101323;--nylas-base-950:#0e101b;--nylas-color-blue-100:#e0e6f9;--nylas-border-radius:0.25rem;--nylas-border-radius-2x:0.5rem;--nylas-border-radius-3x:0.75rem;--nylas-font-family:\"Inter\", sans-serif;--nylas-color-black:#000000;--nylas-color-grey-900:#2c2c2c;--nylas-color-grey-800:#4b4b4b;--nylas-color-grey-700:#6e6e6e;--nylas-color-grey-600:#8e8e8e;--nylas-color-grey-500:#b3b3b3;--nylas-color-grey-400:#cacaca;--nylas-color-grey-300:#e1e1e1;--nylas-color-grey-200:#eaeaea;--nylas-color-grey-100:#f5f5f5;--nylas-color-grey-50:#fbfcfe;--nylas-color-white:#ffffff;--nylas-color-red-900:#992222;--nylas-color-red-700:#cc4841;--nylas-color-red-500:#ff786a;--nylas-color-red-300:#ffa79e;--nylas-color-red-100:#ffc5bf;--nylas-color-red-50:#ffeae8;--nylas-color-blue-900:#213571;--nylas-color-blue-700:#314fa9;--nylas-color-blue-500:#4169e1;--nylas-color-blue-300:#bdccf9;--nylas-color-blue-100:#e0e6f9;--nylas-color-blue-50:#f6f8fd;--nylas-color-yellow-900:#7c6506;--nylas-color-yellow-700:#c29f09;--nylas-color-yellow-500:#f7c90b;--nylas-color-yellow-300:#f9de70;--nylas-color-yellow-100:#fceba9;--nylas-color-yellow-50:#fdf4ce;--nylas-color-green-900:#0e6b60;--nylas-color-green-700:#16a392;--nylas-color-green-500:#17c3b2;--nylas-color-green-300:#74dbd1;--nylas-color-green-100:#a2e7e0;--nylas-color-green-50:#d1f3f0;--nylas-color-purple-900:#643554;--nylas-color-purple-700:#954f7d;--nylas-color-purple-500:#c769a7;--nylas-color-purple-300:#dda5ca;--nylas-color-purple-100:#e0bdd6;--nylas-color-purple-50:#e9dde5;--nylas-color-sky-900:#20698f;--nylas-color-sky-700:#2b8fc2;--nylas-color-sky-500:#6dceff;--nylas-color-sky-300:#8fdaff;--nylas-color-sky-100:#b8e7ff;--nylas-color-sky-50:#d9f2ff;width:inherit}div.nylas-event-timeslot label{display:flex;align-items:center;color:var(--nylas-base-800);font-size:16px;font-style:normal;font-weight:400;line-height:150%}div.nylas-event-timeslot div.date-time-input div.date-time-picker{display:flex;gap:32px}@media screen and (max-width: 768px){div.nylas-event-timeslot div.date-time-input div.date-time-picker{flex-direction:column;gap:16px}}div.nylas-event-timeslot div.date-time-input div.date-time-picker nylas-date-component{width:224px}@media screen and (max-width: 768px){div.nylas-event-timeslot div.date-time-input div.date-time-picker nylas-date-component{width:100%}}div.nylas-event-timeslot div.date-time-input div.date-time-picker nylas-date-component:not(.error)::part(ic__date){border-color:var(--nylas-base-200)}div.nylas-event-timeslot div.date-time-input div.date-time-picker nylas-date-component::part(ic__date){height:50px}div.nylas-event-timeslot div.date-time-input div.date-time-picker div.time-range{display:flex;gap:8px;align-items:flex-start}div.nylas-event-timeslot div.date-time-input div.date-time-picker div.time-range span{margin:12px 0 0 6px;display:inline-flex;align-items:flex-start}@media screen and (max-width: 768px){div.nylas-event-timeslot div.date-time-input div.date-time-picker div.time-range{display:grid;grid-template-columns:1fr 20px 1fr}div.nylas-event-timeslot div.date-time-input div.date-time-picker div.time-range nylas-time-window-picker::part(time-picker){width:-webkit-fill-available}div.nylas-event-timeslot div.date-time-input div.date-time-picker div.time-range nylas-time-window-picker::part(time-input){width:calc(100% - 8px)}}div.nylas-event-timeslot div.date-time-input div.date-time-picker select-dropdown{width:fit-content}div.nylas-event-timeslot div.date-time-input div.date-time-picker select-dropdown::part(sd_dropdown){position:relative}div.nylas-event-timeslot div.date-time-input div.date-time-picker select-dropdown::part(sd_dropdown-button){border:none;padding:14px;justify-content:flex-start}div.nylas-event-timeslot div.date-time-input div.date-time-picker select-dropdown::part(sd_dropdown-button):hover{border:none;outline:none;color:var(--nylas-primary)}@media screen and (max-width: 768px){div.nylas-event-timeslot div.date-time-input div.date-time-picker select-dropdown{width:-webkit-fill-available}div.nylas-event-timeslot div.date-time-input div.date-time-picker select-dropdown::part(sd_dropdown-button-selected-label){max-width:fit-content}div.nylas-event-timeslot div.date-time-input div.date-time-picker select-dropdown::part(sd_dropdown-content){right:unset;width:unset}}div.nylas-event-timeslot div.date-time-input div.recurrence-options{margin:8px 0}div.nylas-event-timeslot div.date-time-input div.recurrence-options select-dropdown::part(sd_dropdown){position:relative}div.nylas-event-timeslot div.date-time-input div.recurrence-options select-dropdown::part(sd_dropdown-button){width:fit-content;padding:14px;border-color:var(--nylas-base-200)}div.nylas-event-timeslot div.date-time-input div.recurrence-options select-dropdown::part(sd_dropdown-button):hover{color:var(--nylas-primary)}div.nylas-event-timeslot div.date-time-input div.recurrence-options select-dropdown::part(sd_dropdown-content){width:fit-content}div.nylas-event-timeslot div.date-time-input div.recurrence-options select-dropdown::part(sd_dropdown-button-selected-label){max-width:100%;width:fit-content;font-size:16px}@media screen and (max-width: 768px){div.nylas-event-timeslot div.date-time-input div.recurrence-options select-dropdown{width:-webkit-fill-available}div.nylas-event-timeslot div.date-time-input div.recurrence-options select-dropdown::part(sd_dropdown-button-selected-label){max-width:254px;width:fit-content}div.nylas-event-timeslot div.date-time-input div.recurrence-options select-dropdown::part(sd_dropdown-content){right:unset;width:unset}}@media screen and (max-width: 412px){div.nylas-event-timeslot div.date-time-input div.recurrence-options select-dropdown::part(sd_dropdown-button-selected-label){max-width:240px}}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.custom-recurrence-time-period,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-type,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-end{display:grid;align-items:center;gap:16px;grid-template-columns:128px 1fr;margin-bottom:8px}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.custom-recurrence-time-period select-dropdown::part(sd_dropdown-button),div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-type select-dropdown::part(sd_dropdown-button),div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-end select-dropdown::part(sd_dropdown-button){border-color:var(--nylas-base-200)}@media screen and (max-width: 768px){div.nylas-event-timeslot div.date-time-input div.recurrence-options div.custom-recurrence-time-period,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-type,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-end{grid-template-columns:1fr;gap:4px;margin:16px 0}}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.custom-recurrence-time-period time-period-selector::part(id_dropdown-input),div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-type time-period-selector::part(id_dropdown-input),div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-end time-period-selector::part(id_dropdown-input){padding:16px}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.custom-recurrence-time-period time-period-selector input-dropdown:hover,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-type time-period-selector input-dropdown:hover,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.recurrence-end time-period-selector input-dropdown:hover{border:1px solid var(--nylas-primary);outline:1px solid transparent}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.days{margin:16px 0;display:flex;gap:16px;align-items:center}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.days div.buttons{display:flex;gap:8px;margin:8px 0}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.days div.buttons button{border-radius:50%;border:none;height:24px;width:24px;color:var(--nylas-base-800);cursor:pointer}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.days div.buttons button.selected{background-color:var(--nylas-primary);color:var(--nylas-base-0)}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.days div.buttons button:hover{background-color:var(--nylas-base-500);color:var(--nylas-base-0)}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.days div.buttons button:active{background-color:var(--nylas-base-600);color:var(--nylas-base-0)}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.days,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence-ends,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.month-recurrence{display:grid;align-items:center;gap:16px;grid-template-columns:128px 1fr}@media screen and (max-width: 768px){div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.days,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence-ends,div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.month-recurrence{grid-template-columns:1fr;gap:4px;margin:16px 0}}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence-ends #custom-recurrence-end-type::part(sd_dropdown-button){padding:16px}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence{display:flex;gap:16px;align-items:baseline}@media screen and (max-width: 768px){div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence{flex-direction:column;align-items:flex-start;gap:0}}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence div.custom-recurrence-end-after{display:flex;gap:8px;align-items:center}@media screen and (max-width: 768px){div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence div.custom-recurrence-end-after{flex-direction:column;align-items:flex-start}}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence div.custom-recurrence-end-after #recurrence-end-after::part(netimeslot__input-textfield),div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence div.custom-recurrence-end-after #recurrence-end-after::part(ic__input){border-color:var(--nylas-base-200)}div.nylas-event-timeslot div.date-time-input div.recurrence-options div.repeat-on div.custom-recurrence nylas-date-component::part(ic__date){padding:0 16px;height:52px;border:1px solid var(--nylas-base-200)}";
const NylasEventTimeslotStyle0 = nylasEventTimeslotCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
dayjs.extend(customParseFormat);
dayjs.extend(utc);
dayjs.extend(timezone);
const periodMap = {
    day: 'daily',
    week: 'weekly',
    month: 'monthly',
    year: 'yearly',
};
const NylasEventTimeslot = proxyCustomElement(class NylasEventTimeslot extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.valueChanged = createEvent(this, "valueChanged", 7);
        this.timeWindowFormError = createEvent(this, "timeWindowFormError", 7);
        this.dateTimeInputError = createEvent(this, "dateTimeInputError", 7);
        this.internals = this.attachInternals();
        this.name = 'event-timeslot';
        this.initialValue = undefined;
        this.selectedLanguage = undefined;
        this.currentUser = undefined;
        this.selectedDate = undefined;
        this.selectedStartTime = undefined;
        this.selectedEndTime = undefined;
        this.selectedTimezone = undefined;
        this.selectedRecurrenceType = undefined;
        this.timeRangeError = false;
        this.selectedRrule = undefined;
        this.recurrenceOptions = [];
        this.repeatEveryInterval = 1;
        this.repeatEveryFrequency = 'week';
        this.repeatOnDays = [];
        this.repeatMonthlySameDate = true;
        this.repeatEndType = 'never';
        this.repeatEndAfter = 1;
        this.repeatEndOn = undefined;
        this.monthRecurrenceOptions = [];
        this.endDate = undefined;
        this.hasDateTimeInputError = false;
    }
    connectedCallback() {
        debug('nylas-event-timeslot', 'connectedCallback');
    }
    disconnectedCallback() {
        debug('nylas-event-timeslot', 'disconnectedCallback');
    }
    componentWillLoad() {
        debug('nylas-event-timeslot', 'componentWillLoad');
        this.host.setAttribute('name', this.name);
    }
    componentDidLoad() {
        debug('nylas-event-timeslot', 'componentDidLoad');
        if (this.initialValue) {
            const { when, recurrence } = this.initialValue;
            if (when) {
                this.selectedDate = dayjs.unix(when.start_time).tz(when.start_timezone).format('YYYY-MM-DD');
                this.selectedStartTime = dayjs.unix(when.start_time).tz(when.start_timezone).format('hh:mma');
                this.selectedEndTime = dayjs.unix(when.end_time).tz(when.end_timezone).format('hh:mma');
                this.selectedTimezone = when.start_timezone;
            }
            else {
                this.selectedDate = new Date().toISOString().split('T')[0];
                const defaultTimes = this.getSuggestedTime();
                this.selectedStartTime = defaultTimes.startTime;
                this.selectedEndTime = defaultTimes.endTime;
                this.selectedTimezone = Intl.DateTimeFormat().resolvedOptions().timeZone;
            }
            if (recurrence && recurrence.length > 0) {
                this.selectedRrule = recurrence[0];
                const repeatEndAfter = recurrence[0]?.split(';')?.find(s => s.includes('COUNT'));
                if (repeatEndAfter) {
                    this.repeatEndAfter = parseInt(repeatEndAfter.split('=')[1]);
                }
                const daysString = recurrence[0]?.split(';')?.find(s => s.includes('BYDAY'));
                if (daysString) {
                    this.repeatOnDays = daysString.split('=')[1].split(',');
                }
                const until = recurrence[0]?.split(';')?.find(s => s.includes('UNTIL'));
                if (until) {
                    const untilDate = dayjs(until.split('=')[1], 'YYYYMMDDTHHmmss').toDate();
                    this.repeatEndOn = dayjs(untilDate).toISOString().split('T')[0];
                    this.repeatEndType = 'on';
                }
                const recurrenceType = this.getRecurrenceTypeFromRrule(recurrence[0]);
                this.selectedRecurrenceType = recurrenceType || 'none';
            }
            else {
                this.selectedRecurrenceType = 'none';
                this.selectedRrule = generateRRule(this.selectedDate, this.selectedRecurrenceType, undefined, undefined, this.selectedTimezone);
            }
        }
        else {
            this.selectedDate = new Date().toISOString().split('T')[0];
            const defaultTimes = this.getSuggestedTime();
            this.selectedStartTime = defaultTimes.startTime;
            this.selectedEndTime = defaultTimes.endTime;
            this.selectedTimezone = Intl.DateTimeFormat().resolvedOptions().timeZone;
            this.selectedRecurrenceType = 'none';
            this.selectedRrule = generateRRule(this.selectedDate, this.selectedRecurrenceType, undefined, undefined, this.selectedTimezone);
        }
        this.recurrenceOptions = this.generateRecurrenceOptions(this.selectedDate, this.selectedTimezone);
        this.monthRecurrenceOptions = this.getMonthRecurrenceOptions(this.selectedDate, this.selectedTimezone);
        this.handleValueChanged(true);
    }
    elementNameChangedHandler(newValue) {
        debug('nylas-event-timeslot', 'elementNameChangedHandler', newValue);
        this.host.setAttribute('name', newValue);
    }
    selectedLanguageChangedHandler(newVal, oldVal) {
        if (newVal === oldVal)
            return;
        instance.changeLanguage(newVal);
    }
    getOrdinalSuffix(n) {
        const s = ['th', 'st', 'nd', 'rd'];
        const v = n % 100;
        return n + (s[(v - 20) % 10] || s[v] || s[0]);
    }
    getRecurrenceTypeFromRrule(rrule) {
        if (rrule.includes('INTERVAL'))
            return 'custom';
        if (rrule.includes('FREQ=DAILY'))
            return 'daily';
        if (rrule.includes('FREQ=WEEKLY'))
            return 'weekly';
        if (rrule.includes('FREQ=MONTHLY'))
            return 'monthly';
        if (rrule.includes('FREQ=YEARLY'))
            return 'yearly';
        return undefined;
    }
    generateRecurrenceOptions(selectedDate, timezoneStr) {
        const daysOfWeek = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
        const selectedDay = dayjs.tz(selectedDate, timezoneStr);
        const dayOfWeek = daysOfWeek[selectedDay.day()];
        const date = selectedDay.date();
        const occurrenceInMonth = Math.ceil(date / 7);
        return [
            { label: instance.t('nylasEventTimeslot.recurrenceOptions.none'), value: 'none' },
            { label: instance.t('nylasEventTimeslot.recurrenceOptions.daily'), value: 'daily' },
            { label: instance.t('nylasEventTimeslot.recurrenceOptions.weekly', { dayOfWeek: dayOfWeek }), value: 'weekly' },
            { label: instance.t('nylasEventTimeslot.recurrenceOptions.monthly', { dayOfMonth: `${this.getOrdinalSuffix(occurrenceInMonth)} ${dayOfWeek}` }), value: 'monthly' },
            {
                label: instance.t('nylasEventTimeslot.recurrenceOptions.yearly', { dateOfMonth: `${selectedDay.format('MMMM D')}` }),
                value: 'yearly',
            },
            { label: instance.t('nylasEventTimeslot.recurrenceOptions.custom'), value: 'custom' },
        ];
    }
    getMonthRecurrenceOptions(selectedDate, timezoneStr) {
        const daysOfWeek = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
        const selectedDay = dayjs.tz(selectedDate, timezoneStr);
        const dayOfWeek = daysOfWeek[selectedDay.day()];
        const date = selectedDay.date();
        const occurrenceInMonth = Math.ceil(date / 7);
        return [
            { label: instance.t('nylasEventTimeslot.recurrenceOptions.monthOnDay', { date: date }), value: 'monthly-same-date' },
            { label: instance.t('nylasEventTimeslot.recurrenceOptions.monthly', { dayOfMonth: `${this.getOrdinalSuffix(occurrenceInMonth)} ${dayOfWeek}` }), value: 'monthly' },
        ];
    }
    getSuggestedTime() {
        const now = dayjs();
        const minutes = now.minute();
        const roundedMinutes = minutes <= 30 ? 30 : 60;
        const startTime = now.set('minute', roundedMinutes).set('second', 0);
        const endTime = startTime.add(30, 'minute');
        return {
            startTime: startTime.format('hh:mma'),
            endTime: endTime.format('hh:mma'),
        };
    }
    getTimezoneLabelHTML(timezone) {
        const offset = getTimezoneOffset(timezone);
        return (h("span", { class: "timezone-label", style: {
                display: 'flex',
                alignItems: 'center',
                justifyContent: 'space-between',
                width: '-webkit-fill-available',
            } }, TIMEZONE_MAP[timezone], ' ', h("span", { class: "timezone-offset", style: {
                fontSize: '14px',
                fontWeight: '400',
                color: 'var(--nylas-base-500)',
            } }, offset)));
    }
    isStartTimeAfterEndTime(startTime, endTime) {
        const start = dayjs(startTime, 'hh:mma');
        const end = dayjs(endTime, 'hh:mma');
        return start.isAfter(end);
    }
    isStartTimeEqualToEndTime(startTime, endTime) {
        const start = dayjs(startTime, 'hh:mma');
        const end = dayjs(endTime, 'hh:mma');
        return start.isSame(end);
    }
    isStartTimeBeforeCurrentDate(date, startTime, timezone) {
        const dateTime = dayjs.tz(`${date} ${startTime}`, 'YYYY-MM-DD hh:mma', timezone);
        return dateTime.isBefore(dayjs());
    }
    validateDateTimeInput(date, startTime, timezone) {
        const dateTimeWithStartTime = dayjs.tz(`${date} ${startTime}`, 'YYYY-MM-DD hh:mma', timezone);
        const isInPast = dateTimeWithStartTime.isBefore(dayjs());
        return {
            isValid: !isInPast,
            errorMessage: isInPast ? instance.t('nylasEventTimeslot.errors.startTimeBeforeCurrentDate') : '',
        };
    }
    getStartAndEndTimes() {
        const start_time = dayjs.tz(`${this.selectedDate} ${this.selectedStartTime}`, 'YYYY-MM-DD hh:mma', this.selectedTimezone).toDate();
        const end_time = dayjs.tz(`${this.selectedDate} ${this.selectedEndTime}`, 'YYYY-MM-DD hh:mma', this.selectedTimezone).toDate();
        return {
            start_time: Math.round(start_time.getTime() / 1000),
            end_time: Math.round(end_time.getTime() / 1000),
        };
    }
    getCustomOptions() {
        if (this.selectedRecurrenceType !== 'custom') {
            return undefined;
        }
        const repeatFreq = periodMap[this.repeatEveryFrequency];
        return {
            frequency: repeatFreq,
            interval: this.repeatEveryInterval,
            daysOfWeek: this.repeatEveryFrequency === 'week' ? this.repeatOnDays : undefined,
            monthlySameDate: this.repeatEveryFrequency === 'month' ? this.repeatMonthlySameDate : undefined,
            end: {
                type: this.repeatEndType,
                count: this.repeatEndType === 'after' ? this.repeatEndAfter : undefined,
                date: this.repeatEndType === 'on' ? this.repeatEndOn : undefined,
            },
        };
    }
    handleValueChanged(noValue = false) {
        const customOptions = this.getCustomOptions();
        this.selectedRrule = generateRRule(this.selectedDate, this.selectedRecurrenceType, this.repeatEndOn, customOptions, this.selectedTimezone);
        const { start_time, end_time } = this.getStartAndEndTimes();
        const internalsObj = {
            when: {
                start_time: start_time,
                end_time: end_time,
                start_timezone: this.selectedTimezone,
                end_timezone: this.selectedTimezone,
            },
            recurrence: this.selectedRrule ? [this.selectedRrule] : [],
        };
        this.internals.setFormValue(JSON.stringify(internalsObj), this.name);
        if (!noValue) {
            this.valueChanged.emit({
                value: JSON.stringify(internalsObj),
                name: this.name,
            });
        }
    }
    setTime(event) {
        const { key, value } = event.detail;
        if (key === 'event-timeslot-start-time') {
            this.selectedStartTime = value;
        }
        else if (key === 'event-timeslot-end-time') {
            this.selectedEndTime = value;
        }
        const validateStartTimeAfterEndTime = this.isStartTimeAfterEndTime(this.selectedStartTime, this.selectedEndTime);
        const validateStartTimeEqualToEndTime = this.isStartTimeEqualToEndTime(this.selectedStartTime, this.selectedEndTime);
        const validation = this.validateDateTimeInput(this.selectedDate, this.selectedStartTime, this.selectedTimezone);
        const validateStartTimeBeforeCurrentDate = !validation.isValid;
        this.timeRangeError = validateStartTimeAfterEndTime || validateStartTimeEqualToEndTime || validateStartTimeBeforeCurrentDate;
        let error = '';
        if (validateStartTimeAfterEndTime) {
            error = instance.t('nylasEventTimeslot.errors.invalidTimeRange');
        }
        else if (validateStartTimeEqualToEndTime) {
            error = instance.t('nylasEventTimeslot.errors.startTimeSameAsEndTime');
        }
        else if (validateStartTimeBeforeCurrentDate) {
            error = validation.errorMessage;
        }
        else {
            error = '';
        }
        this.timeWindowFormError.emit({
            key: this.name,
            message: error,
            uniqueIdentifier: 'time-range',
        });
        if (error) {
            return;
        }
        this.handleValueChanged();
    }
    nylasFormDropdownChangedHandler(event) {
        const { name, value } = event.detail;
        if (name === 'timezone') {
            this.selectedTimezone = value;
            const date = dayjs(this.selectedDate);
            const validation = this.validateDateTimeInput(date.format('YYYY-MM-DD'), this.selectedStartTime, this.selectedTimezone);
            this.hasDateTimeInputError = !validation.isValid;
            this.dateTimeInputError.emit({
                key: this.name,
                message: validation.errorMessage,
            });
            if (!validation.isValid) {
                return;
            }
        }
        else if (name === 'recurrence-type') {
            this.selectedRecurrenceType = value;
        }
        else if (name === 'month-recurrence-type') {
            this.repeatMonthlySameDate = value === 'monthly-same-date';
        }
        else if (name === 'custom-recurrence-end-type') {
            this.repeatEndType = value;
        }
        this.handleValueChanged();
    }
    nylasFormInputChangedHandler(event) {
        const { name, value } = event.detail;
        if (name === 'date-time-input') {
            const date = dayjs(value);
            const validation = this.validateDateTimeInput(date.format('YYYY-MM-DD'), this.selectedStartTime, this.selectedTimezone);
            this.hasDateTimeInputError = !validation.isValid;
            this.dateTimeInputError.emit({
                key: this.name,
                message: validation.errorMessage,
            });
            if (!validation.isValid) {
                return;
            }
            this.selectedDate = date.format('YYYY-MM-DD');
            this.recurrenceOptions = this.generateRecurrenceOptions(this.selectedDate, this.selectedTimezone);
            this.monthRecurrenceOptions = this.getMonthRecurrenceOptions(this.selectedDate, this.selectedTimezone);
        }
        else if (name === 'recurrence-end-date' || name === 'custom-recurrence-end-date') {
            const error = event.detail?.error || '';
            this.timeWindowFormError.emit({
                key: this.name,
                message: error,
                uniqueIdentifier: name,
            });
            this.repeatEndOn = value;
        }
        else if (name === 'recurrence-end-after') {
            const parsedValue = parseInt(value);
            if (parsedValue < 1 || isNaN(parsedValue)) {
                this.timeWindowFormError.emit({
                    key: this.name,
                    message: instance.t('fixFormErrors'),
                });
                return;
            }
            this.repeatEndAfter = parsedValue;
        }
        this.handleValueChanged();
    }
    timePeriodChangedHandler(event) {
        const { number, period } = event.detail;
        this.repeatEveryInterval = number;
        this.repeatEveryFrequency = period;
        if (period === 'month') {
            this.monthRecurrenceOptions = this.getMonthRecurrenceOptions(this.selectedDate, this.selectedTimezone);
        }
        this.handleValueChanged();
    }
    render() {
        const icloudProvider = this.currentUser?.provider === 'icloud';
        const defaultRecurrenceOption = this.recurrenceOptions.find(option => option.value === this.selectedRecurrenceType);
        const timezoneOptions = Object.keys(TIMEZONE_MAP).map(key => ({
            labelHTML: this.getTimezoneLabelHTML(key),
            label: TIMEZONE_MAP[key],
            value: key,
        }));
        const selectedTimezoneOption = timezoneOptions.find(i => i.value === this.selectedTimezone);
        const endOptions = [
            { label: instance.t('nylasEventTimeslot.customRecurrence.endsOptions.never'), value: 'never' },
            { label: instance.t('nylasEventTimeslot.customRecurrence.endsOptions.on'), value: 'on' },
            { label: instance.t('nylasEventTimeslot.customRecurrence.endsOptions.after'), value: 'after' },
        ];
        const defaultEndOnDate = dayjs(this.selectedDate).add(1, 'year').toISOString().split('T')[0];
        const defaultEndAfter = this.repeatEveryFrequency === 'week' ? 4 : this.repeatEveryFrequency === 'month' ? 12 : 5;
        this.repeatEndOn = this.repeatEndOn || defaultEndOnDate;
        this.repeatEndAfter = this.repeatEndAfter || defaultEndAfter;
        const today = dayjs().tz(this.selectedTimezone);
        return (h(Host, { key: '92581d88eaad6ec232d41d494635ce1cf922e310' }, h("div", { key: '2031b25539623b44c19924972fd768409ee524c7', class: "nylas-event-timeslot", part: "netimeslot" }, h("label", { key: 'aced1ba3abf182ee443917d347b8c7c6c4fc4478', htmlFor: "date-time-input" }, instance.t('nylasEventTimeslot.dateTimeLabel')), h("div", { key: '25e8065e47d81b54f680edbdbd8aa7e2b744aa96', class: "date-time-input", part: "netimeslot__date-time-input" }, h("div", { key: 'bef56e130618fb6142e0aa604310ee083e3661bc', class: "date-time-picker", part: "netimeslot__date-time-picker" }, h("nylas-date-component", { key: '5f603058e7e5a67970f74108d93340cc6ed150e6', minDate: dayjs().tz(this.selectedTimezone).toISOString().split('T')[0], name: "date-time-input", defaultValue: this.selectedDate, id: 'date-time-input', class: { error: this.hasDateTimeInputError }, required: true, hasError: this.hasDateTimeInputError }), h("div", { key: '26ab20902a5d50be85b27c7634525f8e155bf4cc', class: "time-range", part: "netimeslot__time-range" }, h("nylas-time-window-picker", { id: 'event-timeslot-start-time', hasError: this.timeRangeError, time: this.selectedStartTime, language: this.selectedLanguage, name: 'event-timeslot-start-time', key: 'event-timeslot-start-time', exportparts: "time-picker: nap__time-picker-container, time-input: nap__time-picker-input, times: nap__time-picker-times" }), h("span", { key: '97433b9bef4f2d4f670f36fdb844518fcccd7dee' }, "\u2013"), h("nylas-time-window-picker", { id: 'event-timeslot-end-time', hasError: this.timeRangeError, time: this.selectedEndTime, language: this.selectedLanguage, name: 'event-timeslot-end-time', key: 'event-timeslot-end-time', minimumStartTime: this.selectedStartTime, exportparts: "time-picker: nap__time-picker-container, time-input: nap__time-picker-input, times: nap__time-picker-times" })), selectedTimezoneOption?.label && (h("select-dropdown", { searchPlaceholder: instance.t('search'), name: "timezone", exportparts: "sd_dropdown: nap__timezone-container, sd_dropdown-button: nap__timezone-button, sd_dropdown-content: nap__timezone-dropdown-content", options: timezoneOptions, withChevron: false, defaultSelectedOption: selectedTimezoneOption }, h("span", { slot: "select-icon" }, h("globe-icon", { width: "20", height: "20" }))))), !icloudProvider && (h("div", { class: "recurrence-options", part: "netimeslot__recurrence-options" }, defaultRecurrenceOption && defaultRecurrenceOption?.label && (h("div", { class: "recurrence-type", part: "netimeslot__recurrence-type" }, h("label", { htmlFor: "recurrence-type" }, instance.t('nylasEventTimeslot.recurrenceLabel')), h("select-dropdown", { withSearch: false, id: "recurrence-type", name: "recurrence-type", options: this.recurrenceOptions, defaultSelectedOption: defaultRecurrenceOption, exportparts: "sd_dropdown: netimeslot__dropdown, sd_dropdown-button: netimeslot__dropdown-button, sd_dropdown-content: netimeslot__dropdown-content" }))), this.selectedRecurrenceType !== 'custom' && this.selectedRecurrenceType !== 'none' && (h("div", { class: "recurrence-end", part: "netimeslot__recurrence-end" }, h("label", null, instance.t('nylasEventTimeslot.endDate')), h("nylas-date-component", { name: "recurrence-end-date", minDate: today.toISOString().split('T')[0], defaultValue: this.repeatEndOn || defaultEndOnDate, id: 'recurrence-end-date', required: true }))), this.selectedRecurrenceType === 'custom' && (h("div", { class: "custom-recurrence-time-period", part: "netimeslot__custom-recurrence" }, h("label", { htmlFor: "" }, instance.t('nylasEventTimeslot.customRecurrence.repeatEvery')), h("time-period-selector", { id: "custom-recurrence-time-period", exportparts: "tps__number-dropdown: netimeslot__number-dropdown, tps__number-dropdown-button: netimeslot__number-dropdown-button, tps__number-dropdown-content: netimeslot__number-dropdown-content, tps__period-dropdown: netimeslot__period-dropdown, tps__period-dropdown-button: netimeslot__period-dropdown-button, tps__period-dropdown-content: netimeslot__period-dropdown-content", timePeriods: [
                { value: 'day', label: instance.t('timePeriod', { context: 'day' }) },
                { value: 'week', label: instance.t('timePeriod', { context: 'week' }) },
                { value: 'month', label: instance.t('timePeriod', { context: 'month' }) },
                { value: 'year', label: instance.t('timePeriod', { context: 'year' }) },
            ], defaultSelectedNumber: this.repeatEveryInterval, defaultSelectedPeriod: this.repeatEveryFrequency }))), h("div", { class: "repeat-on" }, this.selectedRecurrenceType === 'custom' && this.repeatEveryFrequency === 'week' && (h("div", { class: "days" }, h("label", null, instance.t('nylasEventTimeslot.customRecurrence.repeatOn')), h("div", { class: "buttons" }, [
            { label: 'S', value: 'SU', title: 'Sunday' },
            { label: 'M', value: 'MO', title: 'Monday' },
            { label: 'T', value: 'TU', title: 'Tuesday' },
            { label: 'W', value: 'WE', title: 'Wednesday' },
            { label: 'T', value: 'TH', title: 'Thursday' },
            { label: 'F', value: 'FR', title: 'Friday' },
            { label: 'S', value: 'SA', title: 'Saturday' },
        ].map(day => (h("button", { class: { selected: this.repeatOnDays.includes(day.value) }, title: day.title, onClick: () => {
                this.repeatOnDays = this.repeatOnDays.includes(day.value) ? this.repeatOnDays.filter(d => d !== day.value) : [...this.repeatOnDays, day.value];
                this.handleValueChanged();
            } }, day.label)))))), this.selectedRecurrenceType === 'custom' && this.repeatEveryFrequency === 'month' && (h("div", { class: "month-recurrence" }, h("span", null), h("select-dropdown", { withSearch: false, id: "month-recurrence-type", name: "month-recurrence-type", options: this.monthRecurrenceOptions, defaultSelectedOption: this.repeatMonthlySameDate ? this.monthRecurrenceOptions[0] : this.monthRecurrenceOptions[1], exportparts: "sd_dropdown: netimeslot__dropdown, sd_dropdown-button: netimeslot__dropdown-button, sd_dropdown-content: netimeslot__dropdown-content" }))), h("div", { class: "custom-recurrence" }, this.selectedRecurrenceType === 'custom' && (h("div", { class: "custom-recurrence-ends" }, h("label", { htmlFor: "recurrence-type" }, instance.t('nylasEventTimeslot.customRecurrence.ends')), h("select-dropdown", { withSearch: false, id: "custom-recurrence-end-type", name: "custom-recurrence-end-type", options: endOptions, defaultSelectedOption: endOptions.find(option => option.value === this.repeatEndType), exportparts: "sd_dropdown: netimeslot__dropdown, sd_dropdown-button: netimeslot__dropdown-button, sd_dropdown-content: netimeslot__dropdown-content" }))), this.selectedRecurrenceType === 'custom' && this.repeatEndType === 'on' && (h("div", null, h("nylas-date-component", { name: "custom-recurrence-end-date", minDate: today.toISOString().split('T')[0], defaultValue: this.repeatEndOn || defaultEndOnDate, id: 'custom-recurrence-end-date', required: true }))), this.selectedRecurrenceType === 'custom' && this.repeatEndType === 'after' && (h("div", { class: "custom-recurrence-end-after" }, h("input-component", { name: "recurrence-end-after", id: "recurrence-end-after", type: "number", minValue: 1, defaultValue: defaultEndAfter.toString(), exportparts: "ic_input: netimeslot__input-textfield" }), h("span", null, instance.t('nylasEventTimeslot.customRecurrence.occurrences'))))))))))));
    }
    static get formAssociated() { return true; }
    get host() { return this; }
    static get watchers() { return {
        "name": ["elementNameChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }; }
    static get style() { return NylasEventTimeslotStyle0; }
}, [65, "nylas-event-timeslot", {
        "name": [1],
        "initialValue": [16],
        "selectedLanguage": [1, "selected-language"],
        "currentUser": [16],
        "selectedDate": [32],
        "selectedStartTime": [32],
        "selectedEndTime": [32],
        "selectedTimezone": [32],
        "selectedRecurrenceType": [32],
        "timeRangeError": [32],
        "selectedRrule": [32],
        "recurrenceOptions": [32],
        "repeatEveryInterval": [32],
        "repeatEveryFrequency": [32],
        "repeatOnDays": [32],
        "repeatMonthlySameDate": [32],
        "repeatEndType": [32],
        "repeatEndAfter": [32],
        "repeatEndOn": [32],
        "monthRecurrenceOptions": [32],
        "endDate": [32],
        "hasDateTimeInputError": [32]
    }, [[0, "timeChange", "setTime"], [0, "nylasFormDropdownChanged", "nylasFormDropdownChangedHandler"], [0, "nylasFormInputChanged", "nylasFormInputChangedHandler"], [0, "timePeriodChanged", "timePeriodChangedHandler"]], {
        "name": ["elementNameChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }]);
__decorate([
    RegisterComponent({
        name: 'nylas-event-timeslot',
        stateToProps: new Map([
            ['schedulerConfig.selectedLanguage', 'selectedLanguage'],
            ['schedulerConfig.currentUser', 'currentUser'],
        ]),
        eventToProps: {
            valueChanged: async (event, _nylasConnector) => {
                debug('nylas-event-timeslot', 'valueChanged', event.detail);
            },
        },
        fireRegisterEvent: true,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NylasEventTimeslot.prototype, "render", null);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["nylas-event-timeslot", "chevron-icon", "globe-icon", "input-component", "input-dropdown", "nylas-date-component", "nylas-time-window-picker", "search-icon", "select-dropdown", "time-period-selector"];
    components.forEach(tagName => { switch (tagName) {
        case "nylas-event-timeslot":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, NylasEventTimeslot);
            }
            break;
        case "chevron-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$9();
            }
            break;
        case "globe-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$8();
            }
            break;
        case "input-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$7();
            }
            break;
        case "input-dropdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "nylas-date-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "nylas-time-window-picker":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "search-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "select-dropdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "time-period-selector":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { NylasEventTimeslot as N, defineCustomElement as d };

//# sourceMappingURL=nylas-event-timeslot2.js.map