import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { R as RegisterComponent } from './register-component.js';
import { b as instance, a as debug, F as parsePreviewLink, M as getCalendarRange } from './utils.js';
import { n as nr, E as ErrorCategory } from './index3.js';
import { C as CONFIGURATION_EVENT_TYPE } from './constants.js';
import { d as defineCustomElement$d } from './button-component2.js';
import { d as defineCustomElement$c } from './calendar.js';
import { d as defineCustomElement$b } from './chevron.js';
import { d as defineCustomElement$a } from './close.js';
import { d as defineCustomElement$9 } from './copy.js';
import { d as defineCustomElement$8 } from './delete.js';
import { d as defineCustomElement$7 } from './edit.js';
import { d as defineCustomElement$6 } from './eye.js';
import { d as defineCustomElement$5 } from './loading.js';
import { d as defineCustomElement$4 } from './nylas-notification2.js';
import { d as defineCustomElement$3 } from './search.js';
import { d as defineCustomElement$2 } from './select-dropdown2.js';
import { d as defineCustomElement$1 } from './warning.js';

const nylasListConfigurationsCss = ":host{display:grid;grid-auto-flow:row;width:100%;font-family:inherit;font-optical-sizing:auto;--nylas-primary:#2563eb;--nylas-error:#cc4841;--nylas-error-pressed:#992222;--nylas-wraning:#f06c00;--nylas-success:#16a392;--nylas-info:#2b8fc2;--nylas-base-0:#ffffff;--nylas-base-25:#fcfcfd;--nylas-base-50:#f8f9fc;--nylas-base-100:#eaecf5;--nylas-base-200:#d5d9eb;--nylas-base-300:#b3b8d8;--nylas-base-400:#717bbc;--nylas-base-500:#4e5ba6;--nylas-base-600:#3e4784;--nylas-base-700:#263f72;--nylas-base-800:#293056;--nylas-base-900:#101323;--nylas-base-950:#0e101b;--nylas-color-blue-100:#e0e6f9;--nylas-border-radius:0.25rem;--nylas-border-radius-2x:0.5rem;--nylas-border-radius-3x:0.75rem;--nylas-font-family:\"Inter\", sans-serif;--nylas-color-black:#000000;--nylas-color-grey-900:#2c2c2c;--nylas-color-grey-800:#4b4b4b;--nylas-color-grey-700:#6e6e6e;--nylas-color-grey-600:#8e8e8e;--nylas-color-grey-500:#b3b3b3;--nylas-color-grey-400:#cacaca;--nylas-color-grey-300:#e1e1e1;--nylas-color-grey-200:#eaeaea;--nylas-color-grey-100:#f5f5f5;--nylas-color-grey-50:#fbfcfe;--nylas-color-white:#ffffff;--nylas-color-red-900:#992222;--nylas-color-red-700:#cc4841;--nylas-color-red-500:#ff786a;--nylas-color-red-300:#ffa79e;--nylas-color-red-100:#ffc5bf;--nylas-color-red-50:#ffeae8;--nylas-color-blue-900:#213571;--nylas-color-blue-700:#314fa9;--nylas-color-blue-500:#4169e1;--nylas-color-blue-300:#bdccf9;--nylas-color-blue-100:#e0e6f9;--nylas-color-blue-50:#f6f8fd;--nylas-color-yellow-900:#7c6506;--nylas-color-yellow-700:#c29f09;--nylas-color-yellow-500:#f7c90b;--nylas-color-yellow-300:#f9de70;--nylas-color-yellow-100:#fceba9;--nylas-color-yellow-50:#fdf4ce;--nylas-color-green-900:#0e6b60;--nylas-color-green-700:#16a392;--nylas-color-green-500:#17c3b2;--nylas-color-green-300:#74dbd1;--nylas-color-green-100:#a2e7e0;--nylas-color-green-50:#d1f3f0;--nylas-color-purple-900:#643554;--nylas-color-purple-700:#954f7d;--nylas-color-purple-500:#c769a7;--nylas-color-purple-300:#dda5ca;--nylas-color-purple-100:#e0bdd6;--nylas-color-purple-50:#e9dde5;--nylas-color-sky-900:#20698f;--nylas-color-sky-700:#2b8fc2;--nylas-color-sky-500:#6dceff;--nylas-color-sky-300:#8fdaff;--nylas-color-sky-100:#b8e7ff;--nylas-color-sky-50:#d9f2ff}.header{display:flex;align-items:center;justify-content:space-between;margin-bottom:1rem;gap:1rem}@media screen and (max-width: 768px){.header{flex-direction:column;gap:0.5rem;align-items:unset}}.header h2{margin:0;font-size:1.25rem;color:var(--nylas-base-900);font-weight:600}.header p{margin:0;font-size:16px;color:var(--nylas-base-700)}.header .actions{justify-self:end}@media screen and (max-width: 768px){.header .actions{width:100%}}.configurations{border:1px solid var(--nylas-base-200);border-radius:var(--nylas-border-radius-2x);background:var(--nylas-base-0);height:100%;display:flex;flex-direction:column;position:relative;overflow-y:hidden}.configurations .table-container{overflow-y:auto;flex:1}@media screen and (max-width: 768px){.configurations .table-container{min-height:624px}}.configurations .table-container table{width:100%;border-spacing:0;border-collapse:collapse;font-family:inherit;height:max-content}.configurations .table-container table.no-configurations{height:100%}.configurations .table-container table tr{color:var(--nylas-base-800);border-bottom:1px solid var(--nylas-base-200);font-family:inherit}.configurations .table-container table tr.hide{display:none}.configurations .table-container table th{font-weight:600;text-transform:uppercase;font-size:14px;line-height:20px}.configurations .table-container table tr.no-configurations td>div{display:flex;height:100%;justify-content:center;align-items:center;flex-direction:column;padding:var(--nylas-border-radius-3x)}.configurations .table-container table tr.no-configurations td>div h3{margin:0 0 1rem 0;color:var(--nylas-base-700)}.configurations .table-container table tr.no-configurations td>div p{margin:0 0 1rem 0;color:var(--nylas-base-600)}.configurations .table-container table tr.no-configurations td>div calendar-icon{margin-bottom:1rem;color:var(--nylas-base-200)}.configurations .table-container table th,.configurations .table-container table td{text-align:left;padding:1rem;font-family:inherit}.configurations .table-container table .actions{display:flex;justify-content:flex-end;gap:1rem;text-align:right}.configurations .table-container table .actions button-component.edit-button{min-width:98px}@media screen and (max-width: 768px){.configurations .table-container table .actions{flex-direction:column;gap:0.5rem}}.configurations .table-container table .actions select-dropdown.last::part(sd_dropdown-content){bottom:54px}.configurations .table-container table .title{width:100%;max-width:300px}@media screen and (max-width: 768px){.configurations .table-container table .title{max-width:96px}}.configurations .table-container table .title div{white-space:nowrap;overflow:hidden;text-overflow:ellipsis}.configurations .table-container table .title div.config-event-title{font-weight:600}.configurations .table-container table .title div.config-event-description{font-size:0.75rem}.configurations .pagination{padding:1rem;position:sticky;top:100%;display:flex;justify-content:flex-end;gap:0.5rem;background:white;width:calc(100% - 2rem);z-index:2}.configurations .pagination td.arrows{display:flex;justify-content:flex-end;gap:0.5rem}.configurations .pagination button{display:flex;flex-direction:row;justify-content:center;align-items:center;height:3vh;width:3vh;min-width:3em;min-height:3em;cursor:pointer;border-radius:var(--nylas-border-radius-2x);border:1px solid var(--nylas-base-300);background-color:transparent;color:var(--nylas-base-800);cursor:pointer}.configurations .pagination button:hover:not(:disabled){border:1px solid var(--nylas-primary)}.configurations .pagination button:active{border:1px solid var(--nylas-base-800)}.configurations .pagination button:disabled{border:1px solid var(--nylas-base-100);background-color:transparent;color:var(--nylas-base-300);cursor:not-allowed}.configurations .pagination button.right{transform:rotate(180deg)}.error-container{margin-top:1.5rem}.error-container .error{color:var(--nylas-error);padding:0.5rem 0;margin:1rem 0 0}button-component#copy button{width:108px}select-dropdown{width:auto}select-dropdown::part(sd_dropdown-button){display:block;height:48px;padding:0px 16px 8px}@media screen and (max-width: 768px){select-dropdown::part(sd_dropdown-button){width:92px}}select-dropdown::part(sd_dropdown-content){width:120px;right:0}select-dropdown::part(sd_dropdown-labelhtml){display:flex;gap:0.5rem;align-items:center;color:var(--nylas-base-900)}select-dropdown::part(sd_dropdown-labelhtml):hover{color:var(--nylas-primary)}.card-wrapper{position:absolute;top:0;left:0;height:calc(100% + 4rem);width:-webkit-fill-available;width:-moz-available;width:fill-available;display:flex;flex-direction:column;justify-content:center;align-items:center;background:rgba(0, 0, 0, 0.6);z-index:2;border-radius:var(--nylas-border-radius-2x)}@media screen and (max-width: 768px){.card-wrapper{justify-content:start;height:100%}}.card-modal{background:var(--nylas-base-0);display:flex;flex-direction:column;font-family:var(--nylas-font-family);background-color:var(--nylas-base-0);color:var(--nylas-base-900);border-radius:var(--nylas-border-radius-3x);padding:32px;width:562px;box-shadow:0px 1px 4px rgba(0, 0, 0, 0.1), 0px 3px 6px rgba(0, 0, 0, 0.06)}@media screen and (max-width: 768px){.card-modal{width:auto;border-radius:0px}}.description.title-desc{margin-bottom:2rem}.description p{margin:0;font-size:18px;color:var(--nylas-base-600)}.footer{margin-top:1rem;padding-top:1rem;display:flex;justify-content:flex-end;gap:0.5rem;box-sizing:border-box;background-color:var(--nylas-base-25);width:100%;border-radius:0 0 var(--nylas-border-radius-2x) var(--nylas-border-radius-2x)}.close-button{width:100%;display:flex;justify-content:flex-end}.close-button button-component button{padding:0;height:auto}.close-button button-component button:hover{background-color:transparent !important}button-component{--dot-color:var(--nylas-base-700)}";
const NylasListConfigurationsStyle0 = nylasListConfigurationsCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
const NylasListConfigurations = proxyCustomElement(class NylasListConfigurations extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.initListConfigurations = createEvent(this, "initListConfigurations", 7);
        this.createButtonClick = createEvent(this, "createButtonClick", 7);
        this.editButtonClick = createEvent(this, "editButtonClick", 7);
        this.deleteButtonClick = createEvent(this, "deleteButtonClick", 7);
        this.nylasSchedulerError = createEvent(this, "nylasSchedulerError", 6);
        this.dismissNotification = createEvent(this, "dismissNotification", 6);
        this.configurations = [];
        this.selectedLanguage = undefined;
        this.schedulerPreviewLink = '';
        this.listConfigurationsNextCursor = undefined;
        this.state = 'loading';
        this.error = {
            message: '',
            type: nr.Error,
            category: ErrorCategory.Component,
            title: '',
        };
        this.currentCursor = null;
        this.previousCursors = [];
        this.disableNextPageButton = false;
        this.deleteConfigurationId = '';
        this.showDeleteButtonLoading = false;
        this.editButtonLoadingId = '';
    }
    listConfigurationsNextCursorChangedHandler(newVal, oldVal) {
        if (!newVal || newVal === oldVal) {
            if (newVal === null) {
                this.disableNextPageButton = true;
            }
            return;
        }
        this.disableNextPageButton = false;
        this.currentCursor = newVal;
    }
    selectedLanguageChangedHandler(newVal, oldVal) {
        if (newVal === oldVal)
            return;
        instance.changeLanguage(newVal);
    }
    connectedCallback() {
        debug('[nylas-list-configurations]', 'connectedCallback');
    }
    componentWillLoad() {
        debug('[nylas-list-configurations]', 'componentWillLoad');
        if (this.configurations && this.configurations.length > 0) {
            this.state = 'loaded';
        }
    }
    componentDidLoad() {
        debug('[nylas-list-configurations]', 'componentDidLoad');
        this.initListConfigurations.emit({
            host: this.host,
        });
    }
    disconnectedCallback() {
        debug('[nylas-list-configurations]', 'disconnectedCallback');
    }
    async handleNylasFormDropdownChanged(event) {
        debug('[nylas-list-configurations]', 'handleNylasFormDropdownChanged', event.detail);
        const { value } = event.detail;
        const [action, index] = value.split('-');
        event.preventDefault();
        switch (action) {
            case 'delete':
                this.deleteConfigurationId = this.configurations[index]?.id;
                break;
            case 'preview':
                window.open(parsePreviewLink(this.schedulerPreviewLink, this.configurations[index]), '_blank');
                break;
            case 'copy':
                await navigator.clipboard.writeText(parsePreviewLink(this.schedulerPreviewLink, this.configurations[index]));
                break;
        }
    }
    async registerCallback() {
        this.initListConfigurations.emit({
            host: this.host,
        });
    }
    async getState() {
        return this.state;
    }
    async setState(state) {
        this.state = state;
    }
    async setError(error) {
        this.error = {
            message: error.message,
            type: error.type,
            category: error.category,
            title: error.title || instance.t('genericErrorTitle'),
        };
        if (this.error?.message) {
            this.showErrorNotification(this.error);
        }
    }
    async hideDeleteConfirmation() {
        this.deleteConfigurationId = '';
        this.showDeleteButtonLoading = false;
    }
    async hideEditButtonLoading() {
        this.editButtonLoadingId = '';
    }
    showErrorNotification(error) {
        this.nylasSchedulerError.emit({
            notification: {
                id: error.message.split(' ').join('-'),
                type: error.type || nr.Error,
                title: error.title,
                category: error.category || ErrorCategory.Component,
                description: error.message,
                ttl: 'none',
            },
            host: this.host,
        });
    }
    closeModal(e) {
        e.preventDefault();
        this.deleteConfigurationId = '';
    }
    handleConfirmDeleteButtonClicked(e) {
        e.preventDefault();
        this.showDeleteButtonLoading = true;
        const config = this.configurations.find(config => config.id === this.deleteConfigurationId);
        if (config && config?.id) {
            this.deleteButtonClick.emit({ host: this.host, configuration: config });
        }
    }
    getDurationString(duration) {
        if (!duration)
            return '—';
        const hours = Math.floor(duration / 60);
        const minutes = duration % 60;
        return `${hours ? hours : ''} ${hours ? `${hours > 1 ? 'hours' : 'hour'}` : ''} ${minutes ? minutes : ''} ${minutes ? `${minutes > 1 ? 'mins' : 'min'}` : ''}`;
    }
    getActionLabelHTML(action) {
        const actionStyle = {
            display: 'inline-flex',
            alignItems: 'center',
            gap: '0.5rem',
        };
        const dangerStyle = {
            color: 'var(--nylas-error)',
        };
        switch (action) {
            case 'preview':
                return (h("span", { style: actionStyle }, h("eye-icon", { width: "16", height: "16" }), instance.t('nylasListConfigurations.previewButtonText')));
            case 'copy':
                return (h("span", { style: actionStyle }, h("copy-icon", { width: "16", height: "16" }), instance.t('nylasListConfigurations.copyLinkButtonText')));
            case 'delete':
                return (h("span", { style: { ...actionStyle, ...dangerStyle } }, h("delete-icon", { width: "15", height: "17" }), instance.t('nylasListConfigurations.deleteButtonText')));
            default:
                return '';
        }
    }
    previousPageClickedHandler() {
        if (this.previousCursors.length === 0)
            return;
        this.currentCursor = this.previousCursors.pop() || null;
        const prevCursor = this.previousCursors[this.previousCursors.length - 1] || undefined;
        this.initListConfigurations.emit({
            host: this.host,
            cursor: prevCursor,
        });
    }
    nextPageClickedHandler() {
        if (!this.currentCursor)
            return;
        this.previousCursors = [...this.previousCursors, this.currentCursor];
        this.initListConfigurations.emit({
            host: this.host,
            cursor: this.currentCursor,
        });
    }
    render() {
        return (h(Host, null, h("nylas-notification", null), h("div", { class: "header" }, h("div", { class: "description" }, h("h2", null, instance.t('allSchedulingPages')), h("p", null, instance.t('createAndManageSchedulingPages'))), this.configurations && this.configurations.length > 0 && (h("div", { class: "actions" }, h("button-component", { part: "nlc__create-new-cta", clickHandler: () => {
                this.createButtonClick.emit(this.host);
            } }, instance.t('createNewSchedulingPageButtonText'))))), h("div", { class: "configurations" }, h("div", { class: "table-container" }, h("table", { class: {
                'no-configurations': this.state !== 'loading' && (!this.configurations || this.configurations.length === 0),
            } }, h("tr", { class: {
                hide: this.state === 'loading' || (this.configurations && this.configurations.length === 0),
            } }, h("th", null, instance.t('pageTitle')), h("th", null, instance.t('durationTitle')), h("th", null)), this.state === 'loading' && (h("tr", { class: "no-configurations" }, h("td", { colSpan: 3 }, h("div", null, h("h3", null, instance.t('loading'), "..."), h("p", null, instance.t('loadingPagesDescription')))))), this.state !== 'loading' && (!this.configurations || this.configurations.length === 0) && (h("tr", { class: "no-configurations" }, h("td", { colSpan: 3 }, h("div", null, h("calendar-icon", { width: "48", height: "48" }), h("h3", null, instance.t('noSchedulingPages')), h("p", null, instance.t('createFirstSchedulingPage')), h("button-component", { part: "nlc__create-new-cta", clickHandler: () => {
                this.createButtonClick.emit(this.host);
            } }, instance.t('createNewSchedulingPageButtonText')))))), this.state !== 'loading' &&
            this.configurations?.map((config, i) => {
                const lastTwo = (i === this.configurations.length - 1 || i === this.configurations.length - 2) && this.configurations.length > 3;
                const groupConfig = config;
                const regularConfig = config;
                return (h("tr", { key: config?.id }, h("td", null, h("div", { class: "title" }, h("div", { class: "config-event-title", title: regularConfig?.event_booking?.title }, regularConfig?.event_booking?.title || groupConfig?.name), h("div", { class: 'config-event-description' }, regularConfig?.event_booking?.description))), h("td", null, h("div", { class: "duration" }, this.getDurationString(regularConfig?.availability?.duration_minutes))), h("td", null, h("div", { class: "actions" }, h("button-component", { class: "edit-button", variant: 'basic', key: `edit-${i}`, disabled: this.editButtonLoadingId === `edit-${i}`, isLoading: this.editButtonLoadingId === `edit-${i}`, clickHandler: event => {
                        event.preventDefault();
                        this.editButtonLoadingId = `edit-${i}`;
                        this.editButtonClick.emit({ host: this.host, configuration: config });
                    } }, this.editButtonLoadingId === `edit-${i}` ? null : h("edit-icon", { width: "16", height: "16" }), instance.t('editSchedulingPageButtonText')), h("select-dropdown", { class: {
                        last: lastTwo,
                    }, name: "actions", options: [
                        { value: `preview-${i}`, label: 'Preview', labelHTML: this.getActionLabelHTML('preview') },
                        { value: `copy-${i}`, label: 'Copy link', labelHTML: this.getActionLabelHTML('copy') },
                        { value: `delete-${i}`, label: 'Delete', labelHTML: this.getActionLabelHTML('delete') },
                    ], defaultSelectedOption: { value: '', label: '' }, dropdownButtonText: "...", withSearch: false, withChevron: false, exportparts: "sd_dropdown: actions__dropdown, sd_dropdown-button: actions__dropdown-button, sd_dropdown-content: actions__dropdown-content, actions-Copy, actions-Preview, actions-Delete" })))));
            }))), h("div", { class: "pagination" }, h("button", { class: "arrow left", onClick: () => this.previousPageClickedHandler(), disabled: this.previousCursors.length <= 0 }, h("chevron-icon", null)), h("button", { class: "arrow right", onClick: () => this.nextPageClickedHandler(), disabled: this.disableNextPageButton }, h("chevron-icon", null)))), !!this.deleteConfigurationId && (h("div", { class: "card-wrapper" }, h("div", { class: "card-modal" }, h("div", { class: "close-button" }, h("button-component", { tooltip: "Close", id: "close", variant: 'invisible', onClick: e => this.closeModal(e), part: "nfbf__close-button" }, h("close-icon", null))), h("div", { class: "header" }, h("h2", { slot: "card-title", part: "nfbf__title" }, instance.t('deleteSchedulingPageTitle'))), h("div", { class: "description title-desc" }, h("p", null, instance.t('deleteSchedulingPageDescription'))), h("div", { class: {
                footer: true,
            } }, h("button-component", { variant: 'basic', onClick: e => this.closeModal(e), part: "nfbf__button-outline nfbf__cancel-cta" }, `${instance.t('deleteSchedulingPageCancelButton')}`), h("button-component", { variant: 'destructive', onClick: e => this.handleConfirmDeleteButtonClicked(e), disabled: this.showDeleteButtonLoading, isLoading: this.showDeleteButtonLoading, part: "nfbf__button-outline nfbf__reschedule-cta" }, `${instance.t('deleteSchedulingPageConfirmButton')}`)))))));
    }
    get host() { return this; }
    static get watchers() { return {
        "listConfigurationsNextCursor": ["listConfigurationsNextCursorChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }; }
    static get style() { return NylasListConfigurationsStyle0; }
}, [1, "nylas-list-configurations", {
        "configurations": [16],
        "selectedLanguage": [1, "selected-language"],
        "schedulerPreviewLink": [1, "scheduler-preview-link"],
        "listConfigurationsNextCursor": [1, "list-configurations-next-cursor"],
        "state": [32],
        "error": [32],
        "currentCursor": [32],
        "previousCursors": [32],
        "disableNextPageButton": [32],
        "deleteConfigurationId": [32],
        "showDeleteButtonLoading": [32],
        "editButtonLoadingId": [32],
        "registerCallback": [64],
        "getState": [64],
        "setState": [64],
        "setError": [64],
        "hideDeleteConfirmation": [64],
        "hideEditButtonLoading": [64]
    }, [[0, "nylasFormDropdownChanged", "handleNylasFormDropdownChanged"]], {
        "listConfigurationsNextCursor": ["listConfigurationsNextCursorChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }]);
__decorate([
    RegisterComponent({
        name: 'nylas-list-configurations',
        stateToProps: new Map([
            ['schedulerConfig.configurations', 'configurations'],
            ['schedulerConfig.listConfigurationsNextCursor', 'listConfigurationsNextCursor'],
            ['schedulerConfig.selectedLanguage', 'selectedLanguage'],
        ]),
        localPropsToProp: new Map([['schedulerPreviewLink', 'schedulerPreviewLink']]),
        eventToProps: {
            initListConfigurations: async (event, connector) => {
                const { host, cursor } = event.detail;
                await host.setState('loading');
                const [data, error] = await connector.schedulerConfig.getConfigurations(cursor);
                if (!data && error && error.message) {
                    await host.setState('error');
                    await host.setError({
                        message: error.message,
                        type: nr.Error,
                        category: ErrorCategory.Component,
                        title: instance.t('nylasEditorTabs.getConfigsError'),
                    });
                    return;
                }
                await host.setState('loaded');
            },
            createButtonClick: async (_, connector) => {
                connector.schedulerConfigStore.resetSelectedConfiguration();
                const enabledEventTypes = Object.entries(connector.schedulerConfigStore.state.enableEventTypes || {}).filter(([_key, value]) => value);
                if (enabledEventTypes.length === 1) {
                    connector.schedulerConfigStore.state.action = 'create';
                    connector.schedulerConfigStore.state.selectedEventType = CONFIGURATION_EVENT_TYPE[enabledEventTypes[0][0]];
                }
                else {
                    connector.schedulerConfigStore.state.action = 'create-select';
                }
            },
            deleteButtonClick: async (event, connector) => {
                const { host, configuration } = event.detail;
                const [data, error] = await connector.schedulerConfig.deleteConfiguration(configuration.id);
                if (!data && error && error.message) {
                    await host.setState('error');
                    await host.setError({
                        message: error.message,
                        type: nr.Error,
                        category: ErrorCategory.Component,
                        title: instance.t('nylasEditorTabs.deleteConfigError'),
                    });
                }
                await host.hideDeleteConfirmation();
            },
            editButtonClick: async (event, connector) => {
                const { host, configuration } = event.detail;
                if (configuration.type === 'group') {
                    const { startTime, endTime } = getCalendarRange(new Date().toISOString(), 'week');
                    connector.schedulerConfigStore.state.calendarViewDateRange = {
                        start_time: startTime.toString(),
                        end_time: endTime.toString(),
                    };
                    const [data, error] = await connector.schedulerConfig.getGroupEvents(configuration.id, configuration);
                    if (!data && error && error.message) {
                        await host.setError({
                            message: error.message,
                            type: nr.Error,
                            category: ErrorCategory.Component,
                            title: instance.t('nylasEditorTabsGroup.getGroupEventsError'),
                        });
                        host.hideEditButtonLoading();
                        return;
                    }
                }
                connector.schedulerConfigStore.state.action = 'edit';
                connector.schedulerConfigStore.state.selectedConfiguration = configuration;
                host.hideEditButtonLoading();
            },
        },
        fireRegisterEvent: true,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NylasListConfigurations.prototype, "render", null);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["nylas-list-configurations", "button-component", "calendar-icon", "chevron-icon", "close-icon", "copy-icon", "delete-icon", "edit-icon", "eye-icon", "loading-icon", "nylas-notification", "search-icon", "select-dropdown", "warning-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "nylas-list-configurations":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, NylasListConfigurations);
            }
            break;
        case "button-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$d();
            }
            break;
        case "calendar-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$c();
            }
            break;
        case "chevron-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$b();
            }
            break;
        case "close-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$a();
            }
            break;
        case "copy-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$9();
            }
            break;
        case "delete-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$8();
            }
            break;
        case "edit-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$7();
            }
            break;
        case "eye-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$6();
            }
            break;
        case "loading-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$5();
            }
            break;
        case "nylas-notification":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "search-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "select-dropdown":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "warning-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { NylasListConfigurations as N, defineCustomElement as d };

//# sourceMappingURL=nylas-list-configurations2.js.map