import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { R as RegisterComponent } from './register-component.js';
import { a as debug, b as instance } from './utils.js';
import { C as CONFIGURATION_EVENT_TYPE } from './constants.js';
import { d as defineCustomElement$3 } from './button-component2.js';
import { d as defineCustomElement$2 } from './chevron.js';
import { d as defineCustomElement$1 } from './loading.js';

const nylasSelectEventTypeCss = ":host{display:block;--nylas-primary:#2563eb;--nylas-error:#cc4841;--nylas-error-pressed:#992222;--nylas-wraning:#f06c00;--nylas-success:#16a392;--nylas-info:#2b8fc2;--nylas-base-0:#ffffff;--nylas-base-25:#fcfcfd;--nylas-base-50:#f8f9fc;--nylas-base-100:#eaecf5;--nylas-base-200:#d5d9eb;--nylas-base-300:#b3b8d8;--nylas-base-400:#717bbc;--nylas-base-500:#4e5ba6;--nylas-base-600:#3e4784;--nylas-base-700:#263f72;--nylas-base-800:#293056;--nylas-base-900:#101323;--nylas-base-950:#0e101b;--nylas-color-blue-100:#e0e6f9;--nylas-border-radius:0.25rem;--nylas-border-radius-2x:0.5rem;--nylas-border-radius-3x:0.75rem;--nylas-font-family:\"Inter\", sans-serif;--nylas-color-black:#000000;--nylas-color-grey-900:#2c2c2c;--nylas-color-grey-800:#4b4b4b;--nylas-color-grey-700:#6e6e6e;--nylas-color-grey-600:#8e8e8e;--nylas-color-grey-500:#b3b3b3;--nylas-color-grey-400:#cacaca;--nylas-color-grey-300:#e1e1e1;--nylas-color-grey-200:#eaeaea;--nylas-color-grey-100:#f5f5f5;--nylas-color-grey-50:#fbfcfe;--nylas-color-white:#ffffff;--nylas-color-red-900:#992222;--nylas-color-red-700:#cc4841;--nylas-color-red-500:#ff786a;--nylas-color-red-300:#ffa79e;--nylas-color-red-100:#ffc5bf;--nylas-color-red-50:#ffeae8;--nylas-color-blue-900:#213571;--nylas-color-blue-700:#314fa9;--nylas-color-blue-500:#4169e1;--nylas-color-blue-300:#bdccf9;--nylas-color-blue-100:#e0e6f9;--nylas-color-blue-50:#f6f8fd;--nylas-color-yellow-900:#7c6506;--nylas-color-yellow-700:#c29f09;--nylas-color-yellow-500:#f7c90b;--nylas-color-yellow-300:#f9de70;--nylas-color-yellow-100:#fceba9;--nylas-color-yellow-50:#fdf4ce;--nylas-color-green-900:#0e6b60;--nylas-color-green-700:#16a392;--nylas-color-green-500:#17c3b2;--nylas-color-green-300:#74dbd1;--nylas-color-green-100:#a2e7e0;--nylas-color-green-50:#d1f3f0;--nylas-color-purple-900:#643554;--nylas-color-purple-700:#954f7d;--nylas-color-purple-500:#c769a7;--nylas-color-purple-300:#dda5ca;--nylas-color-purple-100:#e0bdd6;--nylas-color-purple-50:#e9dde5;--nylas-color-sky-900:#20698f;--nylas-color-sky-700:#2b8fc2;--nylas-color-sky-500:#6dceff;--nylas-color-sky-300:#8fdaff;--nylas-color-sky-100:#b8e7ff;--nylas-color-sky-50:#d9f2ff;width:inherit}.nylas-select-event-type{height:inherit;overflow-y:auto}.nylas-select-event-type div.header{display:flex;justify-content:space-between;align-items:center;border-bottom:1px solid var(--nylas-base-200)}.nylas-select-event-type div.header h2{font-size:18px;padding:0 24px;line-height:24px;margin:0;font-weight:600;color:var(--nylas-base-800)}.nylas-select-event-type div.header button-component button{background:transparent;border:none;cursor:pointer}.nylas-select-event-type div.header button-component button:hover,.nylas-select-event-type div.header button-component button:active{color:var(--nylas-primary);background-color:transparent}.nylas-select-event-type div.header button-component button:disabled{cursor:not-allowed}.nylas-select-event-type div.content{padding:40px}.nylas-select-event-type div.content h3{margin:0 0 32px 0;font-size:18px;line-height:24px;font-weight:600}.nylas-select-event-type div.content div.event-type{display:flex;flex-direction:column;gap:8px}.nylas-select-event-type div.content div.event-type div.event-type-option{padding:16px;border:1px solid var(--nylas-base-200);border-radius:var(--nylas-border-radius-3x);width:inherit;cursor:pointer;display:flex;flex-direction:column;gap:8px}.nylas-select-event-type div.content div.event-type div.event-type-option h4{margin:0;font-size:16px;line-height:24px;font-weight:600;color:var(--nylas-base-900)}.nylas-select-event-type div.content div.event-type div.event-type-option p{margin:0;font-size:14px;line-height:21px;font-weight:400;color:var(--nylas-base-800)}";
const NylasSelectEventTypeStyle0 = nylasSelectEventTypeCss;

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r = Reflect.decorate(decorators, target, key, desc);
    else
        for (var i = decorators.length - 1; i >= 0; i--)
            if (d = decorators[i])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(k, v);
};
const NylasSelectEventType = proxyCustomElement(class NylasSelectEventType extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.returnToAllSchedulingPagesEvent = createEvent(this, "returnToAllSchedulingPagesEvent", 7);
        this.createEventTypeSelected = createEvent(this, "createEventTypeSelected", 7);
        this.participantOptions = undefined;
        this.name = 'select-event-type';
        this.selectedLanguage = undefined;
        this.enableEventTypes = {
            one_on_one: true,
            collective: true,
            max_fairness: true,
            max_availability: true,
            group: true,
        };
    }
    connectedCallback() {
        debug('nylas-select-event-type', 'connectedCallback');
    }
    disconnectedCallback() {
        debug('nylas-select-event-type', 'disconnectedCallback');
    }
    componentWillLoad() {
        debug('nylas-select-event-type', 'componentWillLoad');
        this.host.setAttribute('name', this.name);
    }
    componentDidLoad() {
        debug('nylas-select-event-type', 'componentDidLoad');
    }
    elementNameChangedHandler(newValue) {
        debug('nylas-select-event-type', 'elementNameChangedHandler', newValue);
        this.host.setAttribute('name', newValue);
    }
    selectedLanguageChangedHandler(newVal, oldVal) {
        if (newVal === oldVal)
            return;
        instance.changeLanguage(newVal);
    }
    render() {
        const eventTypeKey = {
            'one-on-one': 'one_on_one',
            'collective': 'collective',
            'max-fairness': 'max_fairness',
            'max-availability': 'max_availability',
            'group': 'group',
        };
        const allEventTypes = [
            {
                label: instance.t('nylasSelectEventType.eventTypeOptions.oneOnOne.label'),
                value: CONFIGURATION_EVENT_TYPE.one_on_one,
                description: instance.t('nylasSelectEventType.eventTypeOptions.oneOnOne.desc'),
            },
            {
                label: instance.t('nylasSelectEventType.eventTypeOptions.collective.label'),
                value: CONFIGURATION_EVENT_TYPE.collective,
                description: instance.t('nylasSelectEventType.eventTypeOptions.collective.desc'),
            },
            {
                label: instance.t('nylasSelectEventType.eventTypeOptions.maxFairness.label'),
                value: CONFIGURATION_EVENT_TYPE.max_fairness,
                description: instance.t('nylasSelectEventType.eventTypeOptions.maxFairness.desc'),
            },
            {
                label: instance.t('nylasSelectEventType.eventTypeOptions.maxAvailability.label'),
                value: CONFIGURATION_EVENT_TYPE.max_availability,
                description: instance.t('nylasSelectEventType.eventTypeOptions.maxAvailability.desc'),
            },
            {
                label: instance.t('nylasSelectEventType.eventTypeOptions.group.label'),
                value: CONFIGURATION_EVENT_TYPE.group,
                description: instance.t('nylasSelectEventType.eventTypeOptions.group.desc'),
            },
        ];
        const conditionalEventTypes = [CONFIGURATION_EVENT_TYPE.collective, CONFIGURATION_EVENT_TYPE.max_availability, CONFIGURATION_EVENT_TYPE.max_fairness];
        const hasAdditionalParticipants = this.participantOptions &&
            this.participantOptions?.length > 0 &&
            !!this.participantOptions[0].email &&
            !!this.participantOptions[0].name &&
            !!this.participantOptions[0].calendars &&
            this.participantOptions[0].calendars.length > 0;
        const eventTypes = this.enableEventTypes
            ? allEventTypes.filter(eventType => {
                const key = eventType.value;
                const keyType = eventTypeKey[key];
                console.log('key', key, this.enableEventTypes ? this.enableEventTypes[keyType] : 'no enableEventTypes');
                if (conditionalEventTypes.includes(key) && !hasAdditionalParticipants) {
                    return false;
                }
                return this.enableEventTypes && this.enableEventTypes[keyType];
            })
            : allEventTypes;
        return (h(Host, null, h("div", { class: "nylas-select-event-type", part: "nset" }, h("div", { class: "header", part: "nset__header" }, h("h2", null, instance.t('nylasSelectEventType.createEventHeaderTitle')), h("button-component", { variant: "invisible", part: "nset__header__back-button", onClick: _event => {
                this.returnToAllSchedulingPagesEvent.emit();
            } }, h("chevron-icon", { width: "16", height: "16" }), h("span", null, instance.t('nylasSelectEventType.returnToAllSchedulingPages')))), h("div", { class: "content", part: "nset__content" }, h("h3", null, instance.t('nylasSelectEventType.eventTypeHeaderTitle')), h("div", { class: "event-type", part: "nset__content__event-type" }, eventTypes.length === 0 && h("p", null, instance.t('nylasSelectEventType.noEventTypesEnabled')), eventTypes.map(eventType => (h("div", { class: "event-type-option", onClick: _event => {
                this.createEventTypeSelected.emit({ eventType: eventType.value });
            }, part: `nset__content__event-type-option-${eventType.value}` }, h("h4", null, eventType.label), h("p", null, eventType.description)))))))));
    }
    get host() { return this; }
    static get watchers() { return {
        "name": ["elementNameChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }; }
    static get style() { return NylasSelectEventTypeStyle0; }
}, [1, "nylas-select-event-type", {
        "participantOptions": [16],
        "name": [1],
        "selectedLanguage": [1, "selected-language"],
        "enableEventTypes": [16]
    }, undefined, {
        "name": ["elementNameChangedHandler"],
        "selectedLanguage": ["selectedLanguageChangedHandler"]
    }]);
__decorate([
    RegisterComponent({
        name: 'nylas-select-event-type',
        stateToProps: new Map([
            ['schedulerConfig.selectedLanguage', 'selectedLanguage'],
            ['schedulerConfig.additionalParticipants', 'participantOptions'],
            ['schedulerConfig.enableEventTypes', 'enableEventTypes'],
        ]),
        eventToProps: {
            returnToAllSchedulingPagesEvent: async (_event, connector) => {
                connector.schedulerConfigStore.state.action = null;
                connector.schedulerConfigStore.set('selectedEventType', undefined);
            },
            createEventTypeSelected: async (event, connector) => {
                const { eventType } = event.detail;
                connector.schedulerConfigStore.state.action = 'create';
                connector.schedulerConfigStore.state.selectedEventType = eventType;
            },
        },
        fireRegisterEvent: true,
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NylasSelectEventType.prototype, "render", null);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["nylas-select-event-type", "button-component", "chevron-icon", "loading-icon"];
    components.forEach(tagName => { switch (tagName) {
        case "nylas-select-event-type":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, NylasSelectEventType);
            }
            break;
        case "button-component":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "chevron-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "loading-icon":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { NylasSelectEventType as N, defineCustomElement as d };

//# sourceMappingURL=nylas-select-event-type2.js.map