import { OpenHours } from '@nylas/core';
export type Locale = Partial<{
    noDateSelected: string;
    rescheduleTitle: string;
    allDay: string;
    today: string;
    spotsLeft: string;
    search: string;
    selectOneOrMoreOptions: string;
    days: Partial<{
        sunday: string;
        monday: string;
        tuesday: string;
        wednesday: string;
        thursday: string;
        friday: string;
        saturday: string;
    }>;
    time: Partial<{
        hour: string;
        hours: string;
        minute: string;
        minutes: string;
        day: string;
        days: string;
        week: string;
        weeks: string;
        month: string;
        months: string;
        year: string;
        years: string;
    }>;
    months: Partial<{
        january: string;
        february: string;
        march: string;
        april: string;
        may: string;
        june: string;
        july: string;
        august: string;
        september: string;
        october: string;
        november: string;
        december: string;
    }>;
    multipleOptionsSelected: string;
    selectAtLeastOneOption: string;
    nextButton: string;
    selectedDayAndYear: string;
    selectedTime: string;
    name: string;
    namePlaceholder: string;
    email: string;
    emailPlaceholder: string;
    guestEmail: string;
    guestEmailPlaceholder: string;
    addGuest: string;
    addAnotherGuest: string;
    backButton: string;
    bookNowButton: string;
    bookingConfirmed: string;
    bookingConfirmedDescription: string;
    bookingSent: string;
    bookingSentDescription: string;
    bookingRescheduled: string;
    bookingDateAndTimeHeader: string;
    cancelBookingButton: string;
    rescheduleBookingButton: string;
    rejectBookingButton: string;
    confirmBookingButton: string;
    bookingPendingTitle: string;
    bookingPendingDescription: string;
    confirmedEventCardTitle: string;
    confirmedEventCardDescription: string;
    cancelBookingTitle: string;
    cancelBookingMessage: string;
    reasonForCancellation: string;
    goBackButton: string;
    bookingCancelledTitle: string;
    bookingCancelledMessage: string;
    bookingCancelledMessage_theParticipants: string;
    closeButton: string;
    closingButton: string;
    fieldRequired: string;
    invalidInputFormat: string;
    createBookingErrorTitle: string;
    getAvailabilityErrorTitle: string;
    cancelBookingErrorTitle: string;
    rescheduleBookingErrorTitle: string;
    getUISettingErrorTitle: string;
    rejectBookingErrorTitle: string;
    confirmBookingErrorTitle: string;
    genericErrorTitle: string;
    schedulingComponentErrorTitle: string;
    sessionIdRequiredErrorMessage: string;
    publicConfigErrorMessage: string;
    invalidTimeslotErrorTitle: string;
    invalidTimeslotErrorMessage: string;
    cancellationErrorTitle: string;
    cancellationErrorMessage: string;
    minimumCancellationErrorMessage: string;
    cancelBokingFormError: string;
    feedbackFormTitle: string;
    feedbackFormDescription: string;
    feedbackMessageLabel: string;
    feedbackMessagePlaceholder: string;
    feedbackModalCloseButton: string;
    feedbackModalSubmitButton: string;
    deleteSchedulingPageTitle: string;
    deleteSchedulingPageDescription: string;
    deleteSchedulingPageConfirmButton: string;
    deleteSchedulingPageCancelButton: string;
    schedulerEditorTitle: string;
    allSchedulingPages: string;
    createAndManageSchedulingPages: string;
    createNewSchedulingPageButtonText: string;
    pageTitle: string;
    durationTitle: string;
    loading: string;
    required: string;
    optional: string;
    loadingPagesDescription: string;
    noSchedulingPages: string;
    createFirstSchedulingPage: string;
    editSchedulingPageButtonText: string;
    eventInfoTab: string;
    availabilityTab: string;
    participantsTab: string;
    bookingOptionsTab: string;
    returnToCalendarView: string;
    bookingFormTab: string;
    communicationsTab: string;
    pageStylesTab: string;
    savingButtonText: string;
    saveChangesButtonText: string;
    createButtonText: string;
    timePeriod_day: string;
    timePeriod_week: string;
    timePeriod_month: string;
    timePeriod_year: string;
    timeDuration_minute: string;
    timeDuration_hour: string;
    eventCommunicationsTitle: string;
    eventCommunicationsDescription: string;
    unsavedChangesLabel: string;
    changesSavedLabel: string;
    fixFormErrors: string;
    pageSettingsButton: string;
    nylasEditorTabs: {
        bookingFormError: string;
        bookingFormError_label: string;
        bookingFormError_option: string;
    };
    nylasListConfigurations: Partial<{
        previewButtonText: string;
        copyLinkButtonText: string;
        deleteButtonText: string;
    }>;
    nylasAdditionalParticipants: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        organizerAsParticipant: string;
        organizer: string;
        participant: string;
        addParticipant_first: string;
        addParticipant_next: string;
        error: string;
        tooltip: {
            includeOrganizer: string;
            includeOrganizerDesc: string;
            excludeOrganizer: string;
            excludeOrganizerDesc: string;
        };
    }>;
    nylasAvailabilityPicker: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        tooltip: {
            desc: string;
        };
        selectTimezone: string;
        unavailable: string;
        days: Record<'SUN' | 'MON' | 'TUE' | 'WED' | 'THU' | 'FRI' | 'SAT', string>;
    }>;
    nylasTimeWindowPicker: Partial<{
        errors: {
            invalid: string;
        };
    }>;
    nylasBookingCalendarPicker: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        tooltip: {
            desc: string;
        };
        selectOptionLabel: string;
        selectCalendarErrorMessage: string;
    }>;
    nylasBookingConfirmationRedirect: Partial<{
        dropdownLabel: string;
        tooltip: {
            desc: string;
        };
        redirectOption_default: string;
        redirectOption_custom: string;
    }>;
    nylasBookingConfirmationType: Partial<{
        dropdownLabel: string;
        tooltip: {
            desc: string;
        };
        bookingOption_booking: string;
        bookingOption_organizerConfirmation: string;
    }>;
    nylasBookingFormConfig: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        dropdownButtonText: string;
        addOption: string;
        allOptionsHeader: string;
        fieldInTitleError: string;
        fieldInDescriptionError: string;
        label: string;
        defaultValue: string;
        fieldType: {
            text: string;
            multi_line_text: string;
            email: string;
            phone_number: string;
            dropdown: string;
            radio_button: string;
            checkbox: string;
            date: string;
            metadata: string;
            multi_select: string;
        };
        fieldLabel: {
            your_name: string;
            your_email: string;
            email: string;
            phone_number: string;
            dropdown: string;
            text: string;
            multi_line_text: string;
            radio_button: string;
            checkbox: string;
            date: string;
            metadata: string;
            multi_select: string;
        };
    }>;
    nylasBufferTime: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        tooltip: {
            desc: string;
        };
        beforeBufferLabel: string;
        afterBufferLabel: string;
        minutesShort: string;
        previewHeader: string;
    }>;
    nylasCalendarPicker: Partial<{
        calendarPickerLabel: string;
        selectAtLeastOneCalendar: string;
    }>;
    nylasCancellationPolicy: Partial<{
        cancellationPolicyLabel: string;
        tooltip: {
            desc: string;
        };
    }>;
    nylasConfirmationEmail: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        editButtonText: string;
        error: {
            invalidImageUrl: string;
        };
        confirmationEmail: {
            label: string;
            tooltip: {
                desc: string;
                language: string;
            };
            language: string;
        };
        nylasBranding: {
            label: string;
            tooltip: {
                desc: string;
            };
        };
        companyLogoUrl: {
            label: string;
            tooltip: {
                desc: string;
            };
        };
        emailMessage: {
            header: string;
            label: string;
            tooltip: {
                desc: string;
            };
            additionalInfoLabel: string;
            additionalInfoTooltip: string;
            additionalInfoPlaceholder: string;
        };
        allHosts: string;
        immediatelyUponBooking: string;
    }>;
    nylasConnectedCalendars: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        tooltip: {
            desc: string;
        };
        participantCalendarTitle: string;
        selectAtLeastOneCalendar: string;
    }>;
    nylasCustomBookingFlow: Partial<{
        headerTitle: string;
    }>;
    nylasCustomEventSlug: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        eventSlugLabel: string;
        tooltip: {
            desc: string;
        };
        copied: string;
    }>;
    nylasCustomizeBookingSettings: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        tooltip: {
            desc: string;
        };
        allowGuests: {
            label: string;
        };
        hideReschedule: {
            label: string;
            tooltip: {
                desc: string;
            };
        };
        hideCancel: {
            label: string;
            tooltip: {
                desc: string;
            };
        };
    }>;
    nylasEventDescription: Partial<{
        headerTitle: string;
        addAdditionalFields: {
            buttonText: string;
            tooltip: {
                desc: string;
            };
        };
        tooltip: {
            desc: string;
        };
    }>;
    nylasEventDuration: Partial<{
        headerTitle: string;
        error: {
            durationMustBeMultipleOf5: string;
            durationMustBeGreaterThan0: string;
        };
    }>;
    nylasEventInfo: Partial<{
        headerTitle: string;
    }>;
    nylasEventLimits: Partial<{
        headerTitle: string;
    }>;
    nylasEventLocation: Partial<{
        headerTitle: string;
        tooltip: {
            desc: string;
        };
        conferenceOptions: {
            none: string;
            zoom: string;
            google: string;
            microsoft: string;
            custom: string;
        };
    }>;
    nylasEventTitle: Partial<{
        headerTitle: string;
        helpText_start: string;
        helpText_end: string;
        title: string;
        description: string;
        tooltip: {
            desc: string;
        };
        eventTitleRequired: string;
        eventTitleTokenDescription: {
            invitee: string;
            inviteeEmail: string;
            duration: string;
        };
    }>;
    nylasLimitFutureBookings: Partial<{
        headerTitle: string;
        tooltip: {
            desc: string;
        };
    }>;
    nylasMinBookingNotice: Partial<{
        headerTitle: string;
        tooltip: {
            desc: string;
        };
    }>;
    nylasMinCancellationNotice: Partial<{
        headerTitle: string;
        tooltip: {
            desc: string;
        };
    }>;
    nylasPageName: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        pageNameError: string;
        tooltip: {
            desc: string;
        };
    }>;
    nylasPageStyling: Partial<{
        headerTitle: string;
    }>;
    nylasParticipantBookingCalendars: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        participantBookingCalendarTitle: string;
        selectAtLeastOneCalendar: string;
    }>;
    nylasParticipantCustomAvailability: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        participantOpenHoursTitle: string;
    }>;
    nylasReminderEmails: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        editButtonText: string;
        recipientOptions_all: string;
        recipientOptions_guest: string;
        recipientOptions_host: string;
        beforeTheEvent: string;
        emailRecipients: {
            label: string;
        };
        sendConfirmation: {
            label: string;
            tooltip: {
                desc: string;
            };
        };
        emailSubject: {
            label: string;
            placeholder: string;
        };
        reminderMinutesValidationError: string;
        newReminderButtonText: string;
    }>;
    nylasSchedulingMethod: Partial<{
        headerTitle: string;
        headerSubTitle: string;
        tooltip: {
            standard: {
                label: string;
                desc: string;
            };
            maxFairness: {
                label: string;
                desc: string;
            };
            maxAvailability: {
                label: string;
                desc: string;
            };
        };
        schedulingMethodOptions_collective: string;
        schedulingMethodOptions_maxFairness: string;
        schedulingMethodOptions_maxAvailability: string;
    }>;
    nylasTimeslotInterval: Partial<{
        headerTitle: string;
        minutesShort: string;
        lengthOfMeeting: string;
        timeslotInterval: {
            label: string;
        };
        timeslotRounding: {
            label: string;
            tooltip: {
                desc: string;
            };
        };
        timeslotRoundingOptions: {
            rounding: {
                label: string;
                desc: string;
            };
            noRounding: {
                label: string;
                desc: string;
            };
        };
    }>;
    nylasEventTimeslot: {
        recurrenceOptions: {
            none: string;
            daily: string;
            weekly: string;
            monthly: string;
            monthOnDay: string;
            yearly: string;
            custom: string;
        };
        recurrenceLabel: string;
        endDate: string;
        customRecurrence: {
            repeatEvery: string;
            repeatOn: string;
            ends: string;
            endsOptions: {
                never: string;
                after: string;
                on: string;
            };
            occurrences: string;
        };
        dateTimeLabel: string;
        errors: {
            invalidTimeRange: string;
            startTimeSameAsEndTime: string;
            startTimeBeforeCurrentDate: string;
            invalid: string;
        };
    };
    nylasEventCapacity: {
        headerTitle: string;
        headerSubTitle: string;
        tooltip: {
            desc: string;
        };
        attendees: string;
    };
    nylasSelectEventType: {
        returnToAllSchedulingPages: string;
        createEventHeaderTitle: string;
        eventTypeHeaderTitle: string;
        noEventTypesEnabled: string;
        eventTypeOptions: {
            oneOnOne: {
                label: string;
                desc: string;
            };
            collective: {
                label: string;
                desc: string;
            };
            maxFairness: {
                label: string;
                desc: string;
            };
            maxAvailability: {
                label: string;
                desc: string;
            };
            group: {
                label: string;
                desc: string;
            };
        };
    };
    nylasEventCalendar: {
        createEventDetails: {
            headerTitle: string;
            closeButtonTooltip: string;
            cancelButton: string;
            createButton: string;
        };
        discardChanges: {
            headerTitle: string;
            cancelButton: string;
            discardButton: string;
        };
        unsavedChanges: string;
        editEventDetails: {
            headerTitle: string;
            closeButtonTooltip: string;
            deleteButton: string;
            saveButton: string;
            pastEventTooltip: string;
        };
        importEvent: {
            closeButtonTooltip: string;
            importButton: string;
            participantsLabel: string;
        };
        deleteEvent: {
            closeButtonTooltip: string;
            deleting: string;
        };
        editOptions: {
            headerTitle: string;
            closeButtonTooltip: string;
            deleting: string;
            import: string;
            edit: string;
            deleteThis: string;
            deleteAll: string;
        };
        updateOptions: {
            updateThis: string;
            updateAll: string;
            updateFuture: string;
        };
        deleteOptions: {
            deleteThis: string;
            deleteFuture: string;
            deleteAll: string;
        };
    };
}>;
export declare enum LANGUAGE_CODE {
    en = "en",
    es = "es",
    fr = "fr",
    de = "de",
    sv = "sv",
    zh = "zh",
    ja = "ja",
    nl = "nl",
    ko = "ko"
}
export declare const TIME_PERIODS: {
    label: string;
    value: string;
}[];
export declare enum EXPERIMENTAL_FEATURES {
}
export declare enum CONFIGURATION_EVENT_TYPE {
    one_on_one = "one-on-one",
    collective = "collective",
    max_fairness = "max-fairness",
    max_availability = "max-availability",
    group = "group"
}
export declare const LANGUAGE_MAP: {
    [key: Navigator['language']]: string;
};
export declare const LANGUAGE_CODE_TO_LOCALE_MAP: {
    [key: Navigator['language']]: string;
};
export declare const LANGUAGE_CODE_MAP: {
    [key: string]: string;
};
export declare const TIMEZONE_MAP: {
    'Africa/Abidjan': string;
    'Africa/Accra': string;
    'Africa/Addis_Ababa': string;
    'Africa/Algiers': string;
    'Africa/Asmara': string;
    'Africa/Asmera': string;
    'Africa/Bamako': string;
    'Africa/Bangui': string;
    'Africa/Banjul': string;
    'Africa/Bissau': string;
    'Africa/Blantyre': string;
    'Africa/Brazzaville': string;
    'Africa/Bujumbura': string;
    'Africa/Cairo': string;
    'Africa/Casablanca': string;
    'Africa/Ceuta': string;
    'Africa/Conakry': string;
    'Africa/Dakar': string;
    'Africa/Dar_es_Salaam': string;
    'Africa/Djibouti': string;
    'Africa/Douala': string;
    'Africa/El_Aaiun': string;
    'Africa/Freetown': string;
    'Africa/Gaborone': string;
    'Africa/Harare': string;
    'Africa/Johannesburg': string;
    'Africa/Juba': string;
    'Africa/Kampala': string;
    'Africa/Khartoum': string;
    'Africa/Kigali': string;
    'Africa/Kinshasa': string;
    'Africa/Lagos': string;
    'Africa/Libreville': string;
    'Africa/Lome': string;
    'Africa/Luanda': string;
    'Africa/Lubumbashi': string;
    'Africa/Lusaka': string;
    'Africa/Malabo': string;
    'Africa/Maputo': string;
    'Africa/Maseru': string;
    'Africa/Mbabane': string;
    'Africa/Mogadishu': string;
    'Africa/Monrovia': string;
    'Africa/Nairobi': string;
    'Africa/Ndjamena': string;
    'Africa/Niamey': string;
    'Africa/Nouakchott': string;
    'Africa/Ouagadougou': string;
    'Africa/Porto-Novo': string;
    'Africa/Sao_Tome': string;
    'Africa/Timbuktu': string;
    'Africa/Tripoli': string;
    'Africa/Tunis': string;
    'Africa/Windhoek': string;
    'America/Adak': string;
    'America/Anchorage': string;
    'America/Anguilla': string;
    'America/Antigua': string;
    'America/Araguaina': string;
    'America/Argentina/Buenos_Aires': string;
    'America/Argentina/Catamarca': string;
    'America/Argentina/ComodRivadavia': string;
    'America/Argentina/Cordoba': string;
    'America/Argentina/Jujuy': string;
    'America/Argentina/La_Rioja': string;
    'America/Argentina/Mendoza': string;
    'America/Argentina/Rio_Gallegos': string;
    'America/Argentina/Salta': string;
    'America/Argentina/San_Juan': string;
    'America/Argentina/San_Luis': string;
    'America/Argentina/Tucuman': string;
    'America/Argentina/Ushuaia': string;
    'America/Aruba': string;
    'America/Asuncion': string;
    'America/Atikokan': string;
    'America/Atka': string;
    'America/Bahia': string;
    'America/Bahia_Banderas': string;
    'America/Barbados': string;
    'America/Belem': string;
    'America/Belize': string;
    'America/Blanc-Sablon': string;
    'America/Boa_Vista': string;
    'America/Bogota': string;
    'America/Boise': string;
    'America/Buenos_Aires': string;
    'America/Cambridge_Bay': string;
    'America/Campo_Grande': string;
    'America/Cancun': string;
    'America/Caracas': string;
    'America/Catamarca': string;
    'America/Cayenne': string;
    'America/Cayman': string;
    'America/Chicago': string;
    'America/Chihuahua': string;
    'America/Ciudad_Juarez': string;
    'America/Coral_Harbour': string;
    'America/Cordoba': string;
    'America/Costa_Rica': string;
    'America/Creston': string;
    'America/Cuiaba': string;
    'America/Curacao': string;
    'America/Danmarkshavn': string;
    'America/Dawson': string;
    'America/Dawson_Creek': string;
    'America/Denver': string;
    'America/Detroit': string;
    'America/Dominica': string;
    'America/Edmonton': string;
    'America/Eirunepe': string;
    'America/El_Salvador': string;
    'America/Ensenada': string;
    'America/Fort_Nelson': string;
    'America/Fort_Wayne': string;
    'America/Fortaleza': string;
    'America/Glace_Bay': string;
    'America/Godthab': string;
    'America/Goose_Bay': string;
    'America/Grand_Turk': string;
    'America/Grenada': string;
    'America/Guadeloupe': string;
    'America/Guatemala': string;
    'America/Guayaquil': string;
    'America/Guyana': string;
    'America/Halifax': string;
    'America/Havana': string;
    'America/Hermosillo': string;
    'America/Indiana/Indianapolis': string;
    'America/Indiana/Knox': string;
    'America/Indiana/Marengo': string;
    'America/Indiana/Petersburg': string;
    'America/Indiana/Tell_City': string;
    'America/Indiana/Vevay': string;
    'America/Indiana/Vincennes': string;
    'America/Indiana/Winamac': string;
    'America/Indianapolis': string;
    'America/Inuvik': string;
    'America/Iqaluit': string;
    'America/Jamaica': string;
    'America/Jujuy': string;
    'America/Juneau': string;
    'America/Kentucky/Louisville': string;
    'America/Kentucky/Monticello': string;
    'America/Knox_IN': string;
    'America/Kralendijk': string;
    'America/La_Paz': string;
    'America/Lima': string;
    'America/Los_Angeles': string;
    'America/Louisville': string;
    'America/Lower_Princes': string;
    'America/Maceio': string;
    'America/Managua': string;
    'America/Manaus': string;
    'America/Marigot': string;
    'America/Martinique': string;
    'America/Matamoros': string;
    'America/Mazatlan': string;
    'America/Mendoza': string;
    'America/Menominee': string;
    'America/Merida': string;
    'America/Metlakatla': string;
    'America/Mexico_City': string;
    'America/Miquelon': string;
    'America/Moncton': string;
    'America/Monterrey': string;
    'America/Montevideo': string;
    'America/Montreal': string;
    'America/Montserrat': string;
    'America/Nassau': string;
    'America/New_York': string;
    'America/Nipigon': string;
    'America/Nome': string;
    'America/Noronha': string;
    'America/North_Dakota/Beulah': string;
    'America/North_Dakota/Center': string;
    'America/North_Dakota/New_Salem': string;
    'America/Nuuk': string;
    'America/Ojinaga': string;
    'America/Panama': string;
    'America/Pangnirtung': string;
    'America/Paramaribo': string;
    'America/Phoenix': string;
    'America/Port-au-Prince': string;
    'America/Port_of_Spain': string;
    'America/Porto_Acre': string;
    'America/Porto_Velho': string;
    'America/Puerto_Rico': string;
    'America/Punta_Arenas': string;
    'America/Rainy_River': string;
    'America/Rankin_Inlet': string;
    'America/Recife': string;
    'America/Regina': string;
    'America/Resolute': string;
    'America/Rio_Branco': string;
    'America/Rosario': string;
    'America/Santa_Isabel': string;
    'America/Santarem': string;
    'America/Santiago': string;
    'America/Santo_Domingo': string;
    'America/Sao_Paulo': string;
    'America/Scoresbysund': string;
    'America/Shiprock': string;
    'America/Sitka': string;
    'America/St_Barthelemy': string;
    'America/St_Johns': string;
    'America/St_Kitts': string;
    'America/St_Lucia': string;
    'America/St_Thomas': string;
    'America/St_Vincent': string;
    'America/Swift_Current': string;
    'America/Tegucigalpa': string;
    'America/Thule': string;
    'America/Thunder_Bay': string;
    'America/Tijuana': string;
    'America/Toronto': string;
    'America/Tortola': string;
    'America/Vancouver': string;
    'America/Virgin': string;
    'America/Whitehorse': string;
    'America/Winnipeg': string;
    'America/Yakutat': string;
    'America/Yellowknife': string;
    'Antarctica/Casey': string;
    'Antarctica/Davis': string;
    'Antarctica/DumontDUrville': string;
    'Antarctica/Macquarie': string;
    'Antarctica/Mawson': string;
    'Antarctica/McMurdo': string;
    'Antarctica/Palmer': string;
    'Antarctica/Rothera': string;
    'Antarctica/South_Pole': string;
    'Antarctica/Syowa': string;
    'Antarctica/Troll': string;
    'Antarctica/Vostok': string;
    'Arctic/Longyearbyen': string;
    'Asia/Aden': string;
    'Asia/Almaty': string;
    'Asia/Amman': string;
    'Asia/Anadyr': string;
    'Asia/Aqtau': string;
    'Asia/Aqtobe': string;
    'Asia/Ashgabat': string;
    'Asia/Ashkhabad': string;
    'Asia/Atyrau': string;
    'Asia/Baghdad': string;
    'Asia/Bahrain': string;
    'Asia/Baku': string;
    'Asia/Bangkok': string;
    'Asia/Barnaul': string;
    'Asia/Beirut': string;
    'Asia/Bishkek': string;
    'Asia/Brunei': string;
    'Asia/Calcutta': string;
    'Asia/Chita': string;
    'Asia/Choibalsan': string;
    'Asia/Chongqing': string;
    'Asia/Chungking': string;
    'Asia/Colombo': string;
    'Asia/Dacca': string;
    'Asia/Damascus': string;
    'Asia/Dhaka': string;
    'Asia/Dili': string;
    'Asia/Dubai': string;
    'Asia/Dushanbe': string;
    'Asia/Famagusta': string;
    'Asia/Gaza': string;
    'Asia/Harbin': string;
    'Asia/Hebron': string;
    'Asia/Ho_Chi_Minh': string;
    'Asia/Hong_Kong': string;
    'Asia/Hovd': string;
    'Asia/Irkutsk': string;
    'Asia/Istanbul': string;
    'Asia/Jakarta': string;
    'Asia/Jayapura': string;
    'Asia/Jerusalem': string;
    'Asia/Kabul': string;
    'Asia/Kamchatka': string;
    'Asia/Karachi': string;
    'Asia/Kashgar': string;
    'Asia/Kathmandu': string;
    'Asia/Katmandu': string;
    'Asia/Khandyga': string;
    'Asia/Kolkata': string;
    'Asia/Krasnoyarsk': string;
    'Asia/Kuala_Lumpur': string;
    'Asia/Kuching': string;
    'Asia/Kuwait': string;
    'Asia/Macao': string;
    'Asia/Macau': string;
    'Asia/Magadan': string;
    'Asia/Makassar': string;
    'Asia/Manila': string;
    'Asia/Muscat': string;
    'Asia/Nicosia': string;
    'Asia/Novokuznetsk': string;
    'Asia/Novosibirsk': string;
    'Asia/Omsk': string;
    'Asia/Oral': string;
    'Asia/Phnom_Penh': string;
    'Asia/Pontianak': string;
    'Asia/Pyongyang': string;
    'Asia/Qatar': string;
    'Asia/Qostanay': string;
    'Asia/Qyzylorda': string;
    'Asia/Rangoon': string;
    'Asia/Riyadh': string;
    'Asia/Saigon': string;
    'Asia/Sakhalin': string;
    'Asia/Samarkand': string;
    'Asia/Seoul': string;
    'Asia/Shanghai': string;
    'Asia/Singapore': string;
    'Asia/Srednekolymsk': string;
    'Asia/Taipei': string;
    'Asia/Tashkent': string;
    'Asia/Tbilisi': string;
    'Asia/Tehran': string;
    'Asia/Tel_Aviv': string;
    'Asia/Thimbu': string;
    'Asia/Thimphu': string;
    'Asia/Tokyo': string;
    'Asia/Tomsk': string;
    'Asia/Ujung_Pandang': string;
    'Asia/Ulaanbaatar': string;
    'Asia/Ulan_Bator': string;
    'Asia/Urumqi': string;
    'Asia/Ust-Nera': string;
    'Asia/Vientiane': string;
    'Asia/Vladivostok': string;
    'Asia/Yakutsk': string;
    'Asia/Yangon': string;
    'Asia/Yekaterinburg': string;
    'Asia/Yerevan': string;
    'Atlantic/Azores': string;
    'Atlantic/Bermuda': string;
    'Atlantic/Canary': string;
    'Atlantic/Cape_Verde': string;
    'Atlantic/Faeroe': string;
    'Atlantic/Faroe': string;
    'Atlantic/Jan_Mayen': string;
    'Atlantic/Madeira': string;
    'Atlantic/Reykjavik': string;
    'Atlantic/South_Georgia': string;
    'Atlantic/St_Helena': string;
    'Atlantic/Stanley': string;
    'Australia/ACT': string;
    'Australia/Adelaide': string;
    'Australia/Brisbane': string;
    'Australia/Broken_Hill': string;
    'Australia/Canberra': string;
    'Australia/Currie': string;
    'Australia/Darwin': string;
    'Australia/Eucla': string;
    'Australia/Hobart': string;
    'Australia/LHI': string;
    'Australia/Lindeman': string;
    'Australia/Lord_Howe': string;
    'Australia/Melbourne': string;
    'Australia/NSW': string;
    'Australia/North': string;
    'Australia/Perth': string;
    'Australia/Queensland': string;
    'Australia/South': string;
    'Australia/Sydney': string;
    'Australia/Tasmania': string;
    'Australia/Victoria': string;
    'Australia/West': string;
    'Australia/Yancowinna': string;
    'Brazil/Acre': string;
    'Brazil/DeNoronha': string;
    'Brazil/East': string;
    'Brazil/West': string;
    CET: string;
    CST6CDT: string;
    'Canada/Atlantic': string;
    'Canada/Central': string;
    'Canada/Eastern': string;
    'Canada/Mountain': string;
    'Canada/Newfoundland': string;
    'Canada/Pacific': string;
    'Canada/Saskatchewan': string;
    'Canada/Yukon': string;
    'Chile/Continental': string;
    'Chile/EasterIsland': string;
    Cuba: string;
    EET: string;
    EST: string;
    EST5EDT: string;
    Egypt: string;
    Eire: string;
    'Etc/GMT': string;
    'Etc/GMT+0': string;
    'Etc/GMT+1': string;
    'Etc/GMT+10': string;
    'Etc/GMT+11': string;
    'Etc/GMT+12': string;
    'Etc/GMT+2': string;
    'Etc/GMT+3': string;
    'Etc/GMT+4': string;
    'Etc/GMT+5': string;
    'Etc/GMT+6': string;
    'Etc/GMT+7': string;
    'Etc/GMT+8': string;
    'Etc/GMT+9': string;
    'Etc/GMT-0': string;
    'Etc/GMT-1': string;
    'Etc/GMT-10': string;
    'Etc/GMT-11': string;
    'Etc/GMT-12': string;
    'Etc/GMT-13': string;
    'Etc/GMT-14': string;
    'Etc/GMT-2': string;
    'Etc/GMT-3': string;
    'Etc/GMT-4': string;
    'Etc/GMT-5': string;
    'Etc/GMT-6': string;
    'Etc/GMT-7': string;
    'Etc/GMT-8': string;
    'Etc/GMT-9': string;
    'Etc/GMT0': string;
    'Etc/Greenwich': string;
    'Etc/UCT': string;
    'Etc/UTC': string;
    'Etc/Universal': string;
    'Etc/Zulu': string;
    'Europe/Amsterdam': string;
    'Europe/Andorra': string;
    'Europe/Astrakhan': string;
    'Europe/Athens': string;
    'Europe/Belfast': string;
    'Europe/Belgrade': string;
    'Europe/Berlin': string;
    'Europe/Bratislava': string;
    'Europe/Brussels': string;
    'Europe/Bucharest': string;
    'Europe/Budapest': string;
    'Europe/Busingen': string;
    'Europe/Chisinau': string;
    'Europe/Copenhagen': string;
    'Europe/Dublin': string;
    'Europe/Gibraltar': string;
    'Europe/Guernsey': string;
    'Europe/Helsinki': string;
    'Europe/Isle_of_Man': string;
    'Europe/Istanbul': string;
    'Europe/Jersey': string;
    'Europe/Kaliningrad': string;
    'Europe/Kiev': string;
    'Europe/Kirov': string;
    'Europe/Kyiv': string;
    'Europe/Lisbon': string;
    'Europe/Ljubljana': string;
    'Europe/London': string;
    'Europe/Luxembourg': string;
    'Europe/Madrid': string;
    'Europe/Malta': string;
    'Europe/Mariehamn': string;
    'Europe/Minsk': string;
    'Europe/Monaco': string;
    'Europe/Moscow': string;
    'Europe/Nicosia': string;
    'Europe/Oslo': string;
    'Europe/Paris': string;
    'Europe/Podgorica': string;
    'Europe/Prague': string;
    'Europe/Riga': string;
    'Europe/Rome': string;
    'Europe/Samara': string;
    'Europe/San_Marino': string;
    'Europe/Sarajevo': string;
    'Europe/Saratov': string;
    'Europe/Simferopol': string;
    'Europe/Skopje': string;
    'Europe/Sofia': string;
    'Europe/Stockholm': string;
    'Europe/Tallinn': string;
    'Europe/Tirane': string;
    'Europe/Tiraspol': string;
    'Europe/Ulyanovsk': string;
    'Europe/Uzhgorod': string;
    'Europe/Vaduz': string;
    'Europe/Vatican': string;
    'Europe/Vienna': string;
    'Europe/Vilnius': string;
    'Europe/Volgograd': string;
    'Europe/Warsaw': string;
    'Europe/Zagreb': string;
    'Europe/Zaporozhye': string;
    'Europe/Zurich': string;
    GB: string;
    'GB-Eire': string;
    GMT: string;
    'GMT+0': string;
    'GMT-0': string;
    GMT0: string;
    Greenwich: string;
    HST: string;
    Hongkong: string;
    Iceland: string;
    'Indian/Antananarivo': string;
    'Indian/Chagos': string;
    'Indian/Christmas': string;
    'Indian/Cocos': string;
    'Indian/Comoro': string;
    'Indian/Kerguelen': string;
    'Indian/Mahe': string;
    'Indian/Maldives': string;
    'Indian/Mauritius': string;
    'Indian/Mayotte': string;
    'Indian/Reunion': string;
    Iran: string;
    Israel: string;
    Jamaica: string;
    Japan: string;
    Kwajalein: string;
    Libya: string;
    MET: string;
    MST: string;
    MST7MDT: string;
    'Mexico/BajaNorte': string;
    'Mexico/BajaSur': string;
    'Mexico/General': string;
    NZ: string;
    'NZ-CHAT': string;
    Navajo: string;
    PRC: string;
    PST8PDT: string;
    'Pacific/Apia': string;
    'Pacific/Auckland': string;
    'Pacific/Bougainville': string;
    'Pacific/Chatham': string;
    'Pacific/Chuuk': string;
    'Pacific/Easter': string;
    'Pacific/Efate': string;
    'Pacific/Enderbury': string;
    'Pacific/Fakaofo': string;
    'Pacific/Fiji': string;
    'Pacific/Funafuti': string;
    'Pacific/Galapagos': string;
    'Pacific/Gambier': string;
    'Pacific/Guadalcanal': string;
    'Pacific/Guam': string;
    'Pacific/Honolulu': string;
    'Pacific/Johnston': string;
    'Pacific/Kanton': string;
    'Pacific/Kiritimati': string;
    'Pacific/Kosrae': string;
    'Pacific/Kwajalein': string;
    'Pacific/Majuro': string;
    'Pacific/Marquesas': string;
    'Pacific/Midway': string;
    'Pacific/Nauru': string;
    'Pacific/Niue': string;
    'Pacific/Norfolk': string;
    'Pacific/Noumea': string;
    'Pacific/Pago_Pago': string;
    'Pacific/Palau': string;
    'Pacific/Pitcairn': string;
    'Pacific/Pohnpei': string;
    'Pacific/Ponape': string;
    'Pacific/Port_Moresby': string;
    'Pacific/Rarotonga': string;
    'Pacific/Saipan': string;
    'Pacific/Samoa': string;
    'Pacific/Tahiti': string;
    'Pacific/Tarawa': string;
    'Pacific/Tongatapu': string;
    'Pacific/Truk': string;
    'Pacific/Wake': string;
    'Pacific/Wallis': string;
    'Pacific/Yap': string;
    Poland: string;
    Portugal: string;
    ROC: string;
    ROK: string;
    Singapore: string;
    Turkey: string;
    UCT: string;
    'US/Alaska': string;
    'US/Aleutian': string;
    'US/Arizona': string;
    'US/Central': string;
    'US/East-Indiana': string;
    'US/Eastern': string;
    'US/Hawaii': string;
    'US/Indiana-Starke': string;
    'US/Michigan': string;
    'US/Mountain': string;
    'US/Pacific': string;
    'US/Samoa': string;
    UTC: string;
    Universal: string;
    'W-SU': string;
    WET: string;
    Zulu: string;
};
export declare const EVENT_TITLE_TOKENS: {
    token: string;
    value: string;
    description: string;
}[];
export declare const DEFAULT_OPEN_HOURS: OpenHours[];
export declare const PROVIDER_CONFERENCE_MAP: {
    google: string;
    zoom: string;
    microsoft: string;
};
export declare const CONFERENCE_PROVIDER_MAP: {
    'Google Meet': string;
    'Zoom Meeting': string;
    'Microsoft Teams': string;
};
export declare const NON_PROVIDER_CONFERENCE_OPTIONS: string[];
export declare const DEFAULT_FORM_FIELD_TYPES: {
    label: string;
    value: string;
}[];
export declare const FIELD_TYPES: any;
export declare const PROVIDER_CONFERENCE_OPTIONS: string[];
export declare const REMINDER_MINUTE_OPTIONS: {
    value: number;
    label: string;
}[];
export declare const REMINDER_HOUR_OPTIONS: {
    value: number;
    label: string;
}[];
export declare const REMINDER_DAY_OPTIONS: {
    value: number;
    label: string;
}[];
export declare const editorTabComponentNames: string[];
export declare const editorGroupTabComponentNames: string[];
