import { EventEmitter } from '../../../stencil-public-runtime';
import { DropdownOption } from '@nylas/core';
export declare class InputDropdown {
    el: HTMLElement;
    private inputRef?;
    private optionsRef;
    name: string;
    options: DropdownOption[];
    defaultInputOption?: DropdownOption;
    inputValue: string;
    pluralizedLabel: string;
    filterable: boolean;
    selectedOption: DropdownOption | null;
    isOpen: boolean;
    typedValue: string;
    filteredOptions: DropdownOption[];
    ariaActivedescendant: string;
    shouldAutoScroll: boolean;
    inputOptionChanged: EventEmitter<{
        value: DropdownOption['value'];
        name: string;
    }>;
    optionsChangedHandler(newValue: DropdownOption[], oldValue: DropdownOption[]): void;
    defaultSelectedOptionChangedHandler(newValue: DropdownOption, oldValue: DropdownOption): void;
    inputValueChangedHandler(newValue: string, oldValue: string): void;
    componentWillLoad(): void;
    getFilteredOptions(options: any): DropdownOption[];
    toggleDropdown(): void;
    selectOption(option: DropdownOption): void;
    handleOnInput(event: Event): void;
    scrollToViewWithinParent(optionIndex: number): void;
    handleSelectButtonKeyDown(event: KeyboardEvent): void;
    handleClick(event: Event): void;
    handleListboxKeydown(e: any): void;
    focusOption(index: any): void;
    handleComboboxKeyDown(event: KeyboardEvent): void;
    handleOutsideClick(event: MouseEvent): void;
    render(): any;
}
