import { EventEmitter } from '../../../stencil-public-runtime';
import { DropdownOption } from '@nylas/core';
export declare class MultiSelectDropdown {
    el: HTMLElement;
    name: string;
    label?: string;
    options: DropdownOption[];
    error?: string;
    required?: boolean;
    readOnly?: boolean;
    multipleOptionsSelectedLabel?: string;
    selectAtLeastOneOptionLabel?: string;
    availableOptions: DropdownOption[];
    isOpen: boolean;
    ariaActivedescendant: string;
    shouldFocusFirstOption: boolean;
    selectedOptionsChanged: EventEmitter<{
        value: string[];
        name: string;
    }>;
    areOptionsEqual(arr1: DropdownOption[], arr2: DropdownOption[]): boolean;
    optionsChangedHandler(newValue: DropdownOption[]): void;
    componentDidLoad(): void;
    componentDidRender(): void;
    handleOutsideClick(event: MouseEvent): void;
    handleBookingFormSubmitted(event: CustomEvent): void;
    selectOption(option: DropdownOption): void;
    toggleDropdown(): void;
    handleSelectButtonKeyDown(event: KeyboardEvent): void;
    handleListboxKeydown(e: KeyboardEvent): void;
    focusOption(index: number): void;
    getSelectedOptions(): DropdownOption[];
    renderOption(option: DropdownOption): any;
    render(): any;
}
