import { EventEmitter } from '../../../stencil-public-runtime';
export declare class NylasDateComponent {
    el: HTMLElement;
    name: string;
    defaultValue?: string;
    label: string;
    placeholder: string;
    required: boolean;
    readOnly: boolean;
    autoFocus: boolean;
    pattern?: RegExp;
    maxLength: number;
    patternError: string;
    requiredError: string;
    minDate?: string;
    hasError: boolean;
    value: string;
    error: string;
    isDateValid: boolean;
    nylasFormInputChanged: EventEmitter<{
        value: string;
        name: string;
        label: string;
        type: string;
        error: string;
    }>;
    nylasFormInputFocused: EventEmitter<{
        value: string;
        name: string;
    }>;
    nylasFormInputBlurred: EventEmitter<{
        value: string;
        name: string;
    }>;
    handleDefaultValueChange(newValue: string): void;
    componentDidLoad(): void;
    handleBookingFormSubmitted(event: CustomEvent): void;
    handleFormSubmitted(event: CustomEvent): Promise<void>;
    handleInput(e: Event): void;
    handleBlur(): void;
    handleFocus(): void;
    validatePattern(value: string, onLoad?: boolean): void;
    render(): any;
}
