import { EventEmitter } from '../../../stencil-public-runtime';
import { DropdownOption } from '@nylas/core';
export declare class SelectDropdown {
    el: HTMLElement;
    private readonly componentType;
    private inputRef?;
    name: string;
    options: DropdownOption[];
    defaultSelectedOption: DropdownOption | null;
    withSearch: boolean;
    searchPlaceholder: string;
    label?: string;
    required: boolean;
    readOnly: boolean;
    pluralizedLabel: string;
    dropdownButtonText?: string;
    withChevron: boolean;
    emptyValue: string;
    errorMessage: string;
    selectedOption: DropdownOption | null;
    isOpen: boolean;
    searchValue: string;
    filteredOptions: DropdownOption[];
    ariaActivedescendant: string;
    error: string;
    nylasFormDropdownChanged: EventEmitter<{
        value: DropdownOption['value'];
        name: string;
        error?: string;
        label?: string;
    }>;
    nylasFormDropdownDefaultSelected: EventEmitter<{
        value: DropdownOption['value'];
        name: string;
        error?: string;
        label?: string;
    }>;
    optionsChangedHandler(newValue: DropdownOption[], oldValue: DropdownOption[]): void;
    defaultSelectedOptionChangedHandler(newValue: DropdownOption, oldValue: DropdownOption): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    handleBookingFormSubmitted(event: CustomEvent): void;
    handleFormSubmitted(event: CustomEvent): void;
    validate(value: string): void;
    toggleDropdown(): void;
    filterOptions(event: Event): void;
    selectOption(option: DropdownOption): void;
    handleSelectButtonKeyDown(event: KeyboardEvent): void;
    handleListboxKeydown(e: any): void;
    focusOption(index: any): void;
    handleComboboxKeyDown(event: KeyboardEvent): void;
    generateButtonText(option: DropdownOption | null, dropButtonText?: string): string;
    handleOutsideClick(event: MouseEvent): void;
    render(): any;
}
