import { Calendar } from '@nylas/core';
import { EventEmitter } from '../../../stencil-public-runtime';
import { User } from "../../../common/nylas-api-request";
import { LANGUAGE_CODE } from "../../../common/constants";
export declare class NylasBookingCalendarPicker {
    host: HTMLNylasCalendarPickerElement;
    calendars?: Calendar[];
    currentUser?: User;
    currentUserCalendars?: Calendar[];
    name: string;
    defaultBookingCalendar: string;
    hideHeader: boolean;
    expressFlow: boolean;
    selectedLanguage?: LANGUAGE_CODE;
    internals: ElementInternals;
    selectedCalendar: string;
    valueChanged: EventEmitter<{
        value: string;
        name: string;
        valueChanged?: (event: CustomEvent<{
            value: string;
            name: string;
        }>) => void;
    }>;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    componentWillUpdate(): void;
    componentDidUpdate(): void;
    componentWillRender(): void;
    componentDidRender(): void;
    get isInternalsAvailable(): boolean;
    elementNameChangedHandler(newValue: string): void;
    currentUserCalendarsChangedHandler(newValue: Calendar[]): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    nylasFormDropdownChangedHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): void;
    render(): any;
}
