import { EventEmitter } from '../../../stencil-public-runtime';
import { Configuration } from '@nylas/core';
import { LANGUAGE_CODE } from "../../../common/constants";
export declare class NylasBookingConfirmationRedirect {
    host: HTMLNylasBookingConfirmationRedirectElement;
    selectedConfiguration?: Configuration;
    name: string;
    redirectUrl: string;
    redirectUrlErrorMessage: string;
    selectedLanguage?: LANGUAGE_CODE;
    internals: ElementInternals;
    currentRedirectUrl: string;
    acceptUrl: boolean;
    componentLoaded: boolean;
    valueChanged: EventEmitter<{
        value: string;
        name: string;
        valueChanged?: (event: CustomEvent<{
            value: string;
            name: string;
        }>) => void;
    }>;
    elementNameChangedHandler(newValue: string): void;
    selectedConfigurationChangedHandler(newValue: Configuration): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    componentWillUpdate(): void;
    componentDidUpdate(): void;
    componentWillRender(): void;
    componentDidRender(): void;
    nylasFormDropdownChangedHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): void;
    nylasFormInputBlurHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): void;
    formSubmittedHandler(_event: CustomEvent): void;
    render(): any;
}
