import { EventEmitter } from '../../../stencil-public-runtime';
import { Configuration, AdditionalFields } from '@nylas/core';
import { LANGUAGE_CODE } from "../../../common/constants";
interface AdditionalFieldsInternal extends AdditionalFields {
    isOpen: boolean;
    readonly?: boolean;
    typeLabel: string;
    key?: string;
    error?: string;
    fieldLabelKey?: string;
}
export declare class NylasBookingFormConfig {
    host: HTMLNylasBookingFormConfigElement;
    selectedConfiguration?: Configuration;
    name: string;
    additionalFields?: AdditionalFields[];
    selectedLanguage?: LANGUAGE_CODE;
    valueChanged: EventEmitter<{
        value: string;
        name: string;
    }>;
    internals: ElementInternals;
    staticFields: {
        type: string;
        label: string;
        key: string;
        typeLabel: string;
        readonly: boolean;
        required: boolean;
        isOpen: boolean;
        fieldLabelKey: string;
        order: number;
    }[];
    formFields: AdditionalFieldsInternal[];
    formFieldsOrder: AdditionalFieldsInternal[];
    count: number;
    watchFields: {
        title: string;
        description: string;
    };
    fieldTypes: {
        label: string;
        value: string;
    }[];
    elementNameChangedHandler(newValue: string): void;
    selectedConfigurationChangedHandler(newValue: Configuration): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    get isInternalsAvailable(): boolean;
    updateFormFields(config: Configuration, valueChanged?: boolean): void;
    formFieldsChangedHandler(newValue: AdditionalFieldsInternal[], valueChanged?: boolean): void;
    findNextMissingNumber(arr: string[]): number;
    nylasFormDropdownChangedHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): void;
    selectedOptionsChangedHandler(event: CustomEvent<{
        value: string[];
        name: string;
    }>): void;
    nylasFormInputChangedHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): void;
    valueChangedHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): void;
    swapFields(event: any): void;
    fieldToggle(index: any): void;
    staticFieldToggle(index: any): void;
    fieldRemove(index: any): void;
    fieldRequired(index: any): void;
    fieldLabelChange(ind: any, event: any): void;
    fieldOptionAdd(index: any): void;
    fieldOptionRemove(fieldIndex: any, index: any): void;
    fieldOptionChange(fieldIndex: any, index: any, event: any): void;
    fieldDefaultValueChanged(index: any, event: any): void;
    render(): any;
}
export {};
