import { Calendar } from '@nylas/core';
import { EventEmitter } from '../../../stencil-public-runtime';
import { User } from "../../../common/nylas-api-request";
import { LANGUAGE_CODE } from "../../../common/constants";
export declare class NylasCalendarPicker {
    host: HTMLNylasCalendarPickerElement;
    name: string;
    currentUser?: User;
    calendars?: Calendar[];
    defaultSelectedCalendars: string[];
    selectedLanguage?: LANGUAGE_CODE;
    internals: ElementInternals;
    selectedCalendars: string[];
    error: string;
    valueChanged: EventEmitter<{
        value: string[];
        name: string;
        valueChangedHandler?: (event: CustomEvent<{
            value: string[];
            name: string;
        }>) => void;
    }>;
    elementNameChangedHandler(newValue: string): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    componentWillUpdate(): void;
    componentDidUpdate(): void;
    componentWillRender(): void;
    componentDidRender(): void;
    selectedOptionsChangedHandler(event: CustomEvent<{
        value: string[];
        name: string;
    }>): void;
    render(): any;
}
