import { EventEmitter } from '../../../stencil-public-runtime';
import { Configuration } from '@nylas/core';
import { LANGUAGE_CODE } from "../../../common/constants";
export declare class NylasCustomEventSlug {
    host: HTMLNylasCustomEventSlugElement;
    selectedConfiguration?: Configuration;
    defaultUrlSlug?: string;
    isOpen: boolean;
    slugErrorMessage: string;
    name: string;
    requiresSlug: boolean;
    selectedLanguage?: LANGUAGE_CODE;
    internals: ElementInternals;
    urlSlug: string;
    focus: boolean;
    copied: boolean;
    valueChanged: EventEmitter<{
        value: string;
        name: string;
        valueChanged?: (event: CustomEvent<{
            value: string;
            name: string;
        }>) => void;
    }>;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    componentWillUpdate(): void;
    componentDidUpdate(): void;
    componentWillRender(): void;
    componentDidRender(): void;
    elementNameChangedHandler(newValue: string): void;
    selectedConfigurationChangedHandler(newValue: Configuration): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    nylasFormInputChangeHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): Promise<void>;
    nylasFormInputFocusHandler(): Promise<void>;
    nylasFormInputBlurHandler(): Promise<void>;
    formSubmittedHandler(event: CustomEvent): void;
    toggleDrawer(): void;
    copyToClipboard(): Promise<void>;
    render(): any;
}
