import { EventEmitter } from '../../../stencil-public-runtime';
import { Configuration } from '@nylas/core';
import { LANGUAGE_CODE } from "../../../common/constants";
export declare class NylasCustomizeBookingSettings {
    host: HTMLNylasCustomizeBookingSettingsElement;
    selectedConfiguration?: Configuration;
    defaultHideAdditionalGuests: boolean;
    defaultHideCancellationOptions: boolean;
    defaultHideReschedulingOptions: boolean;
    name: string;
    selectedLanguage?: LANGUAGE_CODE;
    showSettings: string[];
    allowGuestsToInvite: boolean;
    hideCancellationOptions: boolean;
    hideReschedulingOptions: boolean;
    internals: ElementInternals;
    valueChanged: EventEmitter<{
        value: string;
        name: string;
        valueChanged?: (event: CustomEvent<{
            value: string;
            name: string;
        }>) => void;
    }>;
    elementNameChangedHandler(newValue: string): void;
    selectedConfigurationChangedHandler(newValue: Configuration): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    componentWillUpdate(): void;
    componentDidUpdate(): void;
    componentWillRender(): void;
    componentDidRender(): void;
    checkboxToggledHandler(event: CustomEvent<{
        name: string;
        checked: boolean;
    }>): void;
    handleSettingValues(valueChanged?: boolean): void;
    get isInternalsAvailable(): boolean;
    render(): any;
}
