import { EventEmitter } from '../../../stencil-public-runtime';
import { Configuration } from '@nylas/core';
import { LANGUAGE_CODE } from "../../../common/constants";
type Token = {
    token: string;
    value: string;
    description: string;
};
export declare class NylasEventDescription {
    host: HTMLElement;
    selectedConfiguration?: Configuration;
    eventDescription?: string;
    name: string;
    selectedLanguage?: LANGUAGE_CODE;
    hideAutoPopulateButton: boolean;
    noTemplates: boolean;
    description: string;
    showTokens: boolean;
    availableTokens: {
        label: string;
        value: string;
        labelHTML: Token;
    }[];
    filteredTokens: {
        label: string;
        value: string;
        labelHTML: Token;
    }[];
    ariaActivedescendant: string;
    currentWord: {
        $value: string;
        fullText: string;
        index: number;
        focusOffset: number;
    };
    validationError: string;
    additionalFieldTokens: Token[];
    private descriptionRef;
    internals: ElementInternals;
    elementNameChangedHandler(newValue: string): void;
    selectedConfigurationChangedHandler(newValue: Configuration): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    valueChanged: EventEmitter<{
        value: string;
        name: string;
    }>;
    connectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    disconnectedCallback(): void;
    valueChangedHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): void;
    updateEventDescriptionFromProp(newValue: string): void;
    highlightTokens(description: string): string;
    getCurrentSelectionForBrowser(): {
        focusOffset: any;
        dollarIndex: any;
        lastWord: any;
        currentText: any;
        node: any;
        allSelected: any;
    } | null;
    handleChange(event: Event): void;
    handleInputKeyDown(event: any): void;
    selectOption(e: Event, option: {
        label: string;
        value: string;
        labelHTML: Token;
    }): void;
    populateSuggestionsDropdown(query?: string): void;
    get isInternalsAvailable(): boolean;
    updateEventDescription(text: string): void;
    resetDropdown(): void;
    getLabelHTML(token: {
        token: string;
        description: string;
    }): any;
    handleAddAdditionalFields(): void;
    render(): any;
}
export {};
