import { EventEmitter } from '../../../stencil-public-runtime';
import { Configuration, GroupConfiguration, Notification, NotificationType } from '@nylas/core';
import { LANGUAGE_CODE } from "../../../common/constants";
import { ErrorCategory } from "../../../types/index";
export declare class NylasListConfigurations {
    host: HTMLNylasListConfigurationsElement;
    configurations: (Configuration | GroupConfiguration)[];
    selectedLanguage?: LANGUAGE_CODE;
    schedulerPreviewLink: string;
    listConfigurationsNextCursor?: string | null;
    initListConfigurations: EventEmitter<{
        host: HTMLNylasListConfigurationsElement;
        cursor?: string;
    }>;
    createButtonClick: EventEmitter<HTMLNylasListConfigurationsElement>;
    editButtonClick: EventEmitter<{
        host: HTMLNylasListConfigurationsElement;
        configuration: Configuration | GroupConfiguration;
    }>;
    deleteButtonClick: EventEmitter<{
        host: HTMLNylasListConfigurationsElement;
        configuration: Configuration | GroupConfiguration;
    }>;
    readonly nylasSchedulerError: EventEmitter<{
        notification: Notification;
        host: HTMLElement;
    }>;
    dismissNotification: EventEmitter<{
        id: string;
        host: HTMLNylasListConfigurationsElement;
    }>;
    private state;
    error?: {
        message: string;
        type: NotificationType | undefined;
        category: ErrorCategory | undefined;
        title: string;
    };
    currentCursor: string | null;
    previousCursors: string[];
    disableNextPageButton: boolean;
    deleteConfigurationId: string;
    showDeleteButtonLoading: boolean;
    editButtonLoadingId: string;
    listConfigurationsNextCursorChangedHandler(newVal: string | null, oldVal: string | null): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    connectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    disconnectedCallback(): void;
    handleNylasFormDropdownChanged(event: CustomEvent): Promise<void>;
    registerCallback(): Promise<void>;
    getState(): Promise<"loading" | "error" | "loaded">;
    setState(state: 'loading' | 'loaded' | 'error'): Promise<void>;
    setError(error: {
        message: string;
        type: NotificationType;
        category: ErrorCategory;
        title: string;
    }): Promise<void>;
    hideDeleteConfirmation(): Promise<void>;
    hideEditButtonLoading(): Promise<void>;
    showErrorNotification(error: {
        message: string;
        type: NotificationType | undefined;
        category: ErrorCategory | undefined;
        title: string;
    }): void;
    closeModal(e: Event): void;
    handleConfirmDeleteButtonClicked(e: Event): void;
    private getDurationString;
    getActionLabelHTML(action: string): any;
    previousPageClickedHandler(): void;
    nextPageClickedHandler(): void;
    render(): any;
}
