import { EventEmitter } from '../../../stencil-public-runtime';
import { Configuration } from '@nylas/core';
import { LANGUAGE_CODE } from "../../../common/constants";
export declare class NylasPageName {
    host: HTMLNylasPageNameElement;
    selectedConfiguration?: Configuration;
    name: string;
    pageName?: string;
    showToggle: boolean;
    isOpen: boolean;
    required: boolean;
    selectedLanguage?: LANGUAGE_CODE;
    requirePageName: boolean;
    internals: ElementInternals;
    currentPageName: string;
    pageNameErrorMessage: string;
    valueChanged: EventEmitter<{
        value: string;
        name: string;
        valueChanged?: (event: CustomEvent<{
            value: string;
            name: string;
        }>) => void;
    }>;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    componentWillUpdate(): void;
    componentDidUpdate(): void;
    componentWillRender(): void;
    componentDidRender(): void;
    elementNameChangedHandler(newValue: string): void;
    selectedConfigurationChangedHandler(newValue: Configuration): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    get isInternalsAvailable(): boolean;
    nylasFormInputChangeHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): Promise<void>;
    toggleDrawer(): void;
    render(): any;
}
