import { AdditionalParticipant, Configuration } from '@nylas/core';
import { EventEmitter } from '../../../stencil-public-runtime';
import { LANGUAGE_CODE } from "../../../common/constants";
export declare class NylasSchedulingMethod {
    host: HTMLNylasSchedulingMethodElement;
    selectedConfiguration?: Configuration;
    name: string;
    participantOptions?: AdditionalParticipant[];
    readOnly: boolean;
    selectedLanguage?: LANGUAGE_CODE;
    showSubTitle: boolean;
    internals: ElementInternals;
    selectedBookingType: string;
    valueChanged: EventEmitter<{
        value: string;
        name: string;
        valueChanged?: (event: CustomEvent<{
            value: string;
            name: string;
        }>) => void;
    }>;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    componentWillUpdate(): void;
    componentDidUpdate(): void;
    componentWillRender(): void;
    componentDidRender(): void;
    elementNameChangedHandler(newValue: string): void;
    selectedLanguageChangedHandler(newVal: LANGUAGE_CODE, oldVal: LANGUAGE_CODE): void;
    selectedConfigurationChangedHandler(newVal: Configuration, _oldVal: Configuration): void;
    nylasFormDropdownChangedHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): void;
    render(): any;
}
