import { EventEmitter } from '../../../stencil-public-runtime';
import { NylasEvent, NylasSchedulerErrorResponse } from '../../..';
import { ConfigSettings } from "../../../stores/scheduler-store";
import { ThemeConfig } from '@nylas/core';
export declare class NylasConfirmedEventCard {
    private host;
    readonly configSettings?: ConfigSettings;
    readonly themeConfig?: any;
    readonly confirmedEventInfo: Partial<NylasEvent>;
    isClosing: boolean;
    readonly closeConfirmEventCardClicked: EventEmitter<{
        errorHandler?: (error: NylasSchedulerErrorResponse) => void;
    }>;
    readonly confirmedEventCardError: EventEmitter<NylasSchedulerErrorResponse>;
    themeConfigChanged(newThemeConfig: ThemeConfig): void;
    connectedCallback(): void;
    componentWillLoad(): Promise<void>;
    componentDidLoad(): Promise<void>;
    disconnectedCallback(): void;
    applyThemeConfig(themeConfig?: ThemeConfig): void;
    private handleCloseClicked;
    render(): any;
}
