import { EventEmitter } from '../../../stencil-public-runtime';
import type { NylasSchedulerBookingData } from "../../../common/types";
import { ThemeConfig } from '@nylas/core';
export declare class NylasLocaleSwitch {
    private timezoneRef?;
    private languageRef?;
    private host;
    readonly themeConfig?: any;
    readonly bookingInfo?: NylasSchedulerBookingData;
    selectedTimezone: string;
    selectedLanguage: string;
    searchPlaceholder: string;
    timezoneChanged: EventEmitter<string>;
    languageChanged: EventEmitter<string>;
    themeConfigChanged(newThemeConfig: ThemeConfig): void;
    bookingInfoChangedHandler(newValue: NylasSchedulerBookingData | undefined): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    applyThemeConfig(themeConfig?: ThemeConfig): void;
    private changeTimezone;
    private changeLanguage;
    nylasFormDropdownChangedHandler(event: CustomEvent<{
        value: string;
        name: string;
    }>): void;
    getTimezoneLabelHTML(timezone: string): any;
    render(): any;
}
