import { EventEmitter } from '../../../stencil-public-runtime';
import { ConfigSettings } from "../../../stores/scheduler-store";
import { NylasSchedulerErrorResponse, ThemeConfig } from '@nylas/core';
export declare class NylasOrganizerConfirmationCard {
    host: HTMLNylasOrganizerConfirmationCardElement;
    readonly configSettings?: ConfigSettings;
    readonly isLoading?: boolean;
    readonly themeConfig?: any;
    readonly organizerConfirmationBookingId?: string;
    readonly selectedLanguage: string;
    action: 'confirm' | 'reject' | null;
    readonly rejectBookingButtonClicked: EventEmitter<{
        bookingId: string;
        host: HTMLNylasOrganizerConfirmationCardElement;
    }>;
    readonly confirmBookingButtonClicked: EventEmitter<{
        bookingId: string;
        host: HTMLNylasOrganizerConfirmationCardElement;
        errorHandler?: (error: NylasSchedulerErrorResponse) => void;
    }>;
    readonly confirmBookingError: EventEmitter<NylasSchedulerErrorResponse>;
    themeConfigChanged(newThemeConfig: ThemeConfig): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): Promise<void>;
    componentDidLoad(): Promise<void>;
    applyThemeConfig(themeConfig?: ThemeConfig): void;
    private handleConfirmBookingButtonClicked;
    private handleRejectBookingButtonClicked;
    resetAction(): Promise<void>;
    render(): any;
}
