import { EventEmitter } from '../../../stencil-public-runtime';
import { AvailabilityTimeslot } from "../../../stores/scheduler-store";
import type { ThemeConfig, Timeslot } from '@nylas/core';
export declare class NylasTimeslotPicker {
    private host;
    readonly availability?: AvailabilityTimeslot[];
    readonly isLoading?: boolean;
    readonly themeConfig?: any;
    readonly selectedTimeslot?: Timeslot;
    readonly selectedTimezone: string;
    readonly selectedDate?: Date;
    selectedLanguage?: string;
    hour12?: boolean;
    readonly timeslotSelected: EventEmitter<Timeslot>;
    readonly timeslotConfirmed: EventEmitter<{
        timeslot: Timeslot;
        host: HTMLNylasTimeslotPickerElement;
    }>;
    readonly validateTimeslotError: EventEmitter<{
        error: string;
        type: 'error' | 'info';
    }>;
    times: AvailabilityTimeslot[];
    hoveredTimeslotIndex?: number;
    selectedTimeslotIndex?: string;
    selectedLanguageChanged(newLanguage: string): void;
    selectedDateChanged(newVal: Date | null | undefined): void;
    availabilityChanged(newVal: AvailabilityTimeslot[] | undefined): void;
    themeConfigChanged(newThemeConfig: ThemeConfig): void;
    connectedCallback(): void;
    disconnectedCallback(): void;
    componentWillLoad(): Promise<void>;
    componentDidLoad(): Promise<void>;
    applyThemeConfig(themeConfig?: ThemeConfig): void;
    private getTimeslotId;
    private onClickSelectTime;
    private handleConfirmedTimeslot;
    emitValidateTimeslotError(error: string, type: 'error' | 'info'): Promise<void>;
    private handleMouseEnter;
    private handleMouseLeave;
    private getTimeSlotLabel;
    render(): any;
}
