import { NylasAuthType } from '@nylas/core';
import { NylasAuthStoreType } from "../stores/auth-store";
import { NylasSchedulerStoreType } from "../stores/scheduler-store";
import { NylasAuthConnector } from './shared/api/auth';
import { NylaSchedulerAPIConnector } from './shared/api/scheduler';
import { NylasSchedulerConfigStoreType } from "../stores/scheduler-config-store";
import { NylasSchedulerConfigAPIConnector } from './shared/api/scheduler-config';
export interface BaseNylasConnectorInterface {
    resetStores(): void;
    init(): void;
}
export interface NylasAuthConnectorInterface extends BaseNylasConnectorInterface {
    nylasAuth: NylasAuthType;
    nylasAuthStore: NylasAuthStoreType;
    get authStore(): NylasAuthStoreType;
    get auth(): NylasAuthConnector;
    logout(): Promise<void>;
}
export interface NylasSchedulerConnectorInterface extends BaseNylasConnectorInterface {
    schedulerAPIURL: string;
    nylasSchedulerStore: NylasSchedulerStoreType;
    get schedulerStore(): NylasSchedulerStoreType;
    get scheduler(): NylaSchedulerAPIConnector;
}
export interface NylasSchedulerConfigConnectorInterface extends BaseNylasConnectorInterface {
    nylasSchedulerConfigStore: NylasSchedulerConfigStoreType;
    get schedulerConfigStore(): NylasSchedulerConfigStoreType;
    get schedulerConfig(): NylasSchedulerConfigAPIConnector;
}
export interface NylasConnectorInterface extends NylasAuthConnectorInterface, NylasSchedulerConnectorInterface {
}
