import { NylasAuthType } from '@nylas/core';
import { NylasAuthStoreType } from "../../../stores/auth-store";
import { TokenInfo } from '@nylas/core/dist/auth';
export declare class NylasAuthConnector {
    private nylasAuth;
    private nylasAuthStore;
    constructor(nylasAuth: NylasAuthType, nylasAuthStore: NylasAuthStoreType);
    validateSession(): Promise<void>;
    isAuthenticated(): Promise<boolean>;
    getTokenInfo(): Promise<TokenInfo | null>;
    isAccessTokenValid(): Promise<boolean>;
    logout(): Promise<void>;
    getHostedAuthRedirectURL(scopes?: string[], email?: string, provider?: string): Promise<string>;
    manageHostedAuthCodeExchange(currentUrl: string): Promise<TokenInfo | null>;
}
